C========================================================================
C c_read_recount.f
C------------------------------------------------------------------------
	SUBROUTINE c_read_recount ( filename )
C
C Abstract:
C	This reads the "rec_count" file into the rec_count structure.
C	It is to be called at the start of preprocessing.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	character*(*) filename

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/rec_count'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	filename	I		Name of record count file
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	rec_count	O		record counts of BIDR files
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	Reads record count file into common block rec_count.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	INTEGER*4	lun, i
	INTEGER*4	status
	integer copen,cread,cclose,ch_fd,n_bytes,bytes,dk_ptr
	integer*4 vax2suni4


C Start:

c	Modified by Lawrence Chen 1/5/94

c	call get_lun( lun )
	write (*,*) 'Reading ', filename

c	OPEN(	unit = lun, recordtype='fixed',
c	2	file = filename, recl=22,
c	3	form = 'unformatted',
c	4	status = 'unknown',
c	5	iostat = status )

c	IF ( status .NE. 0 ) THEN
c		TYPE *, 'C_READ_RECOUNT:'
c		TYPE *, '   File open failed, status = ', status
c
c		CALL exit
c	END IF

c	read ( lun ) (rec_count(i),i=1,52)

	bytes = 88
	dk_ptr = 0
	ch_fd = copen(filename)
	n_bytes = cread(ch_fd, rec_count, bytes, dk_ptr)
	if (n_bytes .ne. bytes) then
	   type *,'READ ERROR ', n_bytes,bytes,filename
	endif
c	cclose(ch_fd)

C Zero out non-meaningful counts:

	REC_COUNT_FILE_13 = 0
	REC_COUNT_FILE_14 = 0
	REC_COUNT_FILE_15 = 0
	REC_COUNT_FILE_16 = 0
	REC_COUNT_FILE_17 = 0
	REC_COUNT_FILE_18 = 0
	REC_COUNT_FILE_19 = 0

	REC_COUNT_FILE_13_BLOCKS = 0
	REC_COUNT_FILE_15_BLOCKS = 0

C Convert integer*4 data from VAX to SUN format
c comment out 3/10/94 
c	REC_COUNT_FILE_01 = vax2suni4(REC_COUNT_FILE_01)
c	REC_COUNT_FILE_02 = vax2suni4(REC_COUNT_FILE_02)
c	REC_COUNT_FILE_03 = vax2suni4(REC_COUNT_FILE_03)
c	REC_COUNT_FILE_04 = vax2suni4(REC_COUNT_FILE_04)
c	REC_COUNT_FILE_05 = vax2suni4(REC_COUNT_FILE_05)
c	REC_COUNT_FILE_06 = vax2suni4(REC_COUNT_FILE_06)
c	REC_COUNT_FILE_07 = vax2suni4(REC_COUNT_FILE_07)
c	REC_COUNT_FILE_08 = vax2suni4(REC_COUNT_FILE_08)
c	REC_COUNT_FILE_09 = vax2suni4(REC_COUNT_FILE_09)
c	REC_COUNT_FILE_10 = vax2suni4(REC_COUNT_FILE_10)
c	REC_COUNT_FILE_11 = vax2suni4(REC_COUNT_FILE_11)
c	REC_COUNT_FILE_12 = vax2suni4(REC_COUNT_FILE_12)
c	REC_COUNT_FILE_20 = vax2suni4(REC_COUNT_FILE_20)



D	TYPE *, 'REC_COUNT_FILE_01 = ', REC_COUNT_FILE_01
D	TYPE *, 'REC_COUNT_FILE_02 = ', REC_COUNT_FILE_02
D	TYPE *, 'REC_COUNT_FILE_03 = ', REC_COUNT_FILE_03
D	TYPE *, 'REC_COUNT_FILE_04 = ', REC_COUNT_FILE_04
D	TYPE *, 'REC_COUNT_FILE_05 = ', REC_COUNT_FILE_05
D	TYPE *, 'REC_COUNT_FILE_06 = ', REC_COUNT_FILE_06
D	TYPE *, 'REC_COUNT_FILE_07 = ', REC_COUNT_FILE_07
D	TYPE *, 'REC_COUNT_FILE_08 = ', REC_COUNT_FILE_08
D	TYPE *, 'REC_COUNT_FILE_09 = ', REC_COUNT_FILE_09
D	TYPE *, 'REC_COUNT_FILE_10 = ', REC_COUNT_FILE_10
D	TYPE *, 'REC_COUNT_FILE_11 = ', REC_COUNT_FILE_11
D	TYPE *, 'REC_COUNT_FILE_12 = ', REC_COUNT_FILE_12
D	TYPE *, 'REC_COUNT_FILE_13 = ', REC_COUNT_FILE_13
D	TYPE *, 'REC_COUNT_FILE_14 = ', REC_COUNT_FILE_14
D	TYPE *, 'REC_COUNT_FILE_15 = ', REC_COUNT_FILE_15
D	TYPE *, 'REC_COUNT_FILE_16 = ', REC_COUNT_FILE_16
D	TYPE *, 'REC_COUNT_FILE_17 = ', REC_COUNT_FILE_17
D	TYPE *, 'REC_COUNT_FILE_18 = ', REC_COUNT_FILE_18
D	TYPE *, 'REC_COUNT_FILE_19 = ', REC_COUNT_FILE_19
D	TYPE *, 'REC_COUNT_FILE_20 = ', REC_COUNT_FILE_20
D	TYPE *, 'REC_COUNT_FILE_13_BLOCKS = ',
D	2 REC_COUNT_FILE_13_BLOCKS
D	TYPE *, 'REC_COUNT_FILE_15_BLOCKS = ',
D	2 REC_COUNT_FILE_15_BLOCKS


C Done:

c	CLOSE ( lun )
c	call free_lun( lun )


D	TYPE *, 'filename =  *', filename, '*'


	RETURN
	END
