c***************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project:	Magellan
c	Task:		Correlator, Alliant Fortran Version.
c---------------------------------------------------------------
c	Module Name:	determine_proj.f
c			
c		        Determine the oblique and sinusoidal projection.
c
c	Input:		1). Per-orbit parameters
c
c	Output:		1). Starting burst and ending burst number.
c
c---------------------------------------------------------------------
c
c	03/10/94A.Chu Make comments.
c	5/25/92	A.Chu Initial code.
c*********************************************************************
	
	subroutine determine_proj(oblique_proj,sin_proj,oblique_flag)
	
	implicit none
	include '../../../inc/keyvar.inc'
	include '../../../inc/pp.inc'
	include '../../../inc/overlay.inc'
	include '../../../inc/constant.inc'
	include '../../../inc/corr_buffer.inc'

c	PASSING IN PARAMETERS

	logical	oblique_flag
	
c	PASSING OUT PARAMETERS
	
	logical	oblique_proj,sin_proj	

c	LOCAL VARIABLE

	integer special,num_burst


	if ( oblique_flag .eq. .true.) then

c	------------
c	DETERMINE OBLIQUE-SIN PROJECTION 
c	------------

	if (po_oblique_start_burst .gt. 0  .and.  
     *      po_oblique_end_burst .gt. po_oblique_start_burst) then
	    
	    oblique_proj = .true.
	    projection = 2 			!2=oblique sin.
	    start_burst_num = po_oblique_start_burst
	    end_burst_num = po_oblique_end_burst
c	Lawrenece Chen
	    type *,'start_burst_num',start_burst_num
	    type *,'end_burst_num',end_burst_num
	    type *,' projection: OBLIQUE sin'
	else

	    oblique_proj = .false.

	    type *,' *** OBLIQUE sin proection Out of range ***'

	endif

	    type *,'Oblique burst ragne:',po_oblique_start_burst,
     *                                    po_oblique_end_burst

	type *,' Enter the desired burst flag:(yes=1,no=0,skip=2)'
	accept *,special
	type *,special

	current_burst = start_burst_num

	if ( special .eq. 1) then
	   type *,' Enter the desired start burst number:'
	   accept *,current_burst 
	   type *,' Desired burst:',current_burst 
	   type *,' Enter total bursts to be processed:'
	   accept *, num_burst
	   type *,num_burst
	   end_burst_num = current_burst + num_burst - 1
	   type *,' The desired burst start at :',current_burst
	   type *,' burst end at :',end_burst_num
	else if (special .eq. 2) then
	    oblique_proj = .false.
	endif

	else 		! sin proj.
c       ----------------
c	DETERMINE SINUSOIDAL PROJECTION 
c	------------

	if (po_sin_start_burst .gt. 0  .and.  
     *      po_sin_end_burst .gt. 0) then
	    
	    sin_proj = .true.
	    projection = 1 			!1= sin.
	    start_burst_num = po_sin_start_burst
	    end_burst_num = po_sin_end_burst

	    type *,' projection: SIN'
	    
	else	    

	    sin_proj = .false.

	    type *,' *** SIN proection Out of range ***'

	endif

            type *,' Sin burst ragne:',po_sin_start_burst,
     *                                 po_sin_end_burst
	
	if (sin_proj .eq. .false. .and. oblique_proj 
     *  	                  .eq. .false.) then
	   type *,' No burst at all, indicated by po'
	   stop
	endif

	type *,' Enter the desired burst flag:(yes=1,no=0,skip=2)'
	accept *,special
	type *,special

	current_burst = start_burst_num

	if ( special .eq. 1) then
	   type *,' Enter the desired start burst number:'
	   accept *,current_burst 
	   type *,' Desired burst:',current_burst 
	   type *,' Enter total bursts to be processed:'
	   accept *, num_burst
	   type *,num_burst
	   end_burst_num = current_burst + num_burst - 1
	   type *,' The desired burst start at :',current_burst
	   type *,' burst end at :',end_burst_num
	else if (special .eq. 2) then
	    sin_proj = .false.
	endif

	endif

	return
	end
c---------------------- end of determine_proj.f --------------------------
