C========================================================================
C elevat_of_geos.f
C------------------------------------------------------------------------
	subroutine elevat_of_Geos(lat_g,lon_g,e_g)
C
C Abstract:
C	Computes the elevations for nine geometric reference points
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real lat_g(3,3), lon_g(3,3), e_g(3,3)

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	lat_g, lon_g	I		latitude & longitude of nine 
C					geometric reference points
C	e_g		O		elevations 
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	integer i, j

	do i=1,3
	do j=1,3

	call elevation(lat_g(i,j),lon_g(i,j),e_g(i,j))
d	type *, 'geo elevation= ', e_g(i,j)
	end do
	end do	

	return
	end
