/*  SPAWN_SAVE_BIDR  routine to create sub process to run SAVE_BIDR  */
#include <stdio.h>
char save_bidr_char[256];
FILE *save_bidr_fd;

int spawn_save_bidr_( bidr_dir, tape1, tape2, wait_flag )
char *bidr_dir, *tape1, *tape2;
int *wait_flag;

/*  Inputs:

	BIDR_DIR:  A string containing the directory path which contains
		the BIDR files.  The name of the actual directory containing
		the files must be of the form T_NNNNN_VV where T is the 
		data type, NNNNN is the decimal of the orbit number with
		leading 0s, and VV is the version number with a leading 0.

	TAPE1, TAPE2:  Strings containing the names of the input tape
			drive(s).  If only one drive is used, set TAPE2
			to zero (0).

	WAIT_FLAG:  0 = do not wait for the subprocess to finish
			(asynchronous).  A call to WAIT_SAVE_BIDR
			must be issued to wait for the subprocess
			to complete and return a status.
		    1 = wait for the subprocess to finish (synchronous).
			routine will return status from subprocess.

	The routine will return a 1 if the subprocess was spawned
	successfully (asynchronous) or if the subprocess completed
	and no errors were encountered (synchronous).
	A -1 will be returned on any error.
*/
{
FILE *popen();

/*  Build the command string  */

strcpy( save_bidr_char, "save_bidr " );
strcat( save_bidr_char, bidr_dir );
strcat( save_bidr_char, " ");
strcat( save_bidr_char, tape1 );
strcat( save_bidr_char, " ");
strcat( save_bidr_char, tape2 );
printf("SPAWN_SAVE_BIDR command to popen:\n %s]\n", save_bidr_char );

save_bidr_fd = popen( save_bidr_char, "r" );
if( save_bidr_fd != NULL ){
    printf("SPAWN_SAVE_BIDR error in POPEN: %d\n", save_bidr_fd );
    return( (int) save_bidr_fd );
}

if( *wait_flag==0 ) return( 1 );

return( wait_save_bidr_() );

}

/*  WAIT_SAVE_BIDR - routine to wait for a subprocess spawned to write a
BIDR file set from disk to tape  */

#include <stdio.h>

char save_bidr_char[256];
FILE *save_bidr_fd;

int wait_save_bidr_( )

/*  Outputs:

    The routine returns a 1 if all is well, and a -1 otherwise.
*/
{
char *lchar;

lchar = save_bidr_char + 128;
while( fgets( save_bidr_char, 120, save_bidr_fd ) != NULL ){
    printf(">>%s");
    strcpy( lchar, save_bidr_char );
}
if( strncmp( "SAVE_BIDR Normal exit", lchar, 21 ) == 0 ) return( 1 );
else printf("WAIT_SAVE_BIDR message from SAVE_BIDR: \n**%s**\n", lchar );
return( -1 );
}
