C========================================================================
C update_cs_status.f
C------------------------------------------------------------------------
	SUBROUTINE update_cs_status( recnum )
C
C Abstract:
C	Writes a new value of "cs_stat.rec5.recnum" to the
C	CS_status file.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	INTEGER*4	recnum

        character*8 date
        common / proc_date / date

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/cold_stat'
	include '../../../inc/pc'
        include '../../../inc/b_head'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	recnum		I		record number
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	see include file listing
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	proc_date	I		processing date	
C
C Files:
C	Updates cold sky status file
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:
C
	INTEGER*4	runnum
	INTEGER*4	lun
	INTEGER*4	status

C Start:

D	TYPE *, 'UPDATE_CS_STATUS:'

	call get_lun( lun )

	write (*,*) 'Updating ', pc_file_param_cs_status
	open  ( unit=lun,	
	1 	FILE = PC_FILE_PARAM_CS_STATUS, 
	2	access = 'sequential',
	3	form = 'unformatted',
	4	recordtype = 'variable',
	6	status = 'old',
	7	iostat=status )


C Read in the Cold Sky Status file:

	READ ( LUN ) COLDS_REC1
	READ ( LUN ) COLDS_REC2
	READ ( lun )
	READ ( LUN ) COLDS_REC4
	READ ( LUN ) COLDS_REC5


C Update record 1 (date):

	COLDS_REC1_DATE = DATE


C Update record 2 (time):

	COLDS_REC2_TIME = B_HEAD_HOUR // ':' //
     .                      B_HEAD_MIN  // ':' //
     .                      B_HEAD_SEC


C Update record 4 (# of runs to date):

	READ (COLDS_REC4_RUNNUM, '(I3)') RUNNUM
	runnum = runnum + 1
	WRITE (COLDS_REC4_RUNNUM, '(I3)') RUNNUM


C Update record 5 (# of records to date):

D	TYPE *, 'recnum (binary):', recnum
	WRITE (COLDS_REC5_RECNUM, '(I5)') RECNUM


C Write the file back out:

	REWIND ( lun )

	WRITE ( LUN ) COLDS_REC1
	WRITE ( LUN ) COLDS_REC2
	WRITE ( lun )
	WRITE ( LUN ) COLDS_REC4
	WRITE ( LUN ) COLDS_REC5

        CLOSE ( lun )

	CALL free_lun (lun)


C Done:

	RETURN
	END
