c	/clw/

      implicit none

      integer maxburst, sfdulen
      parameter ( maxburst = 8600)

      integer maxrim 		! maximum number of rim ticks per orbit
      parameter ( maxrim = 37 )

      byte buf(1024)
      character*1024 cbuf
      equivalence ( buf, cbuf )

      character*40 fname
      integer initdk, chan, lun

      integer nb, nbyte, iblk, os, i, j, n, k

      byte tags(7,maxburst)
      character*7 ctags(maxburst)
      equivalence ( tags, ctags )

      integer mod210(maxburst), rim(maxburst), 
     .	      mod91(maxburst), rti(maxburst)
      real*8  cr_sclk(maxburst)

      character*20 orbit
      logical error, correct
      real delta1, delta2

      write (*,'(1x,a,$)') 'Enter SAB data file name: '
      read (*,'(a)') fname

      lun = 1
      chan = initdk ( lun, fname )
      iblk = 1
      call dkread ( chan, buf, 1024, iblk )
      i = index(cbuf,'ORBIT_NUMBER=')
      orbit = cbuf(i:i+19)
      read (cbuf(13:20), '(i)') sfdulen
      sfdulen = sfdulen + 20
      nb = 0
      os = sfdulen
      do while ( cbuf(os+1:os+4) .eq. 'NJPL' ) 
         nb = nb + 1
         os = os + 317
	 ctags(nb) = cbuf(os+1:os+7)
         call sclk52( buf(os+1), mod210(nb), rim(nb), 
     .			mod91(nb), rti(nb), cr_sclk(nb) )
    	 nbyte = nb * 338 + sfdulen
         iblk = ( nbyte / 512 ) + 1
         os = mod ( nbyte, 512)
         call dkread ( chan, buf, 1024, iblk )
    	 
      enddo

      call closedk( lun, chan )
  
      write (*,*) '                BURSTS WITH SCLK OUT OF SEQUENCE'
      write (*,*) orbit, ' Number of bursts= ', nb
      n = 1			! index of last good burst
      correct = 'true'
      do i = 1, nb

c check for range of values of time tags

    	 error = rti(i) .lt. 0 .or. rti(i) .gt. 9 .or.
     .	      mod210(i) .lt. 0 .or. mod210(i) .gt. 2100 .or. 
     .        mod91(i) .lt. 0 .or. mod91(i) .gt. 90 .or.
     .	      ((i .gt. 1) .and. (abs(rim(i)-rim(n)) .gt. maxrim))

c check for time going backward 

    	 if ( .not. error ) then
    		error = (rim(i) .eq. rim(n) .and. 
     .			  mod91(i) .eq. mod91(n) .and.
     .			  mod210(i) .lt. mod210(n) ) .or.
     .			  (rim(i) .eq. rim(n) .and. 
     .			  mod91(i) .lt. mod91(n)) 
     .			  .or. (cr_sclk(i) .lt. cr_sclk(n) )
    	 endif

c check for false alarm of data gap

    	 if ( .not. error ) then

    	 delta1 = cr_sclk(i) - cr_sclk(n)
    	 delta2 = cr_sclk(min(i+1,nb)) - cr_sclk(n)
    	 error = delta1 .gt. 0 .and. delta2 .gt. 0 .and.
     .    		     delta1 .gt. delta2

    	 endif

    	 if ( error ) then
       
	 correct = 'false'
	 do k= i-3, i-1
            if (k .gt. 0) then
              write (*,'(1x,i5,2x,8z2.2,i6,i8,2i4,f18.5,a)') 
     .             k,(tags(j,k),j=os,os+7), 
     .             mod210(k), rim(k), mod91(k), rti(k), 
     .		   cr_sclk(k)
            endif
         enddo

	    write (*,'(1x,i5,2x,8z2.2,i6,i8,2i4,f18.5,a)') 
     .             i,(tags(j,i),j=os,os+7), 
     .             mod210(i), rim(i), mod91(i), rti(i), 
     .		   cr_sclk(i), '** Error **'

	 do k= i+1, i+3
            if (k .lt. nb) then
	       write (*,'(1x,i5,2x,8z2.2,i6,i8,2i4,f18.5,a)') 
     .             k,(tags(j,k),j=os,os+7), 
     .             mod210(k), rim(k), mod91(k), rti(k), 
     .		   cr_sclk(k)
            endif
	 enddo
         write (*,*)

         else

c         write (*,'(1x,i5,2x,8z2.2,i6,i8,2i4,f18.5)') 
c     .             i,(tags(j,i),j=os,os+7), 
c     .             mod210(i), rim(i), mod91(i), rti(i), 
c     .		   cr_sclk(i), '** Error **' 
         n = i

        endif
      enddo

      if (correct.eq.'true') then
	  write (*,*) '  ******************************'
	  write (*,*) '         NO TIME TAGS ERROR'
	  write (*,*) '  ******************************'
      endif
      end

C******************************************************************************
C* This routine decodes 52-bit spacecraft clock
C*	The data has 7 bytes in four data fields
C*	-	MOD210_COUNT
C*	-	RIM_COUNT
C*	-	MOD91_COUNT
C*	-	RTI_COUNT
C******************************************************************************
C*
	SUBROUTINE SCLK52 (IN_BYTES,MOD210_COUNT,RIM_COUNT,
     .				MOD91_COUNT,RTI_COUNT,CR_SCLK)

	BYTE IN_BYTES (7)
	INTEGER MOD210_COUNT, RIM_COUNT
	INTEGER MOD91_COUNT, RTI_COUNT	
	REAL*8    CR_SCLK

	MOD210_COUNT = JISHFT ( JZEXT(IN_BYTES(1)) , 8 ) .OR.
     .			 	JZEXT(IN_BYTES(2))

	RIM_COUNT = JISHFT ( JZEXT(IN_BYTES(3)), 16 ) .OR.
     .		    JISHFT ( JZEXT(IN_BYTES(4)), 8  ) .OR.
     .		    	     JZEXT(IN_BYTES(5))

	MOD91_COUNT = JZEXT (IN_BYTES (6))
	RTI_COUNT = JZEXT (IN_BYTES (7))

	CR_SCLK = RIM_COUNT * 182.0D0/3.0D0 +
     .		  MOD91_COUNT * 2.0D0 /3.0D0 +
     .		  (RTI_COUNT+1) / 15.0D0 +
     .		  (MOD210_COUNT) / (15.0D0*210.0D0) - .00015875D0

	
	RETURN
	END
