/*  Routine to rewind (and unload) a tape and put it offline

  Functional Description:

  Issue the command to rewind and unload the tape drive

*/

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/mtio.h>
extern int errno;

#include "tape_buff.h"

int close_tape_volume( tu, flag )
int tu, flag;
{
struct mtop mt_com;
int status;

/*  printf("CLOSE_TAPE_VOLUME...read(0)/write(1) flag=%d\n", flag);  */

if( flag==1 ){		/*  writing a tape  */

/*	EOV not needed for single volume tapes

    strcpy( buffer, "EOV1" );
    strcat( buffer, tv_id );
    for( status=10; status<37; status++ ) buffer[status] = 32;
    buffer[status] = 0;
    strcat( buffer, owner_id );
    for( status=51; status<79; status++ ) buffer[status] = 32;
    buffer[status] = '3';
    if( (status=write( tu, buffer, 80 ))!=80 ){
	printf("CLOSE_TAPE_VOLUME error writing EOV to tape:  %d\n", errno );
	perror("CLOSE_TAPE_VOLUME error:");
	return( -errno );
    }
*/
    mt_com.mt_op = MTWEOF;
    mt_com.mt_count = 1;
    status = ioctl( tu, MTIOCTOP, &mt_com );
    if( status==-1 ){
	printf("CLOSE_TAPE_VOLUME error writing EOF 1: %d\n", errno );
	perror("CLOSE_TAPE_VOLUME error:");
    }

/*	Write only one EOF after the EOF of previous file
    status = ioctl( tu, MTIOCTOP, &mt_com );
    if( status==-1 )
	printf("CLOSE_TAPE_VOLUME error writing EOF 2: %d\n", errno );
*/
}				/*  end writing EOV  */

mt_com.mt_op = MTOFFL;		/*  Rewind the tape  */
mt_com.mt_count = 1;
status = ioctl( tu, MTIOCTOP, &mt_com );
if( status==-1 ){
    printf("CLOSE_TAPE_VOLUME tape rewind/unload error: %d\n", errno );
    perror("CLOSE_TAPE_VOLUME error:");
/*    exit( -errno );  */
}

return( 1 );
}
