/* $Id: xbutt.c,v 1.1 1994/02/15 16:44:16 quyen Exp $ */
/* 
 * xbutt.c - regular buttons
 *
 * done by quyen dinh nguyen
 * %W% %G%
 */

#include "xinclude.h"


/* define bitmaps for cboard50 */
#define cboard50_width 8
#define cboard50_height 8
static char cboard50_bits[] = {
   0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa};

static  Pixmap cboard50 = (Pixmap) NULL; /* 50% gray checkerboard */

/* bit map */
#define gray25_width 8
#define gray25_height 8
static char gray25_bits[] = {
   0x88, 0x22, 0x88, 0x22, 0x88, 0x22, 0x88, 0x22};

#define gray50_width 8
#define gray50_height 8
static char gray50_bits[] = {
   0x33, 0xcc, 0x33, 0xcc, 0x33, 0xcc, 0x33, 0xcc};




/********************************************/
void BUTTON_Create( but_pt,win,x,y,w,h,str,cfg,cbg,mono)
BUTTON   *but_pt;
Window   win;
int      x,y,w,h;
char     *str;
unsigned long cfg,cbg;
int      mono;
{
  but_pt->win   = win;
  but_pt->x = x; but_pt->y = y; but_pt->w = w; but_pt->h = h;
  but_pt->lit   = 0;
  but_pt->active = 1;
  but_pt->str   = str;
  but_pt->fg    = cfg;  but_pt->bg = cbg;
  but_pt->pix   = None;
  but_pt->pw    = but_pt->ph = 0;
  but_pt->fwidth = 3;
  but_pt->color  = mono;


  if ( !cboard50 ) 
     cboard50 = XCreatePixmapFromBitmapData ( dpy, rootW, cboard50_bits,
                       cboard50_width, cboard50_height, 1, 0, 1);
  /* Set the background */
  if ( !grayStip )
     grayStip = XCreatePixmapFromBitmapData( dpy, rootW, gray50_bits,
             gray50_width, gray50_height, 1, 0, 1);

  if ( !grayTile )
     grayTile = XCreatePixmapFromBitmapData( dpy, rootW, gray25_bits,
                gray25_width, gray25_height, infofg, infobg, dispDEEP);


}

/*********************************************/
void BUTTON_Redraw(but_pt)
BUTTON   *but_pt;
{
  int  i,win,x,y,w,h,r,x1,y1;
  
  win = but_pt->win;
  x = but_pt->x;  y = but_pt->y;   w = but_pt->w;  h = but_pt->h;
  r = but_pt->fwidth;

  if ( !but_pt->active) but_pt->lit = 0; 
  if ( but_pt->lit ){
      r -= 1;
      if (r < 0) r = 0;
  }

  if ( but_pt->color == 0 ) {
    XPoint tpts[10], bpts[10], ipts[5];
    /* set up 'ipts' */
    ipts[0].x = x+r;        ipts[0].y = y+r;         /* topleft */
    ipts[1].x = x+r;        ipts[1].y = y+h-r;       /* botleft */
    ipts[2].x = x+w-r;      ipts[2].y = y+h-r;       /* botright */
    ipts[3].x = x+w-r;      ipts[3].y = y+r;         /* topright */
    ipts[4].x = ipts[0].x;  ipts[4].y = ipts[0].y;   /* close path */

    /* top left polygon */
    tpts[0].x = x;            tpts[0].y = y;
    tpts[1].x = x;            tpts[1].y = y+h;
    tpts[2].x = ipts[1].x;    tpts[2].y = ipts[1].y;
    tpts[3].x = ipts[0].x;    tpts[3].y = ipts[0].y;
    tpts[4].x = ipts[3].x;    tpts[4].y = ipts[3].y;
    tpts[5].x = x+w;          tpts[5].y = y;
    tpts[6].x = x;            tpts[6].y = y;

    /* bot left polygon */
    bpts[0].x = x;            bpts[0].y = y+h;
    bpts[1].x = ipts[1].x;    bpts[1].y = ipts[1].y;
    bpts[2].x = ipts[2].x;    bpts[2].y = ipts[2].y;
    bpts[3].x = ipts[3].x;    bpts[3].y = ipts[3].y;
    bpts[4].x = x+w;          bpts[4].y = y;
    bpts[5].x = x+w;          bpts[5].y = y+h;
    bpts[6].x = x;            bpts[6].y = y+h;

    /* clear button and draw frame */
    XSetForeground( dpy, gc, but_pt->bg);
    XFillRectangle( dpy, win, gc, x, y, w, h);
    XSetForeground( dpy, gc, but_pt->fg);
    XDrawRectangle( dpy, win, gc, x, y, w, h);

    XSetForeground( dpy, gc, but_pt->fg);
    XSetFillStyle( dpy, gc, FillStippled);
    XSetStipple( dpy, gc, cboard50);
    XFillPolygon( dpy, win, gc, bpts, 7, Nonconvex, CoordModeOrigin);
    XSetFillStyle( dpy,gc,FillSolid);

    XSetForeground( dpy, gc, but_pt->fg);
    XDrawLines( dpy, win, gc, ipts, 5, CoordModeOrigin);  /* inset */

    XDrawLine( dpy, win, gc, x+1,   y+1,  ipts[0].x,ipts[0].y);
    XDrawLine( dpy, win, gc, x+1,   y+h-1,ipts[1].x,ipts[1].y);
    XDrawLine( dpy, win, gc, x+w-1, y+h-1,ipts[2].x,ipts[2].y);
    XDrawLine( dpy, win, gc, x+w-1, y+1,  ipts[3].x,ipts[3].y);

    if (but_pt->lit) {
      XDrawRectangle( dpy, win, gc, x+2, y+2, w-4, h-4);
      XDrawRectangle( dpy, win, gc, x+1, y+1, w-2, h-2);
    }

  } else {

  /* Draw the button with 4 different colors */
    XSetForeground ( dpy, gc, but_pt->bg);
    XFillRectangle ( dpy, win, gc, x+1, y+1, w-1, h-1);

    XSetForeground ( dpy, gc, hicol);
    for ( i=1; i<=r; i++){
       XDrawLine ( dpy, win, gc, x+i, y+i, x+w, y+i);
       XDrawLine ( dpy, win, gc, x+i, y+i, x+i, y+h);
    }

    XSetForeground ( dpy, gc, locol);
    for ( i=1; i<=r; i++){
       XDrawLine ( dpy, win, gc, x+i, y+h-i, x+w, y+h-i);
       XDrawLine ( dpy, win, gc, x+w-i, y+h, x+w-i, y+i);
    }

    XSetForeground ( dpy, gc, but_pt->fg);
    XDrawRectangle ( dpy, win, gc, x, y, w, h);

    if ( but_pt->lit )
       XDrawRectangle ( dpy, win, gc, x+1, y+1, w-2, h-2);
  }

  /* Draw the string at center of button */
  XSetForeground( dpy, gc, fg);

  if (but_pt->pix != None) {     /* draw pixmap centered in butt */
    x1 = x+(1+w-but_pt->pw)/2;
    y1 = y+(1+h-but_pt->ph)/2;

    XSetBackground( dpy, gc, bg);
    XCopyPlane( dpy, but_pt->pix, but_pt->win, gc, 
                     0,0,but_pt->pw,but_pt->ph, x1,y1, 1);
    if (!but_pt->active) 
          DimRect(but_pt->win, x1,y1, but_pt->pw, but_pt->ph, but_pt->bg);
  } else {                       /* draw string centered in butt */
    x1 = CENTERX(mfontstruct, x + w/2, but_pt->str);
    y1 = CENTERY(mfontstruct, y + h/2);

    if (but_pt->active) {
      XDrawString( dpy, but_pt->win, gc, 
                        x1,y1, but_pt->str, strlen(but_pt->str));
    } else {  /* stipple if not active */
      XSetFillStyle( dpy, gc, FillStippled);
      XSetStipple( dpy, gc, grayStip);
      XDrawString( dpy, but_pt->win, gc, 
                        x1,y1, but_pt->str, strlen(but_pt->str));
      XSetFillStyle( dpy, gc,FillSolid);
    }
  }

}

/************************************/
void BUTTONSetActive(but_pt,act)
BUTTON    *but_pt;
int       act;
{
   if( but_pt->active != act) {
       but_pt->active = act;
       BUTTON_Redraw(but_pt);
   }
}

/***********************************/
void DimRect(win, x, y, w, h, bg)
Window win;
int x,y,w,h;
u_long bg;
{
  /* stipple a rectangular region by drawing 'bg' where there's 1's
     in the stipple pattern */

  XSetFillStyle( dpy, gc, FillStippled);
  XSetStipple( dpy, gc, grayStip);
  XSetForeground( dpy, gc, bg);
  XFillRectangle( dpy, win, gc, x,y,w,h);
  XSetFillStyle( dpy, gc, FillSolid);
}

/********************************************/
void MSG_BUTTON_Create( but_pt,win,x,y,w,h,str,cfg,cbg)
MSG_BUTT   *but_pt;
Window   win;
int      x,y,w,h;
char     *str;
unsigned long cfg,cbg;
{
  but_pt->win   = win;
  but_pt->x = x; but_pt->y = y; but_pt->w = w; but_pt->h = h; 
  but_pt->str   = str;
  but_pt->active = 1;
  but_pt->fg    = cfg;  but_pt->bg = cbg;
}

/**************************************************/
void MSG_BUTTON_Redraw(msgbut_pt)
MSG_BUTT *msgbut_pt;
{
  int   x,y,w,h,x1,y1;
  x = msgbut_pt->x; y = msgbut_pt->y; 
  w = msgbut_pt->w; h = msgbut_pt->h;
  fg = msgbut_pt->fg; bg = msgbut_pt->bg; 

  /* Draw the string at center of button */
  XSetForeground( dpy, gc, bg);
  XFillRectangle( dpy, msgbut_pt->win, gc, x, y, w, h);
  XSetForeground( dpy, gc, fg);

  /* draw string centered in butt */
  x1 = CENTERX(mfontstruct, x + w/2, msgbut_pt->str);
  y1 = CENTERY(mfontstruct, y + h/2);


  if (msgbut_pt->active) {
     XDrawString( dpy, msgbut_pt->win, gc, 
                        x1,y1, msgbut_pt->str, strlen(msgbut_pt->str));
  } else {  /* stipple if not active */
      XSetFillStyle( dpy, gc, FillStippled);
      XSetStipple( dpy, gc, grayStip);
      XDrawString( dpy, msgbut_pt->win, gc, 
                        x1,y1, msgbut_pt->str, strlen(msgbut_pt->str));
      XSetFillStyle( dpy, gc,FillSolid);
  }
}


/* $Log: xbutt.c,v $
 * Revision 1.1  1994/02/15  16:44:16  quyen
 * Initial revision
 * */
