/* $Id: ximg.c,v 1.1 1994/02/15 16:44:16 quyen Exp $ */
/* 
 * done by quyen dinh nguyen
 * %W% %G%
 */

#include "xinclude.h"

/******************************************************************/
void Create_Image(img_name,geom,pwin,orig_pic,orig_x,orig_y,dispw_w,dispw_h,
                  ix_start,iy_start,image_title)
char *img_name,*geom,*image_title;
int  pwin;
byte *orig_pic;
int  orig_x,orig_y,dispw_w,dispw_h,ix_start,iy_start;
{
   int   x,y,w,h,mono;
   int   ix,iy,iw,ih;
   int   win_x,win_y,ctrl_width;
   float xcmp,ycmp;

   /* Calculate the image window size */
   ctrl_width = BUTTW + 8;
   win_x = dispw_w + ctrl_width;       win_y = dispw_h;

   imgW = CreateWindow(img_name,geom,pwin,win_x,win_y,
                       infofg,infobg);
   if(!imgW){
      printf("Can not create image window\n");
      exit(1);
   }

   /* Create the buttons */
   x=3; y=3; w=BUTTW; h=BUTTH;
   mono = 0;
   iw = BUTTW/2 ;

   /* Create the subimage buttons */
   BUTTON_Create(&img_but[B_SUBIMG_VIS],  imgW, x,y,w,h,
                    "Shrinking Win", infofg, infobg, mono);

   /* Create the subimage buttons */
   y += (BUTTH+2);
   BUTTON_Create(&img_but[B_SUBIMG_ZOOM],  imgW, x,y,w,h,
                    "Zoom Win", infofg, infobg, mono);

   /* Create the color buttons */
   y += (BUTTH+2);
   BUTTON_Create(&img_but[B_BLACKWHITE],  imgW, x,y,iw,h,
                    "BW", infofg, infobg, mono);
   BUTTON_Create(&img_but[B_COLOR],  imgW, x+iw,y,iw,h,
                    "Color", infofg, infobg, mono);

   /* Create the stretch buttons */
   y += (BUTTH+2);
   MSG_BUTTON_Create ( &msg_but[MSG_B_STR], imgW, x,y,w,h,
                     str_string, infofg, infobg);
   y += (BUTTH+2);
   BUTTON_Create(&img_but[B_LOW_DOWN],  imgW, x,y,w,h,
                    "Low <", infofg, infobg, mono);
   BUTTON_Create(&img_but[B_LOW_UP],    imgW, x,y+(BUTTH+2),w,h,
                    "Low >", infofg, infobg, mono);
   BUTTON_Create(&img_but[B_HIGH_DOWN], imgW, x,y+2*(BUTTH+2),w,h,
                    "High <", infofg, infobg, mono);
   BUTTON_Create(&img_but[B_HIGH_UP],   imgW, x,y+3*(BUTTH+2),w,h,
                    "High >", infofg, infobg, mono);


   /* Create the location button */
   y += 5*(BUTTH+2) ;
   BUTTON_Create(&img_but[IMG_UP], imgW, x,y,w,h,
                 "UP",infofg,infobg,mono);
   BUTTON_Create(&img_but[IMG_DOWN], imgW, x, y+BUTTH+2,      w, h,
                 "DOWN", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_LEFT], imgW, x, y+2*(BUTTH+2),  w, h,
                 "LEFT", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_RIGHT], imgW, x, y+3*(BUTTH+2), w, h,
                 "RIGHT", infofg, infobg, mono);
   MSG_BUTTON_Create ( &msg_but[MSG_LOC_STR], imgW, x,y+4*(BUTTH+2),w,h,
                     loc_string, infofg, infobg);

   /* Create the expand/compress buttons */ 
   y += 6*(BUTTH+2);
   BUTTON_Create(&img_but[IMG_QUIT], imgW, x,y,w,h,
                  "QUIT", infofg, infobg, mono);


   /* Create the scrolling button */
   y += 3*(BUTTH+2);
   ix = x; iy = y; ih = ((BUTTW/3)/2)*2 +1;

   BUTTON_Create(&img_but[IMG_SCR_LEFT], imgW,  ix,iy+ih,ih,ih,
                  "<", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_SCR_RIGHT], imgW, ix+2*ih,iy+ih,ih,ih,
                  ">", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_SCR_UP], imgW,    ix+ih,iy,ih,ih,
                  "A", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_SCR_DOWN], imgW,  ix+ih,iy+2*ih,ih,ih, 
                  "V", infofg, infobg, mono);
   BUTTON_Create(&img_but[IMG_SCR_CNTR], imgW,  ix+ih,iy+ih,ih,ih,
                  "O", infofg, infobg, mono);
   
   /* Create the message button for filename */
   x = ctrl_width;    y = 3;
   MSG_BUTTON_Create ( &msg_but[MSG_WIN_NAME], imgW, x,y,dispw_w,BUTTH,
                     image_title, infofg, infobg);

   /* Create the display window */
   y += (BUTTH + 2);
   xcmp = ycmp = 1.0;
   PICWIN_Create(&img_picwin,imgW,x,y,dispw_w,dispw_h,infofg,infobg,
                         orig_pic,orig_x,orig_y,xcmp,ycmp,
                         ix_start,iy_start);


}

/***********************************************/
void CheckLocationButton(picwin_pt)
PICWIN   *picwin_pt;
{
   XImage *a_image;
   int    disp_w,disp_h;

   a_image = picwin_pt->dpixmap;
   disp_w = a_image->width;   disp_h = a_image->height;

   if( picwin_pt->cur_x <= 0) {
            BUTTONSetActive(&img_but[IMG_LEFT], 0);
            BUTTONSetActive(&img_but[IMG_SCR_LEFT], 0);
   } else {
            BUTTONSetActive(&img_but[IMG_LEFT], 1);
            BUTTONSetActive(&img_but[IMG_SCR_LEFT], 1);
   }
   if( picwin_pt->cur_y <= 0) {
            BUTTONSetActive(&img_but[IMG_UP], 0);
            BUTTONSetActive(&img_but[IMG_SCR_UP], 0);
   } else {
            BUTTONSetActive(&img_but[IMG_UP], 1);
            BUTTONSetActive(&img_but[IMG_SCR_UP], 1);
   }
   if( (picwin_pt->cur_x+ disp_w) >= picwin_pt->owidth ) {
            BUTTONSetActive(&img_but[IMG_RIGHT], 0);
            BUTTONSetActive(&img_but[IMG_SCR_RIGHT], 0);
   } else {
            BUTTONSetActive(&img_but[IMG_RIGHT], 1);
            BUTTONSetActive(&img_but[IMG_SCR_RIGHT], 1);
   }
   if( (picwin_pt->cur_y+ disp_h) >= picwin_pt->oheight ) {
            BUTTONSetActive(&img_but[IMG_DOWN], 0);
            BUTTONSetActive(&img_but[IMG_SCR_DOWN], 0);
   } else {
            BUTTONSetActive(&img_but[IMG_DOWN], 1);
            BUTTONSetActive(&img_but[IMG_SCR_DOWN], 1);
   }

}

/***********************************************/
void ChangeColor()
{
  if(color_mode == 0 ){ /* current mode is blackwhite, change to color */
     min_color = low_str = 0;  max_color = high_str = 15;
     BUTTONSetActive(&img_but[B_BLACKWHITE], 1);
     BUTTONSetActive(&img_but[B_COLOR], 0);
     color_mode = 1;
  }else if(color_mode == 1){
     min_color = low_str = 0;  max_color = high_str = 255;
     BUTTONSetActive(&img_but[B_BLACKWHITE], 0);
     BUTTONSetActive(&img_but[B_COLOR], 1);
     color_mode = 0;
  }
  BUTTON_Redraw(&img_but[B_BLACKWHITE]);
  BUTTON_Redraw(&img_but[B_COLOR]);
  str_grey(low_str, high_str);
 
}

/***********************************************/
void RedrawImgWin(picwin_pt)
PICWIN   *picwin_pt;
{
  int i;
  for(i=0; i<N_IMG_BUTTS; i++) BUTTON_Redraw(&img_but[i]);

  for(i=0; i<N_MSG_BUTTS; i++) MSG_BUTTON_Redraw(&msg_but[i]);

  PICWIN_Redraw(picwin_pt);
  CheckLocationButton(picwin_pt);
}

/***********************************************/
int ClickImg_win(picwin_pt,ix,iy)
PICWIN *picwin_pt;
int     ix,iy;
{
   XImage  *a_image;
   a_image = picwin_pt->dpixmap;

   if(PTinRECT(ix,iy,picwin_pt->wloc_x, picwin_pt->wloc_y,
               a_image->width-1, a_image->height-1) ) return(1);
   return(0);

}


/***********************************************/
void RedrawLocString(picwin_pt,ix,iy,clear)
PICWIN *picwin_pt;
int    ix,iy,clear;
{
   int  img_x, img_y,img_val;
   XImage  *a_image;
   a_image = picwin_pt->dpixmap;

   if(clear == 0){
      sprintf(loc_string,"            "); 
      MSG_BUTTON_Redraw(&msg_but[MSG_LOC_STR]);
   } else {
      if( ClickImg_win(picwin_pt, ix, iy) ) {
         img_x = ix - picwin_pt->wloc_x + picwin_pt->cur_x;
         img_y = iy - picwin_pt->wloc_y + picwin_pt->cur_y;
         if( PTinRECT(img_x,img_y, 0, 0, picwin_pt->owidth-1, 
                        picwin_pt->oheight-1) ){
            img_val = *(picwin_pt->opic+img_y*picwin_pt->owidth+img_x);
            sprintf(loc_string,"(%4d,%4d)%3d",img_x,img_y,img_val);
            MSG_BUTTON_Redraw(&msg_but[MSG_LOC_STR]);
         }
      }
   }
}


/************************************************************/
int ClickImg_But(x,y)
int x,y;
{
   BUTTON *bp;
   int  i;
   for(i=0; i<N_IMG_BUTTS; i++){
      bp = &img_but[i];
      if(PTinRECT(x,y,bp->x,bp->y,bp->w,bp->h)) break;
   }
   if(i<N_IMG_BUTTS && bp->active == 1) return (i);
   return(-1);
}


/*************************************************************/
void MoveImg(picwin_pt,idir)
PICWIN  *picwin_pt;
int     idir;
{
  XImage  *a_image;
  int     ix,dispw_x,max_x,iy,dispw_y,max_y;

  ix = picwin_pt->cur_x;          iy = picwin_pt->cur_y;
  max_x = picwin_pt->owidth;      max_y = picwin_pt->oheight;

  a_image = picwin_pt->dpixmap;
  dispw_x = a_image->width;       dispw_y = a_image->height;


  if(idir == IMG_RIGHT) 
     ix = ( (ix + 2*dispw_x) <= max_x ) ? (ix + dispw_x) : (max_x - dispw_x) ;
  else if (idir == IMG_LEFT)
     ix = ( (ix - dispw_x) > 0) ? (ix - dispw_x) : 0 ;
  else if (idir == IMG_DOWN)
     iy = ( (iy + 2*dispw_y) <= max_y ) ? (iy + dispw_y) : (max_y - dispw_y) ;
  else if (idir == IMG_UP)
     iy = ( (iy - dispw_y) > 0 ) ? (iy - dispw_y) : 0 ;


  /* Update the pointer */
  picwin_pt->cur_x = ix;    picwin_pt->cur_y = iy;

  /* Reset the button active status */
  CheckLocationButton(picwin_pt);

  /* Redraw if necessary */
  PICWIN_Redraw(picwin_pt);

}
    
/*************************************************************/
void JumpImg(picwin_pt,x,y)
PICWIN  *picwin_pt;
int     x,y;
{
  XImage  *a_image;
  int     ix,dispw_x,max_x,iy,dispw_y,max_y;

  max_x = picwin_pt->owidth;        max_y = picwin_pt->oheight;
  
  a_image = picwin_pt->dpixmap;
  dispw_x = a_image->width;         dispw_y = a_image->height;


  /* From the center, calculate the top left corner location */
  x  = x  - dispw_x/2 ;            
  y  = y  - dispw_y/2 ;            


  /* Check of top left corner is in picture */
  ix = ( x  > 0) ? x : 0 ;
  ix = ( (ix + dispw_x) <= max_x ) ? ix  : (max_x - dispw_x) ;

  iy = ( y  > 0) ? y : 0 ;
  iy = ( (iy + dispw_y) <= max_y ) ? iy  : (max_y - dispw_y) ;

  /* Update the pointer */
  picwin_pt->cur_x = ix;    picwin_pt->cur_y = iy;

  /* Reset the button active status */
  CheckLocationButton(picwin_pt);

  /* Redraw if necessary */
  PICWIN_Redraw(picwin_pt);

}
    

/* $Log: ximg.c,v $
 * Revision 1.1  1994/02/15  16:44:16  quyen
 * Initial revision
 * */
