/* $Id: ximg2.c,v 1.1 1994/02/15 16:44:16 quyen Exp $ */
/* 
 * done by quyen dinh nguyen
 * %W% %G%
 */

#include "xinclude.h"

/******************************************************************/
int Create_subImage(sub_picwin,img_name,geom,pwin,orig_pic,orig_x,orig_y,
                     x_fac, y_fac, subdispw_w,subdispw_h, subimage_title,
                     msg_sub_but)
PICWIN   *sub_picwin;
char     *img_name,*geom,*subimage_title;
int      pwin;
byte     *orig_pic;
int      orig_x,orig_y;
int      subdispw_w, subdispw_h;
float    x_fac,y_fac;
MSG_BUTT *msg_sub_but;
{
   int   subW;
   int   x,y,w,h,mono;
   int   ix,iy,iw,ih;
   int   win_x,win_y,xcmp,ycmp;
   int   ix_start,iy_start;

   subW = CreateWindow(img_name,geom,pwin,subdispw_w,subdispw_h,
                       infofg,infobg);
   if(!subW){
      printf("Can not create sub image window\n");
      exit(1);
   }


   /* Create the message button for filename */
   x = 0;    y = 0;
   MSG_BUTTON_Create ( msg_sub_but, subW, 
                       x,y,subdispw_w,BUTTH,
                       subimage_title, infofg, infobg);

   /* Create the display window */
   y += BUTTH ;
   ix_start = iy_start = 0;
   PICWIN_Create ( sub_picwin,subW,x,y,subdispw_w,subdispw_h,
                   infofg,infobg, orig_pic,orig_x,orig_y,x_fac,y_fac,
                   ix_start,iy_start);
   return(subW);

}

/***********************************************/
void subImgBox(ImgW, img_win, WinUp)
int ImgW,*WinUp;
Window img_win;
{
   int vis;
   vis = !(*WinUp);
   if(vis) {
      XMapRaised(dpy, ImgW);
      XMapWindow(dpy, ImgW);          
      XMapWindow(dpy, img_win);
   } else {
      XUnmapWindow(dpy, ImgW);
      XUnmapWindow(dpy, img_win);
   }

   *WinUp = vis;
}


/***********************************************/
void RedrawsubImgWin(picwin_pt,msg_vec)
PICWIN   *picwin_pt;
MSG_BUTT *msg_vec;
{
  MSG_BUTTON_Redraw(msg_vec);

  PICWIN_Redraw(picwin_pt);
}


/***********************************************/
void GetLoc_subImgWin(picwin_pt,x,y, org_x,org_y)
PICWIN   *picwin_pt;
int   x,y,*org_x,*org_y;
{
  float  xfact,yfact;
  int    cur_x,cur_y;
  
  cur_x = picwin_pt->cur_x;   cur_y = picwin_pt->cur_y;
  xfact = picwin_pt->xcmp;    yfact = picwin_pt->ycmp;

  *org_x  = (int)( (float)(x - picwin_pt->wloc_x) / xfact ) + cur_x ;
  *org_y  = (int)( (float)(y - picwin_pt->wloc_y) / yfact ) + cur_y ;

}

/**************************************************/
void Zoom_subImgWin(picwin_pt,msg_sub,idir)
PICWIN   *picwin_pt;
MSG_BUTT *msg_sub;
int      idir;
{
   XImage *a_image;
   int    cen_x,cen_y,dispw_x,dispw_y,before_x,before_y;
   float  new_xcmp,new_ycmp;
   int    new_x,new_y;

   /* Find the center of the image */
   a_image = picwin_pt->dpixmap;
   dispw_x = a_image->width;        dispw_y = a_image->height;

   before_x = (int)((float)(dispw_x)/picwin_pt->xcmp) ;
   before_y = (int)((float)(dispw_y)/picwin_pt->ycmp) ;

   cen_x    = picwin_pt->cur_x + before_x/2;
   cen_y    = picwin_pt->cur_y + before_y/2;
   

   /* Check to see if the new reduction is not too small nor too big */
   if(idir == 0) {
      new_xcmp =  new_ycmp = 1.0;
   } else if ( idir > 0 ) {
      new_xcmp = picwin_pt->xcmp * 2.0;
      new_ycmp = picwin_pt->ycmp * 2.0;
   } else if ( idir  < 0 ) {
      new_xcmp = picwin_pt->xcmp / 2.0;
      new_ycmp = picwin_pt->ycmp / 2.0;
   }
   new_x = (int)((float)(dispw_x)/new_xcmp) ;
   new_y = (int)((float)(dispw_y)/new_ycmp) ;

   /* Do not change scale if too small or too big */
   if( (new_x < 2) || (new_y < 2) ) return; 
   if( (new_x > picwin_pt->owidth) || (new_y > picwin_pt->oheight) ) return; 

   /* Update the compression factor */
   picwin_pt->xcmp = new_xcmp;
   picwin_pt->ycmp = new_ycmp;
    
   /* Force the image to be redraw */
   Zoom_xy_subImgWin(picwin_pt,msg_sub,cen_x,cen_y);
}



/**************************************************/
void Zoom_xy_subImgWin(picwin_pt,msg_sub,cen_x,cen_y)
PICWIN   *picwin_pt;
MSG_BUTT *msg_sub;
int      cen_x,cen_y;
{
   XImage *a_image;
   int    x,y,dispw_x,dispw_y,before_x,before_y;
   int    x1,y1;

   a_image = picwin_pt->dpixmap;
   dispw_x = a_image->width;        dispw_y = a_image->height;

   before_x = (int)((float)(dispw_x)/picwin_pt->xcmp) ;
   before_y = (int)((float)(dispw_y)/picwin_pt->ycmp) ;
   
   /* Need to check if the reduce picture is within the original image */
   x =  cen_x - before_x / 2;
   x = (x < 0 ) ? 0 : x ;
   x = ((x + before_x)>picwin_pt->owidth) ? picwin_pt->owidth - before_x : x ;
   x = (x < 0 ) ? 0 : x ;

   y =  cen_y - before_y / 2;
   y = (y < 0 ) ? 0 : y ;
   y = ((y + before_y)>picwin_pt->oheight) ? picwin_pt->oheight - before_y : y ;
   y = (y < 0 ) ? 0 : y ;
   
   /* Force the image to be displayed */
   picwin_pt->cur_x  = x;
   picwin_pt->cur_y  = y;
   picwin_pt->last_x = picwin_pt->last_y = -1;
   sprintf(msg_sub->str,"Zoom%6.2f:%6.2f",
           1./picwin_pt->xcmp, 1./picwin_pt->ycmp);
   RedrawsubImgWin(picwin_pt,msg_sub);
}



/* $Log: ximg2.c,v $
 * Revision 1.1  1994/02/15  16:44:16  quyen
 * Initial revision
 * */
