/* $Id: xinclude.h,v 1.1 1994/02/15 16:45:37 quyen Exp $ */
/* 
 * done by quyen dinh nguyen
 */

/* UNIx include file stuff */
#include <stdio.h>
#include <math.h>

/* Xlib stuff */
#include <X11/Xlib.h>
#include <X11/Xutil.h>

/* Use the same include files in all files */
#ifndef  MAIN
#define  WHERE extern
#else
#define  WHERE
#endif

typedef unsigned char byte;

typedef struct{Window  win;      /* parent window */
               int     x,y,w,h;  /* location and size of button rectangle */
               int     lit;      /* invert flag (true = 1) */
               int     active;   /* active flag (false = 0 -> stipple gray */ 
               unsigned long fg,bg; /* colors */
               char    *str;     /* string for button */
               Pixmap  pix;      /* use pixmap instead of string */
               int     pw,ph;    /* size of pixmap */
               int     fwidth;   /* width of frame */
               int     color;    /* color flag (false = 0 -> 2-color button*/
              } BUTTON;

typedef struct{Window        win;      /* parent window */
               int           x,y,w,h;      /* position in parent */
               char          *str;     /* the message string */
               int           active;   /* selectable? */
               unsigned long fg,bg;    /* colors */
              } MSG_BUTT;

typedef struct{Window    win;      /* window */
               XImage    *dpixmap; /* XImage pointer */
               byte      *opic;    /* location of original picture*/
               int       wloc_x,wloc_y;  /* location of image window */
               int       owidth,oheight; /* size of original picture */
               int       last_x,last_y;  /* location of last modification */
               int       cur_x,cur_y;    /* displayed portion location */
               float     xcmp,ycmp;      /* compression factor */
              } PICWIN;
 
/* MACROS */
#define CENTERX(f,x,str) ((x)-XTextWidth(f,str,strlen(str))/2)
#define CENTERY(f,y) ((y)-((f->ascent+f->descent)/2)+f->ascent)
#define PTinRECT(x,y,rx,ry,rw,rh) \
        ((x)>=(rx) && (y)>=(ry) && (x)<=(rx)+(rw) && (y)<=(ry)+(rh))

#define X_LOCATION   0
#define Y_LOCATION   0

/* define the butter size */
#define BUTTW        91
#define BUTTH        21

/* message button in image window */
#define N_MSG_BUTTS  3
#define MSG_B_STR    0
#define MSG_WIN_NAME 1
#define MSG_LOC_STR  2

/* buttons in image window */
#define N_IMG_BUTTS   18 
#define B_LOW_DOWN    0
#define B_LOW_UP      1
#define B_HIGH_DOWN   2
#define B_HIGH_UP     3
#define IMG_UP        4
#define IMG_DOWN      5
#define IMG_LEFT      6
#define IMG_RIGHT     7
#define IMG_QUIT      8
#define IMG_SCR_LEFT  9
#define IMG_SCR_RIGHT 10
#define IMG_SCR_UP    11
#define IMG_SCR_DOWN  12
#define IMG_SCR_CNTR  13
#define B_BLACKWHITE  14
#define B_COLOR       15
#define B_SUBIMG_VIS  16
#define B_SUBIMG_ZOOM 17

/* message button in subimage windows */
#define N_MSG_SUB_BUTTS  2
#define MSG_SUBWIN_NAME  0
#define MSG_ZOOMWIN_NAME 1


/* X variables */
WHERE  Display       *dpy;
WHERE  int           screen;
WHERE  unsigned int  dispDEEP, dispWIDE, dispHIGH;
WHERE  Window        rootW,mainW,ctrlW;
WHERE  GC            gc;
WHERE  Visual        *visual;
WHERE  Colormap      cmap;
WHERE  XColor        *xcolors;
WHERE  int           bwidth,ncols;
WHERE  unsigned long white,black,fg,bg,infofg,infobg;
WHERE  int           low_str,high_str;
WHERE  int           min_color, max_color,color_mode;
WHERE  unsigned long locol,hicol;
WHERE  unsigned long colorcells[256];
WHERE  unsigned long planemask[256];
WHERE  unsigned int  red[256], blue[256], green[256];
WHERE  XFontStruct   *mfontstruct;
WHERE  XEvent        theEvent;
WHERE  int           eWIDE,eHEIGHT,eDBWIDTH;

/* Stuff for ctrl window */
WHERE  char          ctrl_geom[80];  /* geometry of ctrl window */
WHERE  MSG_BUTT      msg_but[N_MSG_BUTTS]; /* message buttons in ctrl window */
WHERE  char          str_string[15]; /* to hold the stretch values */
WHERE  char          loc_string[15]; /* to hold the stretch values */
WHERE  char          image_title[128]; /* title of the picture */

/* Stuff for image window */
WHERE  int           imgW;           /* Image window number */
WHERE  int           imgUp;          /* Boolean:whether img Window is visible*/
WHERE  char          img_geom[80];   /* geometry of image window */
WHERE  BUTTON        img_but[N_IMG_BUTTS]; /*command buttons in image window */
WHERE  PICWIN        img_picwin;     /* the display image window */
WHERE  int           dir_x_scroll;   /* the flag for x direction */
WHERE  int           dir_y_scroll;   /* the flag for y direction */
WHERE  int           scroll_step;    /* scroll step in pixels */
WHERE  int           button_pressed; /* flag for clicking button 3 */

/* Stuff for subimage window */
WHERE  int           subImgW;       /* Image window number */
WHERE  int           subImgUp;      /* Boolean:whether img Window is visible*/
WHERE  char          subimg_geom[80];  /* geometry of ctrl window */
WHERE  char          subimg_name[80];  /* geometry of ctrl window */
WHERE  PICWIN        subimg_picwin;    /* the display subimage window */
WHERE  char          subimage_title[128]; /* title of the picture */

WHERE  MSG_BUTT      msg_sub_but[N_MSG_SUB_BUTTS];
                                       /* message buttons in sub image window */

/* Stuff for Zoom window */
WHERE  int           ZoomW;       /* Image window number */
WHERE  int           ZoomUp;      /* Boolean:whether img Window is visible*/
WHERE  int           ZoomDir;     /* Zoom increase/decrease factor */
WHERE  char          subzoom_geom[80];  /* geometry of ctrl window */
WHERE  char          subzoom_name[80];  /* geometry of ctrl window */
WHERE  PICWIN        subzoom_picwin;    /* the display subimage window */
WHERE  char          subzoom_title[128]; /* title of the picture */

/* Stuff for button's graphics */
WHERE  int           initial;
#ifndef  MAIN
WHERE  Pixmap       grayTile;
WHERE  Pixmap       grayStip;
#else
Pixmap grayTile = (Pixmap) NULL;
Pixmap grayStip = (Pixmap) NULL;
#endif



/* xbutt.c */
void BUTTON_Create(),BUTTON_Redraw(),BUTTONSetActive(),DimRect();
void MSG_BUTTON_Create(),MSG_BUTTON_Redraw();

/* xcolors.c */
void str_grey();

/* xevent.c */
int  HandleEvent();

/* ximg.c */
void Create_Image(),CheckLocationButton(),ChangeColor(),RedrawImgWin();
int  ClickImg_win();
void RedrawLocString(),MoveImg(),JumpImg();

/* ximg2.c */
int  Create_subImage();
void subImgBox(),RedrawsubImgWin(),GetLoc_subImgWin();
void  Zoom_subImgWin(),Zoom_xy_subImgWin();

/* xmisc.c */
Window CreateWindow();

/* xpicwin.c */
void PICWIN_Create(),PICWIN_Redraw(),PICWIN_scroll_x(),copy_data();


/* $Log: xinclude.h,v $
 * Revision 1.1  1994/02/15  16:45:37  quyen
 * Initial revision
 * */
