/* $Id: xmain.c,v 1.1 1994/02/15 16:44:16 quyen Exp $ */
/*
 * done by quyen dinh nguyen 
 * %W% %G%
 */

#define MAIN

#include <fcntl.h>
#include "xinclude.h"



main(argc,argv)
int argc;
char **argv;
{
   int             xlocation,ylocation;
   int             winWIDE,winHEIGHT,BorderWIDTH;
   int             Done,retval;

   byte      *bytedata;
   int       i;
   int       ifd,img_size_x, img_size_y, disp_size_x,disp_size_y,byte_start;
   int       win_size_x,win_size_y,total_size,ix_start,iy_start,nread;
   int       subwin_size_x,subwin_size_y,subxlocation,subylocation;
   int       max_subzoom_sz, zoom_size_x, zoom_size_y;
   int       max_subimg_sz;
   int       subdispw_w,subdispw_h;
   float     ximg_fac,yimg_fac;
   float     xzoom_fac, yzoom_fac;

   /* Get the arguments */
   if(argc == 1) {
      print_usage(argv[0]);
      exit(1);
   }

   /* Decode the command line */
   get_size(argc,argv, &img_size_x,&img_size_y, &disp_size_x,&disp_size_y,
                       &ix_start, &iy_start, &low_str,&high_str,&byte_start,
                       &max_subzoom_sz);

   /* open the display */
   if ( (dpy = XOpenDisplay(NULL)) == NULL){
      printf("%s: can not open display: %s\n",argv[0],XDisplayName(NULL));
      exit(1);
   }

   /* X Setup */
   mainW = ctrlW = (Window) NULL; /* initialize to null */
   screen   = XDefaultScreen(dpy);
   rootW    = RootWindow(dpy,screen);
   gc       = DefaultGC( dpy, screen);
   visual   = DefaultVisual( dpy,screen);
   dispDEEP = DisplayPlanes( dpy,screen);
   dispWIDE = DisplayWidth(  dpy,screen);
   dispHIGH = DisplayHeight( dpy,screen);
   ncols    = DisplayCells(  dpy, screen);
   bwidth   = 1;
   initial  = 1;
   

   /* Setup the colormap */
   if((xcolors=(XColor *)calloc(ncols,sizeof(XColor))) == NULL){
       printf("there is no memory for setting up colormap\n");
       exit(1);
   }
   cmap = XCreateColormap(dpy, rootW, visual, AllocAll);
   if( XAllocColorCells ( dpy, cmap, True, planemask, dispDEEP, colorcells, 1)){
       printf("Can not open the colormap \n");
       exit(1);
   }

   /* Set up white, black colors, and fg, bg colors  */
   white  = 255;     black  = 0;
   fg     = white;   bg     = black; 
   infofg = fg;      infobg = bg;
   hicol  = fg;      locol  = bg;
   color_mode = 1;   button_pressed = False;

   /* Setup the fonts */
   if((mfontstruct = XLoadQueryFont( dpy, "fixed"))==NULL){
      printf("%s: Display %s can not load the font %s\n",
                   argv[0],XDisplayString(dpy),"fixed");
      exit(1);
   }
   XSetFont( dpy, gc, mfontstruct->fid);

   /* Create the main window */
   xlocation = 0; ylocation = 0;
   winWIDE   = BUTTW; winHEIGHT = (N_IMG_BUTTS+1)*BUTTH; BorderWIDTH = 1;
   sprintf(ctrl_geom,"%dx%d+%d+%d",winWIDE,winHEIGHT,
                     xlocation,ylocation);
   mainW = CreateWindow(argv[0],ctrl_geom,rootW,winWIDE,winHEIGHT,fg,bg);
   if(!mainW) {
      printf("%s: Can not create window at %s\n",argv[0],XDisplayString(NULL));
      exit(1);
   }


   /* Create the window image */
   total_size = img_size_x*img_size_y;
   if( (ifd=open(argv[1],O_RDONLY)) < 0 ){
       printf(" Can not open the input file %s\n",argv[1]);
       exit(1);
   }
   if(byte_start!=0) lseek(ifd,byte_start,0);
   if( (bytedata = (byte *) malloc(total_size)) == NULL){
       printf("Can not crate the memory of size %d\n",img_size_x*img_size_y);
       exit(1);
   }
   if( (nread = read(ifd,bytedata,total_size)) != total_size){
       printf("Can not read whole file in (%d bytes)\n",total_size);
       exit(1);
   }
   close(ifd);

   /* Create the window image (cont.) */
   win_size_x = disp_size_x + BUTTW + 10;
   win_size_y = disp_size_y + BUTTH + 7;
   win_size_y = ( win_size_y > 17*(BUTTH+2) + BUTTW +10 ) ? 
                   win_size_y : 17*(BUTTH+2) + BUTTW +10 ;
   sprintf(img_geom,"%dx%d+%d+%d",win_size_x,win_size_y,
                                  xlocation,ylocation);
   sprintf(image_title,"%s (start at byte %d)",argv[1],byte_start);
   Create_Image(argv[1],img_geom, rootW, bytedata,img_size_x,img_size_y,
                disp_size_x,disp_size_y,ix_start,iy_start,image_title);
   dir_x_scroll = 0;
   dir_y_scroll = 0;
   scroll_step  = 2;
   XSelectInput(dpy,imgW,ExposureMask|ButtonPressMask|ButtonReleaseMask);
   XMapWindow( dpy, imgW);
   XMapWindow( dpy, img_picwin.win);
                                 

   /* Create the subimage window */
   subImgUp = 0;
   max_subimg_sz = 512;
   ximg_fac = (img_size_x > max_subimg_sz ) ?  
                512.0 / (float)(img_size_x) : 1.0 ;
   yimg_fac = (img_size_y > max_subimg_sz ) ? 
                512.0 / (float)(img_size_y) : 1.0 ;
   ximg_fac = yimg_fac = (ximg_fac > yimg_fac) ? yimg_fac : ximg_fac ;
   subwin_size_x = (int)((float)(img_size_x)*ximg_fac) + 2;
   subwin_size_y = (int)((float)(img_size_y)*yimg_fac) + BUTTH + 2;
   subxlocation  = BUTTW + 10;
   subylocation  = 0;
   sprintf(subimg_geom,"%dx%d+%d+%d",subwin_size_x,subwin_size_y,
                                  subxlocation,subylocation);
   sprintf(subimg_name,"%s",argv[1]);
   sprintf(subimage_title,"%s (scale=%d:%d)",argv[1],
                          (int)(1./ximg_fac),(int)(1./yimg_fac));
   /* Calculate the subimage window size */
   subdispw_w = (int)((float)(img_size_x)*ximg_fac);
   subdispw_h = (int)((float)(img_size_y)*yimg_fac);
   subImgW = Create_subImage(&subimg_picwin,subimg_name,subimg_geom, 
                rootW, bytedata, img_size_x,img_size_y, ximg_fac, yimg_fac,
                subdispw_w, subdispw_h,
                subimage_title,&msg_sub_but[MSG_SUBWIN_NAME]);
   XSelectInput(dpy,subImgW,ExposureMask|ButtonPressMask|ButtonReleaseMask);

   /* Create the subimage Zoom window */
   ZoomUp = 0;
   xzoom_fac = yzoom_fac = 2.0;
   zoom_size_x = max_subzoom_sz + 2;
   zoom_size_y = max_subzoom_sz + BUTTH + 2;
   subxlocation  = BUTTW + 10;
   subylocation  = 0;
   sprintf(subzoom_geom,"%dx%d+%d+%d",zoom_size_x,zoom_size_y,
                                  subxlocation,subylocation);
   sprintf(subzoom_name,"%s",argv[1]);
   sprintf(subzoom_title,"Zoom %6.2f:%6.2f",
                          1./xzoom_fac,1./yzoom_fac);
   subdispw_w = subdispw_h = max_subzoom_sz;
   ZoomW = Create_subImage(&subzoom_picwin,subzoom_name,subzoom_geom, 
                rootW, bytedata, img_size_x,img_size_y, xzoom_fac, yzoom_fac,
                subdispw_w, subdispw_h,
                subzoom_title,&msg_sub_but[MSG_ZOOMWIN_NAME]);
   XSelectInput(dpy,ZoomW,ExposureMask|ButtonPressMask|ButtonReleaseMask);


   /* Do The Thing... */
   color_mode = 1; ChangeColor();

   Done = 0;
   while ( Done == 0 ){
       XNextEvent( dpy, &theEvent);
       retval = HandleEvent(&theEvent,&Done);
       if(dir_x_scroll != 0) 
          PICWIN_scroll_x(&img_picwin,scroll_step,&dir_x_scroll);
       if(dir_y_scroll != 0) 
          PICWIN_scroll_x(&img_picwin,scroll_step,&dir_y_scroll);
   }

   exit(0);
}


/* get_size(argc,argv,in_wt,in_ht,out_wt,out_ht,ix,iy,lo,hi,b_off)------------
   This will scan the command line to get the image dimension
 */
get_size(argc,argv,in_wt,in_ht,out_wt,out_ht,
         ix,iy,lo,hi,b_off,subzoom_sz)
int argc;
char *argv[];
int *in_wt,*in_ht,*out_wt,*out_ht;
int *ix,*iy,*lo,*hi,*b_off,*subzoom_sz;
{
   int  iarg;
   *in_wt = 1024;
   *in_ht = 1024;
   *out_wt = 1024;
   *out_ht = 1024;
   *ix     = 0;
   *iy     = 0;
   *lo     = 0;
   *hi     = 255;
   *b_off  = 0;
   *subzoom_sz = 128;
   for(iarg=2; iarg<argc ; iarg++){
      if(argv[iarg][0] == '-'){
         switch(argv[iarg][1]){
           case 'z':
               if(iarg+1 > argc) {
                 print_usage(argv[0]);
                 printf("\nError: option -z requires one more value\n");
                 exit(1);
               }
               *subzoom_sz = atoi(argv[iarg+1]);
               break;
           case 'b':
               if(iarg+1 > argc){
                 print_usage(argv[0]);
                 printf("\nError: option -b requires one more value\n");
                 exit(1);
               }
               *b_off  = atoi(argv[iarg+1]);
               break;
           case 'd':
               if(iarg+2 > argc){
                 print_usage(argv[0]);
                 printf("\nError: option -d requires two more values\n");
                 exit(1);
               }
               *out_wt = atoi(argv[iarg+1]);
               *out_ht = atoi(argv[iarg+2]);
               break;
          case 'x':
               if(iarg+2 > argc){
                 print_usage(argv[0]);
                 printf("Error: option -x requires two more values\n");
                 exit(1);
               }
               *ix = atoi(argv[iarg+1]) - 1;
               *in_wt = atoi(argv[iarg+2]);
               break;
          case 'y':
               if(iarg+2 > argc){
                 print_usage(argv[0]);
                 printf("Error: option -y requires two more values\n");
                 exit(1);
               }
               *iy = atoi(argv[iarg+1]) - 1;
               *in_ht = atoi(argv[iarg+2]);
               break;
         }
       }
  }
  if( (*out_wt + *ix) > (*in_wt)){
     printf(" The display image is greater than input image\n");
  }
  if( (*out_ht + *iy) > (*in_ht)){
     printf(" The display image is greater than the input image\n");
  }
}

print_usage(fname)
char *fname;
{
   printf("Usage: %s filename [-switch [switch value(s)]] ...\n",fname);
   printf("   switches may not be specified in clusters,i.e. \n");
   printf("   '%s badman.d -dxy <values>' is illegal\n",fname);
   printf(" Switches are currently:\n");
   printf("   -d <x> <y>  image dimensions horiz,vertical\n");
   printf("               to be displayed on the screen\n");
   printf("   -x <el> <size> display subset of full image where \n");
   printf("                  <el> is the first element to display\n");
   printf("                  (1st element is 1) and <size> is the\n");
   printf("                  actual size of data in horizontal\n");
   printf("   -y <el> <size> display subset of full image where \n");
   printf("                  <el> is the first element to display\n");
   printf("                  (1st element is 1) and <size> is the\n");
   printf("                  actual size of data in vertical\n");
   printf("   -b <byte_n>    Starting display at byte <byte_n>\n");
   printf("   -z <size>      Zoom sub window size.\n");
   printf("\n");
   printf(" Defaults: colortable is 256 value grey scale.\n");
   printf("           image is 1024 x 1024\n");
   printf("           input file size is 1024 x 1024\n");
   printf("           Starting display at byte 0\n");
   printf("           Zoom window size is 128 x 128 \n");
   printf("\n");

}

/* $Log: xmain.c,v $
 * Revision 1.1  1994/02/15  16:44:16  quyen
 * Initial revision
 * */
