/* $Id: xpicwin.c,v 1.1 1994/02/15 16:44:16 quyen Exp $ */
/* 
 * done by quyen dinh nguyen
 * %W% %G%
 */

#include "xinclude.h"

/*****************************************************************/
void PICWIN_Create(img_pt,win,x,y,winW,winH,cfg,cbg, 
                   orig_pic,orig_x,orig_y,xfact,yfact,
                   ix_start,iy_start)
PICWIN *img_pt;
Window win;
int    x,y,winW,winH;
unsigned long cfg,cbg;
byte   *orig_pic;
int    orig_x,orig_y;
float  xfact,yfact;
int    ix_start,iy_start;
{
  Window   win_disp;
  XImage   *pixmap_disp;
  byte     *imagedata;

  /* Create a subwindow for the image */
  win_disp = XCreateSimpleWindow (dpy,win,x,y,winW,winH,bwidth,cfg,cbg);
  if(!win_disp){
      printf("Can not create sub image window\n");
      exit(1);
  }

  imagedata = (byte *) malloc( winW * winH );
  if(!imagedata){
     printf(" can not allocate the buffer\n");
     printf(" the allocation=%d %d\n",winW,winH);
     exit(1);
  }
  /* Create the pixmap structure for picture */
  pixmap_disp = XCreateImage(dpy, visual, dispDEEP, ZPixmap, 0,
                      (char *)imagedata, winW, winH, 8, 0);
  if(!pixmap_disp){
     printf("Can not create pixmap structures\n");
     exit(1);
  }
  pixmap_disp->byte_order = MSBFirst;

  /* Inititalize the structure of PICWIN */
  img_pt->win         = win_disp;
  img_pt->dpixmap     = pixmap_disp;
  img_pt->opic        = orig_pic;
  img_pt->wloc_x      = x+bwidth;
  img_pt->wloc_y      = y+bwidth;
  img_pt->owidth      = orig_x;
  img_pt->oheight     = orig_y;
  img_pt->cur_x       = ix_start;
  img_pt->cur_y       = iy_start;
  img_pt->last_x      = img_pt->last_y    = -1;
  img_pt->xcmp        = xfact;
  img_pt->ycmp        = yfact;


}

/************************************************************/
void PICWIN_Redraw(img_pt)
PICWIN    *img_pt;
{
   byte    *pdata,*popic,*pfrom,*pto;
   XImage  *a_image;
   int     last_x,last_y,cur_x,cur_y;

   int     disp_width,disp_height,orig_width,orig_height;
   int     copy_pix,copy_line,fill_pix,fill_line;
   int     i,j;
   float   xcmp,ycmp;

   int     before_pix, before_line, after_pix, after_line;
   int     line;
   int     *cxarr,*cxarrp;



   popic  = img_pt->opic;
   last_x = img_pt->last_x;     last_y = img_pt->last_y;
   cur_x  = img_pt->cur_x;       cur_y = img_pt->cur_y;
   xcmp   = img_pt->xcmp;         ycmp = img_pt->ycmp;


   a_image = img_pt->dpixmap;
   pdata   = (byte *) a_image->data;

   orig_width  = img_pt->owidth; 
   orig_height = img_pt->oheight;
   disp_width  = a_image->width; 
   disp_height = a_image->height;
   
 

   if(  (last_x != cur_x)  || (last_y != cur_y) ){
      if( (xcmp == 1.0) && (ycmp == 1.0) ){
   
         copy_pix = (disp_width > orig_width ) ?  orig_width : disp_width;
         copy_line = (disp_height > orig_height) ? orig_height : disp_height;
         fill_pix  = (disp_width>orig_width ) ? (disp_width-orig_width) : 0;
         fill_line = (disp_height>orig_height) ? (disp_height-orig_height) : 0 ;

         for( i=0, pto=pdata ; i<copy_line ; i++){
             for (j=0, pfrom=popic+(i+cur_y)*orig_width+cur_x;
                  j<copy_pix; j++)  *pto++ = *pfrom++ ;
             if(fill_pix > 0) for(j=0;j<fill_pix;j++) *pto++ = 0;
         }
         for( i=0; i<fill_line; i++)
             for(j=0; j<disp_width; j++) *pto++ = 0;

      } else {

         before_pix  = (int)((float)(disp_width) /xcmp); 
         before_pix  = (before_pix > orig_width )  ? orig_width  : before_pix;

         before_line = (int)((float)(disp_height)/ycmp);
         before_line = (before_line > orig_height) ? orig_height : before_line;

         after_pix   = (int)((float)(before_pix) *xcmp);
         after_line  = (int)((float)(before_line)*ycmp);

         fill_pix    = (after_pix < disp_width)   ? 
                       (disp_width - after_pix) : 0;
         fill_line   = (after_line < disp_height) ?
                       (disp_height - after_line): 0;
         /* Allocate the temporary variable for resampling */
         cxarr = (int *) malloc(after_pix * sizeof(int));
         if(!cxarr){
            printf("Unable to allocate %d integer values\n",after_pix);
            exit(1);
         }
         for(i=0; i<after_pix; i++) 
            cxarr[i] = (before_pix * i) / after_pix;
  
         for(i=0, pto=pdata; i< after_line; i++) {
             line = (before_line * i)/after_line ;
             pfrom = popic + (line + cur_y)*orig_width + cur_x; 
             for(j=0, cxarrp = cxarr ; j< after_pix; j++)
                 *pto++ = pfrom[*cxarrp++];
             if(fill_pix > 0) for(j=0;j<fill_pix;j++) *pto++ = 0;
         }
         for( i=0; i<fill_line; i++)
             for(j=0; j<disp_width; j++) *pto++ = 0;

         /* Deallocate the memory */
         free(cxarr);
      }
   }
   
   /* update the location */
   img_pt->last_x = cur_x;   img_pt->last_y = cur_y;

   XPutImage( dpy, img_pt->win, gc, a_image, 0, 0, 0, 0,
              a_image->width, a_image->height); 

}

/******************************************************************/
void PICWIN_scroll_x(img_pt,xstep,dir_flag)
PICWIN    *img_pt;
int       xstep, *dir_flag;
{
  XImage  *a_image;
  int     last_x,cur_x,last_y,cur_y;
  int     new_x,new_y,new_width,new_height;
  int     win_fromx, win_fromy, win_cp_width, win_cp_height;
  int     win_to_x, win_to_y, putimg_x, putimg_y;
  byte    *pdata, *popic;
  
  popic   = img_pt->opic;
  last_x  = img_pt->last_x;      last_y = img_pt->last_y;
  cur_x   = img_pt->cur_x;       cur_y  = img_pt->cur_y;

  a_image = img_pt->dpixmap;
  pdata   = (byte *) a_image->data;

  /* Allow to scroll only if no expansion factor */
  if(  (img_pt->xcmp != 1.0 ) || (img_pt->ycmp != 1.0) ) return ;

  /* Update the picture first */
  if( (last_x != cur_x) ||  (last_y != cur_y) ) PICWIN_Redraw(img_pt);
  if( *dir_flag == -1 ){  /* scroll to left */
     new_width = (cur_x - xstep > 0 ) ? xstep : cur_x ;
     new_height = (img_pt->oheight < a_image->height) ?  
                   img_pt->oheight : a_image->height ;
     new_x = cur_x - new_width;
     new_y = cur_y;

     win_fromx = 0;              win_fromy = 0;
     win_cp_width   = img_pt->owidth - new_width;  win_cp_height = new_height;
     win_to_x = new_width;       win_to_y = 0 ;

     putimg_x = 0;               putimg_y = 0;

     img_pt->last_x = img_pt->cur_x = new_x;
     if( new_x <= 0 ) *dir_flag = 0;
  } else if ( *dir_flag == 1){ /* scroll to right */
     new_x = cur_x + a_image->width;
     new_y = cur_y;
     new_width = ( new_x + xstep  > img_pt->owidth ) ? 
                   img_pt->owidth - new_x : xstep ;
     new_height = (img_pt->oheight < a_image->height ) ?
                   img_pt->oheight : a_image->height ;

     win_fromx = new_width;              win_fromy = 0;
     win_cp_width  = img_pt->owidth - new_width;  win_cp_height = new_height;
     win_to_x =  0;       win_to_y = 0 ;

     putimg_x = a_image->width - new_width;  putimg_y = 0;

     img_pt->last_x = img_pt->cur_x = cur_x + new_width; 
     if( new_x + new_width >= img_pt->owidth ) *dir_flag = 0;
  } else if ( *dir_flag == -2) { /* scroll up */
     new_width =  (img_pt->owidth < a_image->width) ?
                   img_pt->owidth : a_image->width;
     new_height = (cur_y - xstep > 0 ) ? xstep : cur_y ;
     new_x = cur_x;
     new_y = cur_y - new_height;

     win_fromx = 0;             win_fromy = 0;
     win_cp_width  = new_width; win_cp_height = a_image->height - new_height;
     win_to_x =  0;             win_to_y = new_height ;


     putimg_x =  0;             putimg_y = 0;

     img_pt->last_y = img_pt->cur_y = new_y; 
     if( new_y <= 0 ) *dir_flag = 0;
  } else if ( *dir_flag == 2)  { /* scroll down */
     new_x = cur_x;
     new_y = cur_y + a_image->height;
     new_width =  (img_pt->owidth < a_image->width) ?
                   img_pt->owidth : a_image->width;
     new_height = (new_y + xstep >= img_pt->oheight) ?
                   img_pt->oheight - new_y : xstep ;

     win_fromx = 0;              win_fromy = new_height ;
     win_cp_width = new_width;   win_cp_height = a_image->height - new_height;
     win_to_x =  0;              win_to_y =  0;

     putimg_x =  0;              putimg_y =  a_image->height - new_height;

     img_pt->last_y = img_pt->cur_y = cur_y + new_height; 
     if( new_y + new_height >= img_pt->oheight ) *dir_flag = 0;
  }

  /* Start to scroll */
  XCopyArea( dpy, img_pt->win, img_pt->win, gc,
                  win_fromx, win_fromy,
                  win_cp_width, win_cp_height,
                  win_to_x, win_to_y);
  copy_data( popic, img_pt->owidth,
             new_x, new_y, new_width, new_height, 
             pdata, a_image->width, 0,0);
  XPutImage( dpy, img_pt->win, gc, a_image, 
                  0, 0, putimg_x,putimg_y,
                  new_width, new_height);

   /* Reset the button active status */
   CheckLocationButton(img_pt);
 
}
/************************************************************/
void copy_data(in, in_size_x, ix,iy, width, height, 
               out, out_size_x, ixout, iyout)
byte *in,*out;
int  in_size_x, ix,iy,width,height;
int  out_size_x, ixout, iyout;
{
   byte *pin,*pout;
   int  i,j;

   for(i=0;i<height;i++)
      for(j=0, pin =in + (i+iy)*in_size_x + ix, 
               pout = out + (i+iyout)*out_size_x + ixout ; 
          j<width; j++) *pout++ = *pin++;
}


/* $Log: xpicwin.c,v $
 * Revision 1.1  1994/02/15  16:44:16  quyen
 * Initial revision
 * */
