c******************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Projection: 	Magellan
c	Task:		Correlator, Alliant Fortran Version.
c------------------------------------------------------------------
c	Module Name: bidr_out.f
c		Output the multi-look image into the disk. 
c
c	Called by: overlay_process.f module.
c	
c	Common Block:
c		overlay.inc
c	Function:
c	        Using cio.c routines to perform the i/o.
c-------------------------------------------------------------------
c	5/1/92  Anhua Chu Initial code
c*******************************************************************
	subroutine bidr_out(buff_out,image_ch)
     
	implicit none	

	include '../../../inc/keyvar.inc'
	include '../../../inc/pp.inc'
	include '../../../inc/po.inc'
	include '../../../inc/constant.inc'
	include '../../../inc/corr_buffer.inc'
	include '../../../inc/overlay.inc'

c	PASSING IN PARAMETERS
	
	byte	buff_out(*)
	integer	image_ch

c	FUNCTION NAME

	integer cwrite

c	LOCAL VARIABLES

	integer nbytes
c	------------
c	WRITE IMAGE INTO DISK
c	------------

	nbytes=cwrite(image_ch,buff_out,byte_count,disk_address)

	if (nbytes .ne. byte_count) then
	   type *,' >>>WRITE IMAGE ERROR<<<',nbytes,byte_count
        endif

c	Alliant disk start at 0

	disk_address = disk_address + byte_count !next address
	num_image = num_image + 1

d	type *,' bidrout bytes, total im szie:',byte_count,disk_address

	byte_count = 0	!reset for the next image block 

	return
	end
c********************** end of bidr_out.f ************************
