c*******************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project:	Magellan
c	Task:		Correlator, Alliant Fortran Version
c-------------------------------------------------------------------
c	bidr_TRAIL.f:	(Alliant Fortran Version)
c	
C Abstract:
C	Writes the BIDR trailer record onto disk
c-------------------------------------------------------------------
c
c	7/30/92 A. Chu 
c*******************************************************************
	subroutine bidr_trail(pc_bidr_trail_name)

	implicit none	

        include '../../../inc/b_head'
        include '../../../inc/b_trail.inc'

C	PASSING PARAMETERS

        character*40 pc_bidr_trail_name

c	LOCAL VARIABLE

        character*8 date
        common / proc_date / date

        integer*4 bidr_reclen  
        parameter ( bidr_reclen = 32500 )

        character*23 date_time
        integer*4 c_to_doy, doy      ! external routine to convert
        external c_to_doy            ! calender date to day of year

        character*3 month (12)
     .       /'JAN','FEB','MAR','APR','MAY','JUN',
     .        'JUL','AUG','SEP','OCT','NOV','DEC'/

        integer i, j, k      ! scratch indices
        integer lun, chan, status
        integer*4 initdk    		! external routine to open or close
c        integer*4 initdk, closedk    ! external routine to open or close
c        external initdk, closedk     ! a file ( EZIO )

        write (*,*) 'BIDR_TRAILER-20'

c	--------------------
C       ASSIGN TAPE CLOSE TIME
c	-------------------- 
                                                !  123456789 123456789 123
        call get_date_time ( date_time )        ! "dd-mmm-yyyy hh:mm:ss.ss"
	B_TRAIL_YEAR = DATE_TIME(10:11)

        i = 0
        do while ( i .lt. 12 .and.
     .           date_time(4:6) .ne. month (i+1) )
         i = i + 1
        enddo

        write ( date (1:2), '(i2.2)' ) i+1

        if ( date_time (1:1) .eq. ' ' ) then
         date (3:5) = '/0' // date_time (2:2)
        else
         date (3:5) = '/' // date_time (1:2)
        endif
        date (6:8) = '/' // date_time(10:11)

        doy = c_to_doy ( date )

	type *,' DOY:',doy
	WRITE ( B_TRAIL_DAY, '(I3.3)' ) DOY

	B_TRAIL_HOUR = DATE_TIME(13:14)
	B_TRAIL_MIN  = DATE_TIME(16:17)
	B_TRAIL_SEC  = DATE_TIME(19:20)
	B_TRAIL_MSEC = DATE_TIME (22:23) // '0'

C>>  Assign product name

	IF ( B_HEAD_TYPE .EQ. 'F' ) THEN
	B_TRAIL_BIDR_NAME = 'F-BIDR '
      else
	B_TRAIL_BIDR_NAME = 'F-' // B_HEAD_TYPE // 'BIDR'
      endif

C>>  Write BIDR

      write (*,*) 'Writing (EZIO) ', pc_bidr_trail_name
      call get_lun ( lun )
      CHAN = INITDK ( LUN, PC_BIDR_TRAIL_NAME )
      call dkwrit ( chan, b_trail, bidr_reclen, 1 )
      call closedk( lun, chan )
      call free_lun ( lun )

      return
      end
c------------------- end of bidr_trail.f --------------------
