c***************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project:	Magellan
c	Task:		Portable Correlator, Alliant Fortran Version
c--------------------------------------------------------------
c	Module Name: 	circularf
c  		        circular SAR data to locate the center
c
c	Input:		SAR 32I/32Q Data 
c	
c	Output:		Centered 32 I/ 32 Q SAR Data c
c---------------------------------------------------------------
c
c	6/12/92 	A.Chu Initial code
c	
c***************************************************************
	
	subroutine  circular(buff,npulses,nsamples,nfft_rg,buff_sar)
	
	implicit none

c	PASSING IN PARAMETERS

	complex buff(*)
	integer npulses,nsamples,nfft_rg

c	PASSING OUT  PARAMETERS

	complex buff_sar(*)
	
c	LOCAL VARIABLES

	integer offset,num,over,short,i,j
	
	over = 0 
	short = 0 
        offset = nfft_rg/2 - (nsamples-60)/2 -1
c        offset = nfft_rg/2 - int(nsamples-60+1)/2

	if (offset+nsamples .gt. nfft_rg) then
	   
	   num = nfft_rg - offset 
	   over = offset + nsamples - nfft_rg 
	   do i=1,npulses
	      do j=1,num
                 buff_sar(offset+j+(i-1)*nfft_rg)
     *	         = buff(j+(i-1)*nfft_rg)
              enddo		 
	      do j=1,over
                 buff_sar(j+(i-1)*nfft_rg)
     *		 = buff(nsamples-over+j+(i-1)*nfft_rg)
	      enddo
	      do j=over+1,offset
		 buff_sar(j+(i-1)*nfft_rg)
     *		 =cmplx(0.0,0.0)
	      enddo
           enddo

	else
	 
	   num = nsamples
	   short = nfft_rg - (offset+nsamples)
	   do i=1,npulses
	      do j=1,num
                 buff_sar(offset+j+(i-1)*nfft_rg)
     *	         = buff(j+(i-1)*nfft_rg)
              enddo		 
	      do j=1,offset
                 buff_sar(j+(i-1)*nfft_rg) = cmplx(0.0,0.0)
	      enddo
	      if (short .gt. 0) then
	         do j=1,short
		     buff_sar(offset+nsamples+j+(i-1)*nfft_rg)
     *		     =cmplx(0.0,0.0)
	         enddo
	      endif
           enddo

        endif

	return
	end
c---------------------- end of circular.f --------------------------
