c*******************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project:	Magellan
c	Task:		Correlator, Alliant Fortran Version
c-------------------------------------------------------------------
c	cube_weight.f:	(Alliant Fortran Version)
c	
c-------------------------------------------------------------------
c
c	7/30/92 A. Chu 
c*******************************************************************
	subroutine cube_weight

	implicit none	

c	PASSING OUT PARAMTERS thru COMMON BLOCK

	REAL W1(16), W2(16), W3(16), W4(16),r_p 

	COMMON/S_WEIGHT/W1,W2,W3,W4 

c	LOCAL VARIABLES

	INTEGER I,PI

c-------------------------------------------------------------------
c	GENERATE FOUR-POINTS CUBE FUNCTION OF THE INTERPOLATION WEIGHTS
c----------------------------------------------------------------------
	
	DO I=1,16
	   r_p=float(i-1)/16.
	   W1(I)=-(1.+r_p)**3 + 5.*(1.+r_p)**2 - 8.*(1.+r_p) +4.
	   W2(I)=      r_p**3 -      2.*r_p**2               +1.
	   W3(I)= (1.-r_p)**3 - 2.*(1.-r_p)**2               +1.
	   W4(I)=-(2.-r_p)**3 + 5.*(2.-r_p)**2 - 8.*(2.-r_p) +4.
	END DO

d	type *,' cube interp weight:',w1(1),w2(1),w3(1),w4(1) 
	
	return
	end
c************************* end of sinc_weight.f *****************
