c***************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project:	Magellan
c	Task:		Portable Correlator, Alliant Fortran Version
c--------------------------------------------------------------
c	Module Name: 	decode_sar.f
c  			Decode 2I/2Q to 32I/32Q
c	Input:		EDR SAR 2I/2Q Data & Threshold values
c	
c	Output:		32 I/ 32 Q SAR Data
c
c	Reference:      F-BIDR SIS Document
c---------------------------------------------------------------
c
c	8/21/92 	A.Chu Testing for the WHITE Line.
c	6/12/92 	A.Chu Copied and modified from E.Chu's codes.
c	
c***************************************************************
	
	subroutine  decode_sar(sample_1_tbl,sample_2_tbl,
     *		              pm_th,data_2iq,buff_sar,
     *   		      npulses,nsamples,nfft_rg)
	
	implicit none


c	PASSING IN PARAMETERS

	complex sample_1_tbl(-128:127),sample_2_tbl(-128:127)
	real pm_th(0:31)
	byte data_2iq(*)
	complex buff_sar(*)
	integer npulses,nsamples,nfft_rg
	
c	LOCAL VARIABLES

	integer offset,num,over,short,i,j
	complex buff(512*2048)

c	do i=1,512*2048
c	   buff_sar(i)=cmplx(0.,0.)
c	   buff(i)=cmplx(0.,0.)
c	enddo

	call decode_baq(sample_1_tbl,sample_2_tbl,
     *	        	pm_th,data_2iq,buff,
     *	        	npulses,nsamples,nfft_rg)
	call circular(buff,npulses,nsamples,nfft_rg,buff_sar)

c	call baq_ac(nam1)

	return
	end
c---------------------- end of deocde_sar.f --------------------------
