c***************************************************************
c	JET PROPULSION LABORATORY
C	SECTION: 	334 RADAR SCIENCE & ENGINEERING
C	PROJECT:	MAGELLAN
C	TASK:		CORRLETOR ; ALLIANT FORTRAN VERSION
C---------------------------------------------------------------
c	Moudle Name: initial_corr.f
c
c			Initialize all file names & read po file
c---------------------------------------------------------------
c
c	03/10/94A.Chu Deleted single image input file.
c	6/20/92	A.Chu Combied stand alone and integrated with Prep
c	4/25/92	A.Chu Initial code.
c*********************************************************************
	subroutine filename_chan
	
	implicit none

	include '../../../inc/overlay.inc'
	include '../../../inc/pp.inc'
	include '../../../inc/po_a.inc'
c	include 'po'	!ln -s /user/magellan/src/pp/inc/po
	include '../../../inc/po.inc'!Corr PO

c	LOCAL VARIABLES

	integer copen,ccreate
	integer proj,bidr_from_disk
	integer oblique_1st_burst,oblique_last_burst
	integer sin_1st_burst,sin_last_burst

C	--------------
C	DETERMINE F-BIDR SOURCE FROM 	
c	READ-PO IF FROM DISK 
C	--------------

ccc	type *,' Enter BIDR source flag:(disk=1;prep=0)'
ccc	accept *,bidr_from_disk
ccc	type *,bidr_from_disk

ccc	if (bidr_from_disk .eq. 1) then

ccc	   type *,' Enter SAR 2I/2Q Data File Name:'
ccc	   accept '(a)',sar_name
ccc	   type *,sar_name
ccc
ccc	   type *,' Enter Per-orbit(F-BIDR12) File Name:'
ccc	   accept '(a)',bidr_12_name
ccc	   type *,bidr_12_name
ccc	   type *,' Enter Projection Flag:(sin=1;obl=0)'
ccc	   accept *,proj
ccc	   type *,proj
ccc	   if (proj .eq. 1) then

ccc	     type *,' Enter BIDR-16 Sin-PP File Name:'
ccc	  accept '(a)',bidr_16_name
cccccc	     type *,bidr_16_name

ccc	     type *,' Enter BIDR-15 Sin-Image File Name:'
ccc	     accept '(a)',bidr_15_name
ccc	     type *,bidr_15_name

cccc	   else

ccc	     type *,' Enter BIDR-14 Sin-PP File Name:'
ccc	     accept '(a)',bidr_14_name
ccc	     type *,bidr_14_name

ccc	     type *,' Enter BIDR-13 Sin-Image File Name:'
ccc	     accept '(a)',bidr_13_name
ccc	     type *,bidr_13_name

cccc	   endif
	
ccc	   call read_po(bidr_12_name,
ccc   *               oblique_1st_burst,
ccc   *		     oblique_last_burst,
ccc   *	             sin_1st_burst,
ccc   *		     sin_last_burst)

ccc	   po_data_projc_obl_st  = oblique_1st_burst
ccc	   po_data_projc_obl_end = oblique_last_burst
ccc	   po_data_projc_sin_st  = sin_1st_burst
ccc	   po_data_projc_sin_end = sin_last_burst

ccc	   po_projc_obl_st  = oblique_1st_burst
ccc	   po_projc_obl_end = oblique_last_burst
ccc	   po_projc_sin_st  = sin_1st_burst
ccc	   po_projc_sin_end = sin_last_burst

ccc	endif

C	--------------
C	COPY PO PARAMETERS TO CORRELATOR
C	--------------
	po_oblique_start_burst = po_projc_obl_st
	po_oblique_end_burst   = po_projc_obl_end
	po_sin_start_burst     = po_projc_sin_st
	po_sin_end_burst       = po_projc_sin_end

C	--------------
C	TESTING FILES SETUP
C	--------------

ccc	TYPE *, 'GIVE SAR OUTPUT FILE NAME'
ccc	accept '(a)' , nam1
ccc	type *,nam1
ccc	TYPE *, ' FILE FOR THE testing 1 DATA?'
ccc	accept '(a)', nam2
ccc	type *,nam2
ccc	TYPE *, ' FILE FOR THE testing 2 DATA?'
ccc	accept '(a)', nam3
ccc	type *,nam3
ccc	TYPE *, ' FILE FOR THE testing 3 DATA?'
ccc	accept '(a)', nam4
ccc	type *,nam4
ccc	ichan1= ccreate(nam1)
ccc	ichan2=ccreate(nam2)
ccc	ichan3=ccreate(nam3)
ccc	ichan4=ccreate(nam4)

	return
	end		
c---------------------- end of filename_chan.f --------------------------
