c************  INIT_FFT  ************************************
      subroutine init_fft( max )
c++
c  Generates Twiddle factor and bit-reversed address arrays for FFT operations
c  Arrays are stored in the common block
c--
      implicit none
      integer max

	include '../../../inc/fft.inc'
	integer i, j, stages
	real*8 anginc
	complex angle

c  Generate twiddle factors and complex conjugate of unscaled twiddle factors
c  for inverse FFT

	max_fft = max
	anginc = ( -2.d0*pi ) / dfloat( max_fft )
	do j = 0, max_fft/2-1
	    angle = cmplx( 0.0, sngl( anginc*( j ) ) )
	    twiddle( j ) = exp( angle )
	    twiddle( j+max_fft/2 ) = conjg( twiddle( j ) )
	end do

c  Calculate stages in FFT

	j = max
	stages = 0
	do while( j .gt. 1 )
	    stages = stages + 1
	    j = j / 2
	end do

c  Generate Bit-reversed numbers

	do i = 0, max-1
	    rev( i ) = 0
	    do j = 0, stages-1
		rev( i ) = rev( i )*2 + ibits( i, j, 1 )
	    end do
	end do
	return
      end
