c*******************************************************************
c	last_remainder.f	(Alliant Fortran Version)
c	
c	Output the last image block with filler.	
c
c-----------------------------------------------------------------------------
c
c	6/23/94   Lawrence Chen, Comment out testing blocksize limitation
c	02/04/93  Anhua Chu Initial code.
c	5/5/92  Anhua Chu Initial code.
c*****************************************************************************
	subroutine last_remainder(buff_out,image_ch)

	implicit none	

	include '../../../inc/pp.inc'
	include '../../../inc/po.inc'
	include '../../../inc/keyvar.inc'
	include '../../../inc/constant.inc'
	include '../../../inc/corr_buffer.inc'
	include '../../../inc/overlay.inc'

c	PASSING IN PARAMETERS

	byte	buff_out(*)
	integer	image_ch

c	Local Variables

	integer	byte_filler
	integer remainder
	integer image_rec_blocks
	integer i
	integer o_burst,pre_burst
	common /o_burst/ o_burst,pre_burst

d	type *,' LAST REMAINDER',burst_no
c	-------------
c	MAKE BIDR FORMAT FOR LAST BURST
c	-------------	

	if (projection .eq. sine) then
  	   c1_start_out = c1_max_1
	else 
	   c1_start_out = c1_min_1
	endif

	c1_size_out = c1_max_1 - c1_min_1 + 1

	c2_start_out = c2_min_1
	c2_size_out = 512

	o_burst = pre_burst

	call bidr_maker(buff_out)
	
c	-------------
c	REMAINDER CALCULATION
c	-------------	

	image_total_size = disk_address + byte_count

	remainder = mod(image_total_size,tape_rec_size) 

	if (remainder .eq. 0 ) then

	   byte_filler = 0
	
	else

	   byte_filler =tape_rec_size - remainder !tape_rec_size=32500

c	   -------------
c	   FILL THE FILLER INTO OUTPUT BUFFER
c	   -------------	

	   do i=1,byte_filler
	     byte_count=byte_count+1
	     buff_out(byte_count)=94	!filler= 94
	   enddo

c          ------------
c	   SEND LAST FILLER BLOCK
c	   -------------

c	   if (byte_count .gt. (512*992) ) then ! L. Chen 6/23/94 
c	      type *,' LAST BLOCK:Actual bytes:',byte_count
c	      byte_count = 15*32500	!QA & MIPL limitation
cccc	      byte_count = 512*992
c	      type *,' Output bytes:',byte_count
c	   endif

	   call bidr_out(buff_out,image_ch)

	endif

d	type *,' byte_filler:', byte_filler

c	------------
c	LOAD IMAGE RECORD BLOCK COUNTER & 
C	IMAGE NUMBER COUNTER FOR THE F-BIDR TAPE COPY
c	-------------	
	image_total_size = disk_address 
	image_rec_blocks = image_total_size / tape_rec_size

c	if (projection .eq. 1) then
c	   rec_count_file_15 = image_rec_blocks
c	   rec_count_file_15_blocks = num_image
c	else
c	   rec_count_file_13 = image_rec_blocks
c	   rec_count_file_13_blocks = num_image
c	endif

	type *,'Image blocks (32500):',image_rec_blocks
	type *,'Number image (one frame o/p)',num_image


	return
	end

c************************end of last_remainder.f****************
