C========================================================================
C mtxeq.f
C------------------------------------------------------------------------
	subroutine mtxeq(aw,x)
C
C Abstract:
C  	Solves the matrix equation awx=b for x, 
C	where b is stored in the 4-TH (and 5-th & 6-th) column 
C	of a 3X3 MATRIX aw as given below
C
C			   | 1    A   A**2|
C		       aw= | 1    0     0 |
C			   | 1    B   B**2|
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real aw(3,4), x(3)

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	aw		I		coefficient of eqn. awx=b
C	x		O		solution of eqn. awx=b
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real a, b, c, d, e, f

	a=aw(1,2)
	b=aw(1,3)
	d=aw(3,2)
	e=aw(3,3)

	c=aw(1,4)-aw(2,4)
	f=aw(3,4)-aw(2,4)

	x(1) = aw(2,4)
	x(2)=(c*e-f*b)/(a*e-d*b)
	x(3)=(c-a*x(2))/b

	return
	end

