c******************************************************************
c	Jet Propulsion Laboratory
c	Section:	334, Radar Science and Engineering
c	Project: 	Magellan
c	Task:		Correlator, Alliant Fortran Version.
c------------------------------------------------------------------
c	Module Name: pass_po
c	
c		Read Per-Orbit F-BIDR-12 file from pre-processor.
c
c-------------------------------------------------------------------
c	5/8/92  Anhua Chu Initial code
c*******************************************************************
	subroutine pass_po
     
	implicit none	

	include '../../../inc/po' ! L. Chen 2/1/94
	include '../../../inc/po_a.inc' ! L. Chen 2/1/94

c	include '/user/magellan/src/pp/inc/po'
c	include '/user/magellan/src/corr/f/po_a.inc'

c	------------
c	INTEGER DATA ASSIGNMENTS	
c	------------

        po_orbit_2_num            =po_sfdu_orbit_num 
	po_left_looking         =po_data_gen_left_looking 

	po_projc_obl_st         =po_data_projc_obl_st
	po_projc_obl_end        =po_data_projc_obl_end

	po_projc_sin_st         =po_data_projc_sin_st
	po_projc_sin_end        =po_data_projc_sin_end
d	type *,' PASS_PO:orbit num:',po_orbit_2_num,po_sfdu_orbit_num
d	type *,'OblSin',po_projc_obl_st,po_projc_obl_end
d	type *,'Sin',po_projc_sin_st,po_projc_sin_end
c	------------
c	CHARACTER  DATA ASSIGNMENTS	
c	------------

	po_prime_label   =po_sfdu_prime_label   
	po_prime_type    =po_sfdu_prime_type       
	po_gen_ephemeris_id  =po_data_gen_ephemeris_id 

c	------------
c	REAL*4 CONVERSION
c	------------
	po_sin_ref_lon       =po_data_projp_sin_ref_lon
	po_obl_ref_lon       =po_data_projp_obl_ref_lon
	po_neg_obl_ref_lat   =po_data_projp_neg_obl_ref_lat

	return
	end
c********************* end of read_po.f *********************
