C========================================================================
C rotate_z.f
C------------------------------------------------------------------------
	subroutine rotate_z(x,y,z,theta0,sign)
C
C Abstract:
C	Performs coordinate rotation about the Z axis
C	by an angle of theta0.
C
	implicit none

C Declarations:
C	Passing Parameters:

	real x, y, z
	real theta0, sign
 
C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x, y, z		I/O		vector to be rotated.
C	theta0		I		angle
C	sign		I		sign
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	None.
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:


	real theta
	real x1, y1

	theta=theta0*sign
	x1=x*cosd(theta)+y*sind(theta)
	y1=-1*x*sind(theta)+y*cosd(theta)
	z=z

	x=x1
	y=y1

	return
	end
