#include <stdio.h>
#include <fcntl.h>
#define MAXBURST 8600
#define PP_BUFSIZ PP_RECORD_LEN*MAXBURST

#define SAR_DATA_HDR_SIZE 298
#define SUB_SAR_DATA_HDR_SIZE 370


void sar_addr_mod_(filename, burst_address, burst_st, burst_end)
int *burst_address, *burst_st, *burst_end;
char *filename;
{
	int fd, nbytes;
	int nb, count, i, j;
	int start, end;
	char sar_buf[12];
	long sar_ptr,sar_addr,pp_addr;
	long data_size,sar_data_size,pp_data_size;

	start = *burst_st;
	end = *burst_end;
	printf("%d %d\n",burst_st,burst_end);
	printf("%d %d\n",start,end);
	printf("input filename %s\n",filename);


/* READ SAR_DATA FILE */

/*	filename="../edr/S_00808_07/SAR_DATA";	*/

	for (i = 0; i < strlen(filename); i++)
	    if (*(filename + i) == ' ') 
		*(filename + i) = '\0';

	if ( (fd = open(filename,O_RDONLY, 0)) < 0 ) {

	        fprintf( stderr, "MIS_SAR_ADDR:Can't open %s \n",filename );
	        exit(1);
	};
	printf( "Reading %s\n", filename);


/* START checking */

/* intialization */

	printf("--------------START CHECKING ---------------\n");	
	sar_addr = SAR_DATA_HDR_SIZE + SUB_SAR_DATA_HDR_SIZE;
	sar_ptr = sar_addr;

/* start looping */

	count = 1;

	for (i = start-1; i < end-1; i++) {
	   
/* find sar_data size from pp */ 


	pp_addr = burst_address[i]; 
	pp_data_size = burst_address[i+1] - burst_address[i]- 370;

/* find sar_addr */

	lseek(fd,sar_ptr,0);
	read(fd,sar_buf,12);

	while (strncmp(sar_buf,"CCSD1I000001",12) != 0) {
	      sar_ptr++;
	      lseek(fd,sar_ptr,0);
	      read(fd,sar_buf,12);
	}

	sar_data_size = sar_ptr - sar_addr;

	if ( sar_data_size != pp_data_size ) {
	   printf("---------------STOP----------------\n");
	   printf("SAR_DATA & PP misalignment ocuured\n");
	   printf("------------information------------\n");
	   printf("burst_index = %d\n",count);
	   printf("data size calculated from pp = %d\n",pp_data_size);
	   printf("data size from SAR_DATA = %d\n",
		   sar_data_size);
	   printf("The offset between two address = %d\n",
		   sar_data_size - pp_data_size);
           printf("The next address from SAR_DATA = %d\n",
		   sar_ptr + SUB_SAR_DATA_HDR_SIZE);
	   printf("The next address calculated from PP = %d\n",
	   	   burst_address[i+1]);
	   printf("-----------> suggestion <-------------\n");
	   if (data_size == sar_data_size) {
		printf("SAR_DATA has one more record of size %d",
			data_size);
		printf(" than PP \n");
		printf("Therefore, the offset for MGNSAR is %d\n",
			data_size+SUB_SAR_DATA_HDR_SIZE);
		for (i = start-1; i < end-1; i++) {
		    burst_address[i] += data_size+SUB_SAR_DATA_HDR_SIZE;
		}
		printf("burst_address + offset %d\n",data_size+
			SUB_SAR_DATA_HDR_SIZE);
		close( fd );
		return;
	   }
	   else if ( data_size == pp_data_size ) {
		printf("You need to skip one burst");
		printf(" when you run MGNSAR\n");
	   }
	   else {
		printf("The EDR tape need to be check\n");
	   }
	
	   close( fd );
	   exit(1);

	}
	
	if (count == 1) {
	   data_size = sar_data_size;
	}	

	if (data_size != sar_data_size) {
	   printf("count = %d sar_data_size %d pp_data_size %d \n"
		,count,sar_data_size,pp_data_size);
	   close( fd );
	   return;
	}

	printf("The burst_index %4d SAR address: %10d data size: %d\n",
		count,sar_addr,data_size);

	sar_ptr += SUB_SAR_DATA_HDR_SIZE;
	sar_addr = sar_ptr;
	count++;

	}
}
