/* cio.c:  i/o routines callable by fortran77
	   int ccreate_(char *fnm)
	   int copen_(char *fnm)
	   int cread_(int *fd, char *buf, int *nb, int *fb)
	   int cwrite_(int *fd, char *buf, int *nb, int *fb)
	   void cclose_(int *fd)

	where 'fnm' is a pointer to a filename  
	      'fd' is a pointer to a file descriptor
	      'buf' is a pointer to a data buffer
	      'nb' is a pointer to a value = number of bytes to read or write
	      'fb' is a pointer to a value = first byte to read or write
*/

#include <fcntl.h>
#include <errno.h>
extern int errno;

int ccreate_(fnm)
char *fnm;
{
	
    int i;
    for (i = 0; i < strlen(fnm); i++)
      if (*(fnm + i) == ' ') *(fnm + i) = '\0';
    return (creat (fnm, 0755));
}

int copen_(fnm)
char *fnm;
{
    int i, fd;
    for (i = 0; i < strlen(fnm); i++)
      if (*(fnm + i) == ' ') *(fnm + i) = '\0';
    if ( (fd = open( fnm, O_RDONLY ) ) <= 0 ) {
	perror ( "  ***   Opening Error ***\n" );
	printf ( " %s\n", fnm );
	printf ( " %i\n", fd);
	return ( -1 ); }
    else 
	return ( fd );
    
}

int cwrite_(fd, var, nb, fb)
int *fd, *nb, *fb;
char *var;
{
    int f_error;

    if (*fb){
        lseek (*fd, (long)(*fb), 0);
    }

    if ( (f_error = write(*fd, var, *nb)) <= 0 ) {
	perror( " ***  Writting Error  ***\n" );
	printf( " %i\n",fd);
	return (-1); }
    else 
	return (f_error);
}

int cread_(fd, var, nb, fb)
int *fd, *nb, *fb;
char *var;
{
    if (*fb){
        lseek (*fd, (long)(*fb), 0);
    }
    return (read(*fd, var, *nb));
}

void cclose_(fd)
int *fd;
{
    close(*fd);
}
