/*
 *   vax2sunr4.c function to convert VAX real*4 to Sun IEEE real*4
 *               based on Anhua Chu's vax_alliant_sf.f
 *
 *   Changes:  Initial code David Swantek  9 / 25 / 93
 *   Changes:  Lawrence Chen 10/18/93 --> passed by value
 *   Changes:  L. Chen 3/16/94 --> deal with -0.0
 *
 */

/***   Includes   ***/

#include<stdio.h>
#include<math.h>

/***   Structure and union definitions   ***/

struct vaxr4 
{
    unsigned mant_low:16;
    unsigned sign:1;
    unsigned expo:8;
    unsigned mant_high:7;
};

union uvaxr4 
{
    float vr4;
    struct vaxr4 vr4s;
    char b[ 4 ];
};

struct ieeer4
{
    unsigned sign:1;
    unsigned expo:8;
    unsigned mant_high:7;
    unsigned mant_low:16;   
};

union uieeer4
{
    float ir4;
    struct ieeer4 ir4s;
    char b[ 4 ];
};

union uif
{
    int i;
    float f;
    char b[ 4 ];
};

float vax2sunr4d( f )
float *f;
{
/***   Declaration of local variables   ***/

    union uvaxr4 uv;
    union uieeer4 ui;
    union uif u1;
    short expo;
    int i;
    float value;

/***   start of code   ***/

    u1.f = *f;

    uv.b[ 3 ] = u1.b[ 0 ];
    uv.b[ 2 ] = u1.b[ 1 ];
    uv.b[ 1 ] = u1.b[ 2 ];
    uv.b[ 0 ] = u1.b[ 3 ];

    if (uv.vr4 != 0.0) {
        ui.ir4s.mant_high = uv.vr4s.mant_high;
        ui.ir4s.mant_low  = uv.vr4s.mant_low;
        ui.ir4s.sign = uv.vr4s.sign;
        expo = uv.vr4s.expo;
        ui.ir4s.expo = expo - 2;
        expo = ui.ir4s.expo;
        value = ui.ir4;
    }
    else
	value = uv.vr4;


    return value;
}
