C========================================================================
C save_to_radiom.f
C------------------------------------------------------------------------
	SUBROUTINE save_to_radiom( burst )
C
C Abstract:
C	Saves certain of the telemetry variables stored in the pp
C	record to the radiom file.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	INTEGER*2	burst

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/pmc'
	include '../../../inc/radiom'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	burst		I		burst counter
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	see include file listing
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

C Start:

C	Check for burst number out of bounds:

	IF ( burst .LE. 0 .OR. burst .GT. bursts_max ) THEN
		TYPE *, 'SAVE_TO_RADIOM:'
		TYPE *, '   "burst" is out of bounds:  ', burst
		TYPE *, '   Return to caller'
		RETURN
	END IF

	CALL save_to_radiom_sub( radiom_ONU_state(burst),
	1			 radiom_RXU_state(burst),
	2			 radiom_receiver_temp(burst),
	3			 radiom_cable_temp(1,burst) )

C Done:

	RETURN
	END
