C========================================================================
C alpha12.f 
C------------------------------------------------------------------------
	subroutine alpha12 ( handle )

C Abstract:
C	This subroutine is high-level routine in the purpose to obtain 
C	the alpha1 and alpha2 angles for the coordinates of the oblique 
C	sinusoidal projection.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	integer handle

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/var_local'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	handle		I		Handle of an S/P kernel file	
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       --------	---		------------
C	var_local	I/O		see include file "var_local"
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C
C Local Variables:

	real*8 day_85_deg

	t_85deg=t_85deg + t_p	!use the time of 85 degree latitude
	call sec_2_day(t_85deg,day_85_deg)  !from second to unit of day
	call Navs(Nav_source,t_85deg,t_p,x_s_j2000,v_s_j2000,
     c	a_s_j2000, handle)

c	get sensor state vectors

	call j2000_to_VME(X_s_j2000,X_s_VME)  !sensor position vector in VME
	call VME_to_VBF(day_85_deg,x_s_VME,x_s_VBF)  !in VBF
	call j2000_to_VME(v_s_j2000,v_s_VME)	     !same for velocity vector
	call VME_to_VBF(day_85_deg,v_s_VME,v_s_VBF)  !sensor velocity in VBF

	call oblique_ang(x_s_vbf,v_s_vbf,alpha1,alpha2,xhat_vbf,
     1	yhat_vbf,zhat_vbf)

d	type *, 'alpha1= ', alpha1
d	type *, 'alpha2= ', alpha2
	return
	end
