C========================================================================
C ang_incd.f
C------------------------------------------------------------------------
	subroutine ang_incd(x_s,x_m,I_m)
C
C Abstract:
C	Computes incidence angle of MRP
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real x_s(3), x_m(3), I_m

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x_s		I		sensor position
C	x_m		I		MRP position
C	I_m		O		incidence angle of MRP
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real n_refrac, I_mp, xsm_mag, xm_mag, xm_dot_xsm, dI_m

	xsm_mag=sqrt((x_s(1)-x_m(1))**2+(x_s(2)-x_m(2))**2+
     c	(x_s(3)-x_m(3))**2) !sensor to planet center

	xm_mag=sqrt(x_m(1)**2+x_m(2)**2+x_m(3)**2) !MRP to planet center

	xm_dot_xsm=((x_s(1)-x_m(1))*x_m(1)+(x_s(2)-x_m(2))*x_m(2)+
     c	(x_s(3)-x_m(3))*x_m(3))

	I_m = acosd(xm_dot_xsm/(xm_mag*xsm_mag)) 

	dI_m = -1 * (.43 - .0222*I_m + .00077 * I_m**2)

	I_m = I_m + dI_m

	return
	end
