C========================================================================
C ang_offset.f
C------------------------------------------------------------------------
	subroutine ang_offset(x_mgn,y_mgn,z_mgn,d_anglk)
C
C Abstract:
C	Computes the directional vectors of the spacecraft x and z axes after
C	a rotation about the y axis by d_anglk degree.
C	For a positive d_anglk, look angle increase.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real x_mgn(3), y_mgn(3), z_mgn(3), d_anglk

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x_mgn		I/O		spacecraft X axis
C	y_mgn		unused		spacecraft Y axis
C	z_mgn		I/O		spacecraft Z axis
C	d_anglk		I		delta look angle
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real temp(3)

	temp(1)=cosd(d_anglk)*z_mgn(1)-sind(d_anglk)*x_mgn(1)
	temp(2)=cosd(d_anglk)*z_mgn(2)-sind(d_anglk)*x_mgn(2)
	temp(3)=cosd(d_anglk)*z_mgn(3)-sind(d_anglk)*x_mgn(3)

	x_mgn(1)=sind(d_anglk)*z_mgn(1)+cosd(d_anglk)*x_mgn(1)
	x_mgn(2)=sind(d_anglk)*z_mgn(2)+cosd(d_anglk)*x_mgn(2)
	x_mgn(3)=sind(d_anglk)*z_mgn(3)+cosd(d_anglk)*x_mgn(3)

	z_mgn(1)=temp(1)
	z_mgn(2)=temp(2)
	z_mgn(3)=temp(3)

	return
	end
