C========================================================================
C backscatter.f
C------------------------------------------------------------------------
	subroutine backscatter(I_m,f_I_m)
C
C Abstract:
C	Gets the backscattering coefficient at
C	given incidence angle according to a MGN project
C	defined model. Value determined by model is stored in 
C	the array sigma(.). Linear interpolation is performed
C	for higher accuracy.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real I_m, f_I_m

	real sigma(100)
	common /array1/sigma

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	I_m		I		incidence angle of MRP
C	f_I_m		O		backscatter coefficient for given I_m
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	array1		I		backscatter coefficients data
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real qI_m, aI_m
	integer i, l

	qI_m=.5

	aI_m=I_m/qI_m

	I=int(aI_m)

	if(i.ge.1 .and. i.le.99) then
	f_I_m=sigma(I)+(aI_m-i)*(sigma(I+1)-sigma(I))
	else

	if(i.ge.100) then
	f_i_m = sigma(100)
	else
	f_i_m = sigma(1)
	end if

	end if

      if ( f_I_m .lt. 0 ) type *,'I_m=', I_m, ' f_I_m=',f_I_m

	return
	end
