C========================================================================
C c_dmp_pp.f
C------------------------------------------------------------------------
      subroutine c_dmp_pp ( nb )
C
C Abstract:
C	Stores partial processing parameters 
C
	implicit none

C Declarations:
C	Passing Parameters: 

      integer nb                        ! burst number

C	Constant Parameters: 

      integer max_rec
      parameter ( max_rec = 8600 ) 

C	Include files: 

      include '../../../inc/ppp'
      include '../../../inc/temp_pp'
      include '../../../inc/var_local'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	nb		I		burst number
C
C Constant Parameters:
C	max_rec - maximum number of burst.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	see include file listing.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

      real sigma_b

d     write (*,*) 'C_DMP_PP: nb = ', nb

      pp_time_burst_ref( nb ) = t_b
      pp_time_burst_center( nb ) = t_m
      pp_time_echo_delay( nb ) = t_d

C>>  Save some of the local variables to temp pp structure

      temp_pp_x_m(1,nb) = x_m(1)
      temp_pp_x_m(2,nb) = x_m(2)
      temp_pp_x_m(3,nb) = x_m(3)

      temp_pp_e(1,nb) = e(1)
      temp_pp_e(2,nb) = e(2)
      temp_pp_e(3,nb) = e(3)

      temp_pp_h(1,nb) = h(1)
      temp_pp_h(2,nb) = h(2)
      temp_pp_h(3,nb) = h(3)

C>>  Transfer to pp structure

	pp_ssp_sc_x_j2000( nb ) = x_s_j2000(1)
	pp_ssp_sc_y_j2000( nb ) = x_s_j2000(2)
	pp_ssp_sc_z_j2000( nb ) = x_s_j2000(3)
	pp_ssp_sc_x_vbf( nb ) = x_s_vbf(1)      !( nb ) = x_s
	pp_ssp_sc_y_vbf( nb ) = x_s_vbf(2)
	pp_ssp_sc_z_vbf( nb ) = x_s_vbf(3)
 
	pp_ssp_sc_vx_j2000( nb ) = v_s_j2000(1)
	pp_ssp_sc_vy_j2000( nb ) = v_s_j2000(2)
	pp_ssp_sc_vz_j2000( nb ) = v_s_j2000(3)

	pp_ssp_sc_vx_vbf( nb ) = v_s_vbf(1)      !( nb ) = v_s
	pp_ssp_sc_vy_vbf( nb ) = v_s_vbf(2)
	pp_ssp_sc_vz_vbf( nb ) = v_s_vbf(3)
 
	pp_ssp_sc_ax_j2000( nb ) = a_s_j2000(1)
	pp_ssp_sc_ay_j2000( nb ) = a_s_j2000(2)
	pp_ssp_sc_az_j2000( nb ) = a_s_j2000(3)

	pp_ssp_sc_ax_vbf( nb ) = a_s_vbf(1)
	pp_ssp_sc_ay_vbf( nb ) = a_s_vbf(2)
	pp_ssp_sc_az_vbf( nb ) = a_s_vbf(3)

	pp_ssp_q1( nb ) = qm(1)
	pp_ssp_q2( nb ) = qm(2)
	pp_ssp_q3( nb ) = qm(3)
	pp_ssp_q4( nb ) = qm(4)

	pp_ssp_ubor_x_vme( nb ) = p_vme(1)
	pp_ssp_ubor_y_vme( nb ) = p_vme(2)
	pp_ssp_ubor_z_vme( nb ) = p_vme(3)

	pp_ssp_ubor_x_vbf( nb ) = p(1)      
	pp_ssp_ubor_y_vbf( nb ) = p(2)
	pp_ssp_ubor_z_vbf( nb ) = p(3)

	pp_ssp_look_ang( nb ) = ang_lk
	
	pp_bip_bip_x_vbf( nb ) = x_b(1)
	pp_bip_bip_y_vbf( nb ) = x_b(2)
	pp_bip_bip_z_vbf( nb ) = x_b(3)
 
        if ( lon_b .ge. 0 ) then
           pp_bip_bip_lon( nb ) = lon_b
        else
           pp_bip_bip_lon( nb ) = lon_b + 360
        endif
           
	pp_bip_bip_lat( nb ) = lat_b
	pp_bip_bip_elev( nb ) = e_b

	pp_bip_bip_inc_ang( nb ) = I_b
	pp_bip_bip_app_rg( nb ) = Rapp

	pp_bip_bip_fd( nb ) = fd_b
	pp_bip_bip_fd_drift( nb ) = f_dr

	pp_mrp_mrp_incang( nb ) = I_m
      	call backscatter(I_b, Sigma_b)
	pp_mrp_mrp_bs_coef( nb ) = Sigma_b
	pp_mrp_mrp_lat( nb ) = Lat_m
        if ( lon_m .ge. 0 ) then
   	   pp_mrp_mrp_lon( nb ) = Lon_m
        else
   	   pp_mrp_mrp_lon( nb ) = Lon_m + 360
        endif
 
	pp_mrp_mrp_elev( nb ) = e_m
    	pp_mrp_sample1_app_rg( nb ) = t_d * cspeed/2.
	pp_mrp_mrp_app_rg( nb ) = R_m

	pp_mrp_mrp_fd( nb ) = fd_m
    	pp_mrp_mrp_fr( nb ) = fr_m

	pp_mrp_mrp_x_vme( nb ) = x_m_vme(1)
	pp_mrp_mrp_y_vme( nb ) = x_m_vme(2)
	pp_mrp_mrp_z_vme( nb ) = x_m_vme(3)

d	if ( mod(nb,10) .eq. 0 ) then
d
d	   write (*,*) 'burst=', nb
d
d	write (*,*) 'pp_time_burst_ref = ',
d    .               pp_time_burst_ref (nb)
d	write (*,*) 'pp_time_burst_center = ',
d    .               pp_time_burst_center (nb)

d	write (*,*) 'pp_ssp_sc_x_j2000 = ',
d    .               pp_ssp_sc_x_j2000 (nb)
d	write (*,*) 'pp_ssp_sc_y_j2000 = ',
d    .               pp_ssp_sc_y_j2000(nb)
d	write (*,*) 'pp_ssp_sc_z_j2000 = ',
d    .               pp_ssp_sc_z_j2000 (nb)
d	write (*,*) 'pp_ssp_sc_x_vbf = ',
d    .               pp_ssp_sc_x_vbf (nb)
d	write (*,*) 'pp_ssp_sc_y_vbf = ',
d    .               pp_ssp_sc_y_vbf (nb)
d	write (*,*) 'pp_ssp_sc_z_vbf = ',
d    .               pp_ssp_sc_z_vbf (nb)
d
d	write (*,*) 'pp_ssp_sc_vx_j2000 = ',
d    .               pp_ssp_sc_vx_j2000(nb)
d	write (*,*) 'pp_ssp_sc_vy_j2000 = ',
d    .               pp_ssp_sc_vy_j2000 (nb)
d	write (*,*) 'pp_ssp_sc_vz_j2000 = ',
d    .               pp_ssp_sc_vz_j2000 (nb)
d
d	write (*,*) 'pp_ssp_sc_vx_vbf = ',
d    .               pp_ssp_sc_vx_vbf(nb)
d	write (*,*) 'pp_ssp_sc_vy_vbf = ',
d    .               pp_ssp_sc_vy_vbf (nb)
d	write (*,*) 'pp_ssp_sc_vz_vbf = ',
d    .               pp_ssp_sc_vz_vbf (nb)
d
d	write (*,*) 'pp_ssp_sc_ax_j2000 = ',
d    .               pp_ssp_sc_ax_j2000(nb)
d	write (*,*) 'pp_ssp_sc_ay_j2000 = ',
d    .               pp_ssp_sc_ay_j2000(nb)
d	write (*,*) 'pp_ssp_sc_az_j2000 = ',
d    .               pp_ssp_sc_az_j2000(nb)
d
d	write (*,*) 'pp_ssp_sc_ax_vbf = ',
d    .               pp_ssp_sc_ax_vbf (nb)
d	write (*,*) 'pp_ssp_sc_ay_vbf = ',
d    .               pp_ssp_sc_ay_vbf (nb)
d	write (*,*) 'pp_ssp_sc_az_vbf = ',
d    .               pp_ssp_sc_az_vbf(nb)
d
d	write (*,*) 'pp_ssp_q1 =', pp_ssp_q1(nb)
d	write (*,*) 'pp_ssp_q2 = ', pp_ssp_q2 (nb)
d	write (*,*) 'pp_ssp_q3 =', pp_ssp_q3(nb)
d	write (*,*) 'pp_ssp_q4 = ', pp_ssp_q4 (nb)
d
d	write (*,*) 'pp_ssp_delta_q1 = ',
d    .               pp_ssp_delta_q1 (nb)
d	write (*,*) 'pp_ssp_delta_q2 = ',
d    .               pp_ssp_delta_q2 (nb)
d	write (*,*) 'pp_ssp_delta_q3 = ',
d    .               pp_ssp_delta_q3 (nb)
d	write (*,*) 'pp_ssp_delta_q4 = ',
d    .               pp_ssp_delta_q4 (nb)
d
d	write (*,*) 'pp_ssp_ubor_x_vme = ',
d    .               pp_ssp_ubor_x_vme (nb)
d	write (*,*) 'pp_ssp_ubor_y_vme = ',
d    .               pp_ssp_ubor_y_vme (nb)
d	write (*,*) 'pp_ssp_ubor_z_vme = ',
d    .               pp_ssp_ubor_z_vme (nb)
d	write (*,*) 'pp_ssp_ubor_x_vbf = ',
d    .               pp_ssp_ubor_x_vbf (nb)
d	write (*,*) 'pp_ssp_ubor_y_vbf = ',
d    .               pp_ssp_ubor_y_vbf(nb)
d	write (*,*) 'pp_ssp_ubor_z_vbf = ',
d    .               pp_ssp_ubor_z_vbf(nb)
d
d	write (*,*) 'pp_ssp_look_ang = ',
d    .               pp_ssp_look_ang (nb)
d
d	write (*,*) 'pp_bip_bip_x_vbf = ',
d    .               pp_bip_bip_x_vbf (nb)
d	write (*,*) 'pp_bip_bip_y_vbf = ',
d    .               pp_bip_bip_y_vbf (nb)
d	write (*,*) 'pp_bip_bip_z_vbf = ',
d    .               pp_bip_bip_z_vbf (nb)
d
d	write (*,*) 'pp_bip_bip_lon = ',
d    .               pp_bip_bip_lon (nb)
d	write (*,*) 'pp_bip_bip_lat = ',
d    .               pp_bip_bip_lat (nb)
d	write (*,*) 'pp_bip_bip_elev = ',
d    .               pp_bip_bip_elev (nb)
d
d	write (*,*) 'pp_bip_bip_inc_ang = ',
d    .               pp_bip_bip_inc_ang (nb)
d	write (*,*) 'pp_bip_bip_app_rg = ',
d    .               pp_bip_bip_app_rg (nb)
d
d	write (*,*) 'pp_bip_bip_fd = ',
d    .               pp_bip_bip_fd (nb)
d	write (*,*) 'pp_bip_bip_fd_drift = ',
d    .               pp_bip_bip_fd_drift (nb)
d
d	write (*,*) 'pp_mrp_mrp_incang = ',
d    .               pp_mrp_mrp_incang(nb)
d	write (*,*) 'pp_mrp_mrp_bs_coef = ',
d    .               pp_mrp_mrp_bs_coef (nb)
d	write (*,*) 'pp_mrp_mrp_lat = ',
d    .               pp_mrp_mrp_lat(nb)
d	write (*,*) 'pp_mrp_mrp_lon = ',
d    .               pp_mrp_mrp_lon(nb)
d
d	write (*,*) 'pp_mrp_mrp_elev = ',
d    .               pp_mrp_mrp_elev(nb)
d
d	write (*,*) 'pp_mrp_sample1_app_rg = ',
d    .               pp_mrp_sample1_app_rg (nb)
d	write (*,*) 'pp_mrp_mrp_app_rg = ',
d    .               pp_mrp_mrp_app_rg(nb)
d
d	write (*,*) 'pp_mrp_mrp_fd = ',
d    .               pp_mrp_mrp_fd (nb)
d	write (*,*) 'pp_mrp_mrp_fr = ',
d    .               pp_mrp_mrp_fr(nb)
d
d	write (*,*) 'pp_mrp_mrp_x_vme = ',
d    .               pp_mrp_mrp_x_vme (nb)
d	write (*,*) 'pp_mrp_mrp_y_vme = ',
d    .               pp_mrp_mrp_y_vme (nb)
d	write (*,*) 'pp_mrp_mrp_z_vme = ',
d    .               pp_mrp_mrp_z_vme (nb)
d
d	endif
      return
      end
