#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "../../../inc/ppinc.h"
#include "../../../inc/pp.h"

extern struct b_head b_head_;
extern struct pp_time pp_time_;
extern struct pp_ssp pp_ssp_;
extern struct pp_bip pp_bip_;
extern struct pp_mrp pp_mrp_;
extern struct sar_stat sar_stat_;
extern struct var_local var_local_;

c_dmp_pp_2_( ppbuf )
char *ppbuf;
{
	int nb, orbit;
	int i, j;
	union upp upp;
	double c_pow_double;  /* Lawrence Chen  1/28/94 */

/* Initialize pp record */

	for ( i = 0; i < 35; i++ ) upp.ppstr.str1[i] = 0;
	for ( i = 0; i < 4; i++ ) upp.ppstr.str2[i] = 0;
	for ( i = 0; i < 44; i++ ) upp.ppstr.str3[i] = 0;
	for ( i = 0; i < 1232; i++ ) upp.ppstr.str4[i] = 0;

/* Extract orbit number and burst number */

      orbit = atoi( b_head_.orbit );
      nb = var_local_.burst_num;

/* part 1 of processing parameters which are good for both projection */

	  strcpy ( upp.pp.sfdu.prime_label, "NJPL1I000" );
          strncat ( upp.pp.sfdu.prime_label, b_head_.ptype, 3 );
          strcpy ( upp.pp.sfdu.prime_length, "00001295" );
	  upp.pp.sfdu.second_label = 4;
	  upp.pp.sfdu.second_length = 11;
	  upp.pp.sfdu.orbit_num = orbit;
	  if ( var_local_.ipj == 2 | var_local_.ipj == 4 ) {
		upp.pp.sfdu.data_class = 68;
	  }
	  else {
		upp.pp.sfdu.data_class = 4;
	  }
	  upp.pp.sfdu.data_ann_length = 7;
	  upp.pp.sfdu.time_tag.mod210 = sar_stat_.time_tag_mod210[nb-1];
	  for ( i = 0; i < 3; i++ ) {
	  upp.pp.sfdu.time_tag.rim[i] = sar_stat_.time_tag_rim[nb-1][i];
	  };
	  upp.pp.sfdu.time_tag.mod91 = sar_stat_.time_tag_mod91[nb-1];
	  upp.pp.sfdu.time_tag.mod10 = sar_stat_.time_tag_mod10[nb-1];

	upp.pp.data.gen.burst_num = nb;
	upp.pp.data.gen.burst_start = pp_time_.burst_start[nb-1];
        upp.pp.data.gen.burst_ref = pp_time_.burst_ref[nb-1];
        upp.pp.data.gen.burst_center = pp_time_.burst_center[nb-1];
        upp.pp.data.gen.echo_delay = pp_time_.echo_delay[nb-1];
	upp.pp.data.gen.test = sar_stat_.test[nb-1];
	upp.pp.data.gen.anomaly = sar_stat_.anomaly[nb-1];
	upp.pp.data.gen.error = sar_stat_.error[nb-1];
	upp.pp.data.gen.projection = var_local_.ipj;

	upp.pp.data.ssp.sc_x_j2000 = pp_ssp_.sc_x_j2000[nb-1];
	upp.pp.data.ssp.sc_y_j2000 = pp_ssp_.sc_y_j2000[nb-1];
	upp.pp.data.ssp.sc_z_j2000 = pp_ssp_.sc_z_j2000[nb-1];
	upp.pp.data.ssp.sc_x_vbf = pp_ssp_.sc_x_vbf[nb-1];
	upp.pp.data.ssp.sc_y_vbf = pp_ssp_.sc_y_vbf[nb-1];
	upp.pp.data.ssp.sc_z_vbf = pp_ssp_.sc_z_vbf[nb-1];

	upp.pp.data.ssp.sc_vx_j2000 = pp_ssp_.sc_vx_j2000[nb-1];
	upp.pp.data.ssp.sc_vy_j2000 = pp_ssp_.sc_vy_j2000[nb-1];
	upp.pp.data.ssp.sc_vz_j2000 = pp_ssp_.sc_vz_j2000[nb-1];
	upp.pp.data.ssp.sc_vx_vbf = pp_ssp_.sc_vx_vbf[nb-1];
	upp.pp.data.ssp.sc_vy_vbf = pp_ssp_.sc_vy_vbf[nb-1];
	upp.pp.data.ssp.sc_vz_vbf = pp_ssp_.sc_vz_vbf[nb-1];

	upp.pp.data.ssp.sc_ax_j2000 = pp_ssp_.sc_ax_j2000[nb-1];
	upp.pp.data.ssp.sc_ay_j2000 = pp_ssp_.sc_ay_j2000[nb-1];
	upp.pp.data.ssp.sc_az_j2000 = pp_ssp_.sc_az_j2000[nb-1];

	upp.pp.data.ssp.sc_ax_vbf = pp_ssp_.sc_ax_j2000[nb-1];
	upp.pp.data.ssp.sc_ay_vbf = pp_ssp_.sc_ay_j2000[nb-1];
	upp.pp.data.ssp.sc_az_vbf = pp_ssp_.sc_az_j2000[nb-1];

	upp.pp.data.ssp.q1 = pp_ssp_.q1[nb-1];
	upp.pp.data.ssp.q2 = pp_ssp_.q2[nb-1];
	upp.pp.data.ssp.q3 = pp_ssp_.q3[nb-1];
	upp.pp.data.ssp.q4 = pp_ssp_.q4[nb-1];

	upp.pp.data.ssp.delta_q1 = pp_ssp_.delta_q1[nb-1];
	upp.pp.data.ssp.delta_q2 = pp_ssp_.delta_q2[nb-1];
	upp.pp.data.ssp.delta_q3 = pp_ssp_.delta_q3[nb-1];
	upp.pp.data.ssp.delta_q4 = pp_ssp_.delta_q4[nb-1];

	upp.pp.data.ssp.ubor_x_vme = pp_ssp_.ubor_x_vme[nb-1];
	upp.pp.data.ssp.ubor_y_vme = pp_ssp_.ubor_y_vme[nb-1];
	upp.pp.data.ssp.ubor_z_vme = pp_ssp_.ubor_z_vme[nb-1];

	upp.pp.data.ssp.ubor_x_vbf = pp_ssp_.ubor_x_vbf[nb-1];
	upp.pp.data.ssp.ubor_y_vbf = pp_ssp_.ubor_y_vbf[nb-1];
	upp.pp.data.ssp.ubor_z_vbf = pp_ssp_.ubor_z_vbf[nb-1];

	upp.pp.data.ssp.look_ang = pp_ssp_.look_ang[nb-1];

	upp.pp.data.bip.bip_x_vbf = pp_bip_.bip_x_vbf[nb-1];
	upp.pp.data.bip.bip_y_vbf = pp_bip_.bip_y_vbf[nb-1];
	upp.pp.data.bip.bip_z_vbf = pp_bip_.bip_z_vbf[nb-1];

        upp.pp.data.bip.bip_lon = pp_bip_.bip_lon[nb-1];
	upp.pp.data.bip.bip_lat = pp_bip_.bip_lat[nb-1];
	upp.pp.data.bip.bip_elev = pp_bip_.bip_elev[nb-1];

	upp.pp.data.bip.bip_inc_ang = pp_bip_.bip_inc_ang[nb-1];
	upp.pp.data.bip.bip_app_rg = pp_bip_.bip_app_rg[nb-1];

	upp.pp.data.bip.bip_fd = pp_bip_.bip_fd[nb-1];
	upp.pp.data.bip.bip_fd_drift = pp_bip_.bip_fd_drift[nb-1];

	upp.pp.data.mrp.mrp_incang = pp_mrp_.mrp_incang[nb-1];
	upp.pp.data.mrp.mrp_bs_coef = pp_mrp_.mrp_bs_coef[nb-1];
	upp.pp.data.mrp.mrp_lat = pp_mrp_.mrp_lat[nb-1];
   	upp.pp.data.mrp.mrp_lon = pp_mrp_.mrp_lon[nb-1];

	upp.pp.data.mrp.mrp_elev = pp_mrp_.mrp_elev[nb-1];
    	upp.pp.data.mrp.sample1_app_rg = pp_mrp_.sample1_app_rg[nb-1];
	upp.pp.data.mrp.mrp_app_rg = pp_mrp_.mrp_app_rg[nb-1];

	upp.pp.data.mrp.mrp_fd = pp_mrp_.mrp_fd[nb-1];
    	upp.pp.data.mrp.mrp_fr = pp_mrp_.mrp_fr[nb-1];

	upp.pp.data.mrp.mrp_x_vme = pp_mrp_.mrp_x_vme[nb-1];
	upp.pp.data.mrp.mrp_y_vme = pp_mrp_.mrp_y_vme[nb-1];
	upp.pp.data.mrp.mrp_z_vme = pp_mrp_.mrp_z_vme[nb-1];

/* part 2 of processing parameters which require determination of projection */
/* Fill in the parameters which values are extracted from EDR files */
/* or processor constants */

      upp.pp.data.brcomp.sensor_proc_gain = var_local_.ksp;
      upp.pp.data.brcomp.rg_f = var_local_.nr;
      upp.pp.data.brcomp.az_f = var_local_.na;
      upp.pp.data.brcomp.n_pulses = var_local_.np;
      upp.pp.data.brcomp.baq_sf = var_local_.gbaq;

	upp.pp.data.sensor.trans_state = var_local_.txu_a_state;
	upp.pp.data.sensor.receive_state = var_local_.rxu_a_state;
	upp.pp.data.sensor.onu_state = var_local_.onu_a_state;
	upp.pp.data.sensor.trans_a_temp = var_local_.t_t1_a;
	upp.pp.data.sensor.receive_a_temp = var_local_.t_rx_a;
	upp.pp.data.sensor.onu_a_temp = var_local_.t_os_a;
	upp.pp.data.sensor.trans_b_temp = var_local_.t_t1_b;
	upp.pp.data.sensor.receive_b_temp = var_local_.t_rx_b;
	upp.pp.data.sensor.onu_b_temp = var_local_.t_os_b;
	upp.pp.data.sensor.cable_1_temp = var_local_.t_cable1;
	upp.pp.data.sensor.cable_2_temp = var_local_.t_cable2;
	upp.pp.data.sensor.cable_3_temp = var_local_.t_cable3;
	upp.pp.data.sensor.cable_4_temp = var_local_.t_cable4;
	upp.pp.data.sensor.cable_5_temp = var_local_.t_cable5;

      backscatter_( &upp.pp.data.mrp.mrp_incang,
			&upp.pp.data.rcomp.sigma22);

      upp.pp.data.bs.prf = var_local_.prf;
      upp.pp.data.bs.npulses = var_local_.np;
      upp.pp.data.bs.nsamples = var_local_.ns;
      upp.pp.data.bs.pbw = var_local_.pbw;

      upp.pp.data.pm.min_looks = var_local_.min_lk;

	for ( i = 0; i <  24; i++ ) {
         upp.pp.data.pm.thresh[i] = var_local_.thresh[i];
	};

      if ( upp.pp.data.gen.test == 0 && upp.pp.data.gen.anomaly == 0 &&
	   upp.pp.data.gen.error == 0 ) {

      upp.pp.data.brcomp.t_grg_cf = var_local_.cr0;
      upp.pp.data.brcomp.fd_at_cf = var_local_.cd;
      upp.pp.data.brcomp.ns_redund_gain_cf = var_local_.goff;

      upp.pp.data.brcomp.trans_pow_cf = var_local_.ptr;
      upp.pp.data.brcomp.rec_gain_cf = var_local_.gr;

      upp.pp.data.dcs.rg_ref_ndx = var_local_.irg;
      upp.pp.data.dcs.abs_rgwalk = var_local_.nw;
      upp.pp.data.dcs.rgwalk_0 = var_local_.d0_rw;
      upp.pp.data.dcs.rgwalk_1 = var_local_.d1_rw;

	for ( i = 0; i < 3; i++ )
	   for ( j = 0; j < 3; j++ ) {
         upp.pp.data.rcomp.rel_rg[i][j] = var_local_.dr_rg[i][j];
         upp.pp.data.rcomp.rel_fd[i][j] = var_local_.dfd_rg[i][j];
         upp.pp.data.rcomp.c1[i][j] = var_local_.c1_rg[i][j] / 75.;
         upp.pp.data.rcomp.c2[i][j] = var_local_.c2_rg[i][j] / 75.;
         upp.pp.data.rcomp.sc_d[i][j] = var_local_.sc_d[i][j];
         upp.pp.data.rcomp.bor_elang[i][j] = var_local_.ange_rg[i][j];
         upp.pp.data.rcomp.bor_hang[i][j] = var_local_.angh_rg[i][j];
         upp.pp.data.rcomp.ant_gain[i][j] = var_local_.ant_gain[i][j];

	 c_pow_double = var_local_.c_pow; /* L.Chen : pow require double */

/* Lawrence Chen 1/28/94
	
	 upp.pp.data.rcomp.rcomp[i][j] = 
		var_local_.c_rg[i][j]*pow(2, var_local_.c_pow);
*/
 
         upp.pp.data.rcomp.rcomp[i][j] =
		var_local_.c_rg[i][j]*pow(2.0, c_pow_double ); /* L. Chen */

         upp.pp.data.rcomp.c_in_fd[i][j] = var_local_.mu_r [2-i][2-j];

         upp.pp.data.geo.c1[i][j] = var_local_.c1_g[i][j] / 75.;
         upp.pp.data.geo.c2[i][j] = var_local_.c2_g[i][j] / 75.;
         upp.pp.data.geo.elev[i][j] = var_local_.e_g [i][j];
         upp.pp.data.geo.rel_rg[i][j] = var_local_.dr_g[i][j];
         upp.pp.data.geo.rel_fd[i][j] = var_local_.dfd_g [i][j];
         upp.pp.data.geo.c_in_c2[i][j] = var_local_.mu_g[2-i][2-j];
         upp.pp.data.geo.c_in_c1[i][j] = var_local_.mu_a[2-i][2-j];
	};

      upp.pp.data.rcomp.rel_rg[1][1] = var_local_.r_rg[1][1];
      upp.pp.data.rcomp.rel_fd[1][1] = var_local_.fd_rg[1][1];

      upp.pp.data.geo.rel_rg[1][1] = var_local_.r_g[1][1];
      upp.pp.data.geo.rel_fd[1][1] = var_local_.fd_g [1][1];

      upp.pp.data.framelet.rg[0][0] = var_local_.r_lo;
      upp.pp.data.framelet.rg[0][1] = var_local_.r_hi;
      upp.pp.data.framelet.rg[1][0] = var_local_.r_lo;
      upp.pp.data.framelet.rg[1][1] = var_local_.r_hi;

      upp.pp.data.framelet.fd[0][0] = var_local_.fd_lo;
      upp.pp.data.framelet.fd[0][1] = var_local_.fd_lo;
      upp.pp.data.framelet.fd[1][0] = var_local_.fd_hi;
      upp.pp.data.framelet.fd[1][1] = var_local_.fd_hi;

	for ( i = 0; i <  2; i++ )
	for ( j = 0; j <  2; j++ ) {
         upp.pp.data.framelet.c1[i][j] =
                   ( var_local_.dc1_fc[i][j] +
		     var_local_.c1_g[1][1] ) / 75.;
         upp.pp.data.framelet.c2[i][j] =
                   ( var_local_.dc2_fc[i][j] +
                     var_local_.c2_g[1][1] ) / 75.;
	};

      upp.pp.data.bs.prs = var_local_.dlta_r /
	 sin(upp.pp.data.mrp.mrp_incang*var_local_.pi/180.);

      upp.pp.data.frame.c2_min = var_local_.c2min/75.;
      upp.pp.data.frame.c2_max = var_local_.c2max/75.;
      upp.pp.data.frame.c2_start = var_local_.c2start/75.;
      upp.pp.data.frame.c2_end = var_local_.c2start/75. + 511;

      if ( var_local_.ipj == 1 | var_local_.ipj == 3) {
	upp.pp.data.frame.c1_fdmax = var_local_.c1min/75.;
	upp.pp.data.frame.c1_fdmin = var_local_.c1max/75.;
	}
      else {
	upp.pp.data.frame.c1_fdmax = var_local_.c1max/75.;
	upp.pp.data.frame.c1_fdmin = var_local_.c1min/75.;
	};

      upp.pp.data.frame.c1_offset = var_local_.ixstart;
      upp.pp.data.frame.c2_offset = var_local_.iystart;
      upp.pp.data.frame.r_offset = var_local_.r_offset;
      upp.pp.data.frame.set_no = var_local_.set_no;

    } /* endif of test, anomaly, & error checking */
/*
     printf ("pp.sfdu.prime_label= %.12s \n",
             upp.pp.sfdu.prime_label);
     printf ("pp.sfdu.prime_length= %.8s \n",
             upp.pp.sfdu.prime_length);
     printf ("pp.sfdu.second_label= %d \n",
             upp.pp.sfdu.second_label);
     printf ("pp.sfdu.second_length= %d \n",
             upp.pp.sfdu.second_length);
     printf ("pp.sfdu.orbit_num= %d \n",
             upp.pp.sfdu.orbit_num);
     printf ("pp.sfdu.data_class= %d \n",
             upp.pp.sfdu.data_class);
     printf ("pp.sfdu.data_ann_length = %d \n",
             upp.pp.sfdu.data_ann_length);
     printf ("pp.sfdu.time_tag.mod210= %d \n",
             upp.pp.sfdu.time_tag.mod210);
	for ( i = 0; i < 3; i++ ){
	printf( "pp.sfdu.time_tag.rim[%d]= %d \n", i,
             upp.pp.sfdu.time_tag.rim[i]);
	};
     printf ("pp.sfdu.time_tag.mod91= %d \n",
             upp.pp.sfdu.time_tag.mod91);
     printf ("pp.sfdu.time_tag.mod10= %d \n",
             upp.pp.sfdu.time_tag.mod10);

	printf ("pp.data.gen.burst_num = %d \n",
               upp.pp.data.gen.burst_num);
	printf ("pp.data.gen.burst_start = %g \n",
               upp.pp.data.gen.burst_start );
	printf ("pp.data.gen.burst_ref = %g \n",
               upp.pp.data.gen.burst_ref );
	printf ("pp.data.gen.burst_center = %g \n",
               upp.pp.data.gen.burst_center );
	printf ("pp.data.gen.echo_delay = %g \n",
               upp.pp.data.gen.echo_delay);

	printf ("pp.data.gen.test = %d \n",
               upp.pp.data.gen.test);
	printf ("pp.data.gen.anomaly = %d \n",
               upp.pp.data.gen.anomaly );
	printf ("pp.data.gen.error = %d \n",
               upp.pp.data.gen.error );
	printf ("pp.data.gen.projection = %d \n",
               upp.pp.data.gen.projection);

	printf ("pp.data.ssp.sc_x_j2000 = %g \n",
               upp.pp.data.ssp.sc_x_j2000 );
	printf ("pp.data.ssp.sc_y_j2000 = %g \n",
               upp.pp.data.ssp.sc_y_j2000);
	printf ("pp.data.ssp.sc_z_j2000 = %g \n",
               upp.pp.data.ssp.sc_z_j2000 );
	printf ("pp.data.ssp.sc_x_vbf = %g \n",
               upp.pp.data.ssp.sc_x_vbf );
	printf ("pp.data.ssp.sc_y_vbf = %g \n",
               upp.pp.data.ssp.sc_y_vbf );
	printf ("pp.data.ssp.sc_z_vbf = %g \n",
               upp.pp.data.ssp.sc_z_vbf );

	printf ("pp.data.ssp.sc_vx_j2000 = %g \n",
               upp.pp.data.ssp.sc_vx_j2000);
	printf ("pp.data.ssp.sc_vy_j2000 = %g \n",
               upp.pp.data.ssp.sc_vy_j2000 );
	printf ("pp.data.ssp.sc_vz_j2000 = %g \n",
               upp.pp.data.ssp.sc_vz_j2000 );

	printf ("pp.data.ssp.sc_vx_vbf = %g \n",
               upp.pp.data.ssp.sc_vx_vbf);
	printf ("pp.data.ssp.sc_vy_vbf = %g \n",
               upp.pp.data.ssp.sc_vy_vbf );
	printf ("pp.data.ssp.sc_vz_vbf = %g \n",
               upp.pp.data.ssp.sc_vz_vbf );

	printf ("pp.data.ssp.sc_ax_j2000 = %g \n",
               upp.pp.data.ssp.sc_ax_j2000);
	printf ("pp.data.ssp.sc_ay_j2000 = %g \n",
               upp.pp.data.ssp.sc_ay_j2000);
	printf ("pp.data.ssp.sc_az_j2000 = %g \n",
               upp.pp.data.ssp.sc_az_j2000);

	printf ("pp.data.ssp.sc_ax_vbf = %g \n",
               upp.pp.data.ssp.sc_ax_vbf );
	printf ("pp.data.ssp.sc_ay_vbf = %g \n",
               upp.pp.data.ssp.sc_ay_vbf );
	printf ("pp.data.ssp.sc_az_vbf = %g \n",
               upp.pp.data.ssp.sc_az_vbf);

	printf ("pp.data.ssp.q1 = %g \n", upp.pp.data.ssp.q1);
	printf ("pp.data.ssp.q2 = %g \n", upp.pp.data.ssp.q2 );
	printf ("pp.data.ssp.q3 = %g \n", upp.pp.data.ssp.q3);
	printf ("pp.data.ssp.q4 = %g \n", upp.pp.data.ssp.q4 );

	printf ("pp.data.ssp.delta_q1 = %g \n",
               upp.pp.data.ssp.delta_q1 );
	printf ("pp.data.ssp.delta_q2 = %g \n",
               upp.pp.data.ssp.delta_q2 );
	printf ("pp.data.ssp.delta_q3 = %g \n",
               upp.pp.data.ssp.delta_q3 );
	printf ("pp.data.ssp.delta_q4 = %g \n",
               upp.pp.data.ssp.delta_q4 );

	printf ("pp.data.ssp.ubor_x_vme = %g \n",
               upp.pp.data.ssp.ubor_x_vme );
	printf ("pp.data.ssp.ubor_y_vme = %g \n",
               upp.pp.data.ssp.ubor_y_vme );
	printf ("pp.data.ssp.ubor_z_vme = %g \n",
               upp.pp.data.ssp.ubor_z_vme );
	printf ("pp.data.ssp.ubor_x_vbf = %g \n",
               upp.pp.data.ssp.ubor_x_vbf );
	printf ("pp.data.ssp.ubor_y_vbf = %g \n",
               upp.pp.data.ssp.ubor_y_vbf);
	printf ("pp.data.ssp.ubor_z_vbf = %g \n",
               upp.pp.data.ssp.ubor_z_vbf);

	printf ("pp.data.ssp.look_ang = %g \n",
               upp.pp.data.ssp.look_ang );

	printf ("pp.data.bip.bip_x_vbf = %g \n",
               upp.pp.data.bip.bip_x_vbf );
	printf ("pp.data.bip.bip_y_vbf = %g \n",
               upp.pp.data.bip.bip_y_vbf );
	printf ("pp.data.bip.bip_z_vbf = %g \n",
               upp.pp.data.bip.bip_z_vbf );

	printf ("pp.data.bip.bip_lon = %g \n",
               upp.pp.data.bip.bip_lon );
	printf ("pp.data.bip.bip_lat = %g \n",
               upp.pp.data.bip.bip_lat );
	printf ("pp.data.bip.bip_elev = %g \n",
               upp.pp.data.bip.bip_elev );

	printf ("pp.data.bip.bip_inc_ang = %g \n",
               upp.pp.data.bip.bip_inc_ang );
	printf ("pp.data.bip.bip_app_rg = %g \n",
               upp.pp.data.bip.bip_app_rg );

	printf ("pp.data.bip.bip_fd = %g \n",
               upp.pp.data.bip.bip_fd );
	printf ("pp.data.bip.bip_fd_drift = %g \n",
               upp.pp.data.bip.bip_fd_drift );

	printf ("pp.data.mrp.mrp_incang = %g \n",
               upp.pp.data.mrp.mrp_incang);
	printf ("pp.data.mrp.mrp_bs_coef = %g \n",
               upp.pp.data.mrp.mrp_bs_coef );
	printf ("pp.data.mrp.mrp_lat = %g \n",
               upp.pp.data.mrp.mrp_lat);
	printf ("pp.data.mrp.mrp_lon = %g \n",
               upp.pp.data.mrp.mrp_lon);
	printf ("pp.data.mrp.mrp_elev = %g \n",
               upp.pp.data.mrp.mrp_elev);

	printf ("pp.data.mrp.sample1_app_rg = %g \n",
               upp.pp.data.mrp.sample1_app_rg );
	printf ("pp.data.mrp.mrp_app_rg = %g \n",
               upp.pp.data.mrp.mrp_app_rg);

	printf ("pp.data.mrp.mrp_fd = %g \n",
               upp.pp.data.mrp.mrp_fd );
	printf ("pp.data.mrp.mrp_fr = %g \n",
               upp.pp.data.mrp.mrp_fr);

	printf ("pp.data.mrp.mrp_x_vme = %g \n",
               upp.pp.data.mrp.mrp_x_vme );
	printf ("pp.data.mrp.mrp_y_vme = %g \n",
               upp.pp.data.mrp.mrp_y_vme );
	printf ("pp.data.mrp.mrp_z_vme = %g \n",
               upp.pp.data.mrp.mrp_z_vme );

      printf ("pp.data.brcomp.sensor_proc_gain = %g \n",
             upp.pp.data.brcomp.sensor_proc_gain );
      printf ("pp.data.brcomp.rg_f = %d \n",
              upp.pp.data.brcomp.rg_f );

      printf ("pp.data.brcomp.az_f = %d \n",
             upp.pp.data.brcomp.az_f );
      printf ("pp.data.brcomp.n_pulses = %d \n",
             upp.pp.data.brcomp.n_pulses );

      printf ("pp.data.brcomp.t_grg_cf = %g \n",
             upp.pp.data.brcomp.t_grg_cf );
      printf ("pp.data.brcomp.fd_at_cf = %g \n",
             upp.pp.data.brcomp.fd_at_cf );
      printf ("pp.data.brcomp.baq_sf = %g \n",
             upp.pp.data.brcomp.baq_sf );

      printf ("pp.data.brcomp.trans_pow_cf = %g \n",
             upp.pp.data.brcomp.trans_pow_cf );
      printf ("pp.data.brcomp.rec_gain_cf = %g \n",
             upp.pp.data.brcomp.rec_gain_cf );
      printf ("pp.data.brcomp.ns_redund_gain_cf = %g \n",
             upp.pp.data.brcomp.ns_redund_gain_cf );


     printf ("pp.data.dcs.rg_ref_ndx = %d \n",
             upp.pp.data.dcs.rg_ref_ndx );
     printf ("pp.data.dcs.abs_rgwalk = %g \n",
             upp.pp.data.dcs.abs_rgwalk );
     printf ("pp.data.dcs.rgwalk_0 = %g \n",
             upp.pp.data.dcs.rgwalk_0 );
     printf ("pp.data.dcs.rgwalk_1 = %g \n",
             upp.pp.data.dcs.rgwalk_1 );


	printf ( "pp.data.sensor.trans_state = %d \n",
          upp.pp.data.sensor.trans_state );
	printf ( "pp.data.sensor.receive_state = %d \n",
	upp.pp.data.sensor.receive_state );
	printf ( "pp.data.sensor.onu_state = %d \n",
           upp.pp.data.sensor.onu_state );
	printf ( "pp.data.sensor.trans_a_temp = %g \n",
           upp.pp.data.sensor.trans_a_temp );
	printf ( "pp.data.sensor.receive_a_temp = %g \n",
    	upp.pp.data.sensor.receive_a_temp );
	printf ( "pp.data.sensor.onu_a_temp = %g \n",
           upp.pp.data.sensor.onu_a_temp );
	printf ( "pp.data.sensor.trans_b_temp = %g \n",
   	upp.pp.data.sensor.trans_b_temp );
	printf ( "pp.data.sensor.receive_b_temp = %g \n",
 	upp.pp.data.sensor.receive_b_temp );
	printf ( "pp.data.sensor.onu_b_temp = %g \n",
           upp.pp.data.sensor.onu_b_temp );
	printf ( "pp.data.sensor.cable_1_temp = %g \n",
	upp.pp.data.sensor.cable_1_temp );
	printf ( "pp.data.sensor.cable_2_temp = %g \n",
	upp.pp.data.sensor.cable_2_temp );
	printf ( "pp.data.sensor.cable_3_temp = %g \n",
	upp.pp.data.sensor.cable_3_temp);
	printf ( "pp.data.sensor.cable_4_temp = %g \n",
	upp.pp.data.sensor.cable_4_temp );
	printf ( "pp.data.sensor.cable_5_temp = %g \n",
	upp.pp.data.sensor.cable_5_temp );


    	for ( i = 0; i < 3; i++ )
    	for ( j = 0; j < 3; j++ ) {

	printf ("pp.data.rcomp.rel_rg[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.rel_rg[i][j]);
	printf ("pp.data.rcomp.rel_fd[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.rel_fd[i][j]);
	printf ("pp.data.rcomp.c1[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.c1[i][j]);
	printf ("pp.data.rcomp.c2[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.c2[i][j]);
	printf ("pp.data.rcomp.sc_d[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.sc_d[i][j]);
	printf ("pp.data.rcomp.bor_elang[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.bor_elang[i][j] );
	printf ("pp.data.rcomp.bor_hang[%d][%d] = %g \n",
       	     i, j, upp.pp.data.rcomp.bor_hang[i][j] );
	printf ("pp.data.rcomp.ant_gain[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.ant_gain[i][j] );
	printf ("pp.data.rcomp.rcomp[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.rcomp[i][j]);
	printf ("pp.data.rcomp.c_in_fd[%d][%d] = %g \n",
               i, j, upp.pp.data.rcomp.c_in_fd[i][j]);

	}
	printf ("pp.data.rcomp.sigma22 = %g \n",
               upp.pp.data.rcomp.sigma22 );

    	for ( i = 0; i < 3; i++ )
    	for ( j = 0; j < 3; j++ ) {

	printf ("pp.data.geo.c1[%d][%d]= %d \n",
               i, j, upp.pp.data.geo.c1[i][j] );
	printf ("pp.data.geo.c2[%d][%d]= %d \n",
               i, j, upp.pp.data.geo.c2[i][j] );
	printf ("pp.data.geo.elev[%d][%d]= %g \n",
               i, j, upp.pp.data.geo.elev[i][j]);
	printf ("pp.data.geo.rel_rg[%d][%d]= %g \n",
               i, j, upp.pp.data.geo.rel_rg[i][j]);
	printf ("pp.data.geo.rel_fd[%d][%d]= %g \n",
               i, j, upp.pp.data.geo.rel_fd[i][j]);
	printf ("pp.data.geo.c_in_c2[%d][%d]= %g \n",
               i, j, upp.pp.data.geo.c_in_c2[i][j] );
	printf ("pp.data.geo.c_in_c1[%d][%d]= %g \n",
               i, j, upp.pp.data.geo.c_in_c1[i][j]);
	};

    	for ( i = 0; i < 2; i++ )
    	for ( j = 0; j < 2; j++ ) {

	printf ("pp.data.framelet.rg[%d][%d] = %g \n",
               i, j, upp.pp.data.framelet.rg[i][j] );
	printf ("pp.data.framelet.fd[%d][%d] = %g \n",
               i, j, upp.pp.data.framelet.fd[i][j] );
	printf ("pp.data.framelet.c1[%d][%d] = %d \n",
               i, j, upp.pp.data.framelet.c1[i][j] );
	printf ("pp.data.framelet.c2[%d][%d]= %d \n",
               i, j, upp.pp.data.framelet.c2[i][j] );
	};

	printf ("pp.data.bs.prf = %g \n", upp.pp.data.bs.prf );
	printf ("pp.data.bs.npulses = %d \n",
               upp.pp.data.bs.npulses );
	printf ("pp.data.bs.nsamples = %d \n",
               upp.pp.data.bs.nsamples);
	printf ("pp.data.bs.pbw = %g \n", upp.pp.data.bs.pbw);
	printf ("pp.data.bs.prs = %g \n", upp.pp.data.bs.prs);
	printf ("pp.data.pm.min_looks = %d \n",
               upp.pp.data.pm.min_looks );

	for ( i = 0; i < 24; i++ ) {
	printf ("pp.data.pm.thresh( %d ) = %d \n",
               i, upp.pp.data.pm.thresh[i] );
	};

	printf ("pp.data.frame.c1_fdmax = %d \n",
               upp.pp.data.frame.c1_fdmax );
	printf ("pp.data.frame.c2_min = %d \n",
               upp.pp.data.frame.c2_min );
	printf ("pp.data.frame.c1_fdmin = %d \n",
               upp.pp.data.frame.c1_fdmin );
	printf ("pp.data.frame.c2_max = %d \n",
               upp.pp.data.frame.c2_max );

	printf ("pp.data.frame.c1_offset = %d \n",
               upp.pp.data.frame.c1_offset );
	printf ("pp.data.frame.c2_offset = %d \n",
               upp.pp.data.frame.c2_offset );
*/
      if ( nb % 1000 == 0 ) printf ("c_dmp_pp_2: @burst %d.\n", nb);

	for ( i = 0; i < 35; i++ ) ppbuf[i] = upp.ppstr.str1[i];
	for ( i = 0; i < 4; i++ ) ppbuf[i+35] = upp.ppstr.str2[i];
	for ( i = 0; i < 44; i++ ) ppbuf[i+39] = upp.ppstr.str3[i];
	for ( i = 0; i < 1232; i++ ) ppbuf[i+83] = upp.ppstr.str4[i];
}
