C========================================================================
C c_get_pp.f
C------------------------------------------------------------------------
      subroutine c_get_pp ( nb )
C
C Abstract:
C	Transfers data from processing parameters structure to
C       the local variables
C
	implicit none

C Declarations:
C	Passing Parameters: 

      integer nb                        

C	Constant Parameters:

      integer max_rec
      parameter ( max_rec = 8600 ) 

C	Include files:

      include '../../../inc/pp_time'
      include '../../../inc/pp_ssp'
      include '../../../inc/sar_stat'
      include '../../../inc/var_local'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	nb		I		burst counter
C
C Constant Parameters:
C	max_rec - maximum number of bursts	
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	see include file listing.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

d     write (*,*) 'C_GET_PP: nb = ', nb

C>>  Transfer to local variables

      t_d = pp_time_echo_delay( nb )       ! only for pp file
      t_m = pp_time_burst_center( nb )     ! only for pp file
      t_b = pp_time_burst_ref( nb )        ! for pp file and pp computation
      tb_tp = t_b - t_p                      
      tm_tb = t_m - t_b                      

      prf = fs / sar_stat_prf_code(nb)
      np = sar_stat_n_echos(nb)
      ns = 2 * sar_stat_range_gate(nb)

      dqm(1) = pp_ssp_delta_q1( nb ) 
      dqm(2) = pp_ssp_delta_q2( nb )
      dqm(3) = pp_ssp_delta_q3( nb )
      dqm(4) = pp_ssp_delta_q4( nb )

d     write (*,*) 't_b, t_m, t_d, tb-tp, tm-tb=', 
d    .       t_b, t_m, t_d, tb_tp, tm_tb
d     write (*,*) 'dqm=', dqm

d     write (*,*) 'End of C_GET_PP.'

      return
      end
