C========================================================================
C c_get_ra.f
C------------------------------------------------------------------------
	SUBROUTINE c_get_ra( burst )
C
C Abstract:
C	Transfers delta quaternion parameters from pp 
C	to var_local common block.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	INTEGER*4	burst

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/pp_ssp'
	include '../../../inc/var_local'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	burst		I		burst counter
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	pp_ssp		I		see include file pp_ssp
C	var_local	O		see include file var_local
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	use delta quaternion parameters.
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	dqm( 1 ) = pp_ssp_delta_q1( burst )
	dqm( 2 ) = pp_ssp_delta_q2( burst )
	dqm( 3 ) = pp_ssp_delta_q3( burst )
	dqm( 4 ) = pp_ssp_delta_q4( burst )

	RETURN
	END
