C========================================================================
C c_po.f
C------------------------------------------------------------------------
        subroutine c_po
C
C Abstract:
C	 Generate the per-orbit (file_12) buffer 
C
	implicit none

C Declarations:
C	Passing Parameters: None.
C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/var_local'
	include '../../../inc/po'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	see include file listing	
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	Writes BIDR per-orbit file.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

        integer lun, channel, initdk

	PO_SFDU_PRIME_LABEL = 'NJPL1I000'
	PO_SFDU_PRIME_LENGTH = '00000520'
	PO_SFDU_SECOND_LABEL = 1
	PO_SFDU_SECOND_LENGTH = 4
	PO_SFDU_DATA_CLASS = 1
	PO_SFDU_DATA_ANN_LENGTH = 0

	PO_DATA_GEN_LEFT_LOOKING = IRL
        if ( lon0 .ge. 0 ) then                  ! clw
	PO_DATA_PROJP_SIN_REF_LON = LON0
        else
	PO_DATA_PROJP_SIN_REF_LON = LON0 + 360
        endif
	PO_DATA_PROJP_XHAT_X_VBF = XHAT_VBF(1)
	PO_DATA_PROJP_XHAT_Y_VBF = XHAT_VBF(2)
	PO_DATA_PROJP_XHAT_Z_VBF = XHAT_VBF(3)
	PO_DATA_PROJP_YHAT_X_VBF = YHAT_VBF(1)
	PO_DATA_PROJP_YHAT_Y_VBF = YHAT_VBF(2)
	PO_DATA_PROJP_YHAT_Z_VBF = YHAT_VBF(3)
	PO_DATA_PROJP_ZHAT_X_VBF = ZHAT_VBF(1)
	PO_DATA_PROJP_ZHAT_Y_VBF = ZHAT_VBF(2)
	PO_DATA_PROJP_ZHAT_Z_VBF = ZHAT_VBF(3)
	PO_DATA_PROJP_OBL_REF_LON = ALPHA1
	PO_DATA_PROJP_NEG_OBL_REF_LAT = ALPHA2

	end
