C========================================================================
C c_pp_2.f 
C------------------------------------------------------------------------
	subroutine c_pp_2 ( start_burst, end_burst, ppbuf )
C
C Abstract:
C	For every normal burst, it will call a sequence of procedures for
C	computation of second part of pp data block.  Those procedures will
C	be c_get_pp_2, referenc_control, geometric_parameters, 
C	radiometric_parameters, and framelet_parameters, and c_dmp_pp_2.

	implicit none

C Declarations:
C	Passing Parameters: 

	integer start_burst, end_burst
	byte ppbuf(*)

C	Constant Parameters: None
C	Include files:

	include '../../../inc/sar_stat'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	start_burst	I		first burst to process
C	end_burst	I		last burst to process
C	buflen		I		size of ppbuf
C	ppbuf		O		pp buffer
C
C Constant Parameters:
C
C Common blocks:
C	Name		I/O		Descript None.ion
C       ----		---		------------
C 	sar_stat	I		see include file "sar_stat"	
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	None.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW).
C
C========================================================================
C Local Variables:

      integer nb, offset

      write (*,*) 'C_PP_2: start=', start_burst,
	1		 ' end=', end_burst
      offset = 1
      do nb = start_burst, end_burst

         call c_get_pp_2 ( nb )

      	 if ( sar_stat_anomaly( nb ) .eq. 1 .or.
     .        sar_stat_error( nb ) .eq. 1  .or.
     .        sar_stat_test( nb ) .eq. 1 ) goto 200

         call Reference_control
         call geometric_parameters
         call radiometric_parameters
         call Framelet_Parameters

200	 continue

d	 call c_var_local
         call c_dmp_pp_2 ( ppbuf(offset) )
	 offset = offset + 1315			! pp record size = 1315 bytes

      enddo

      return
      end
