#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "../../../inc/ppinc.h"
#include "../../../inc/rad.h"

extern struct b_head b_head_;
extern struct var_local var_local_;

/* Lawrence Chen 12/22/93
double ieee8_vaxd_();
float ieee4_vaxf_();
*/

double sun2vaxr8_();
float sun2vaxr4d();

void c_put_ra_( ra_in, type, data, calib )
        char *ra_in;
	int *type;
	short *data, *calib;	
{
	union ura ura;
	int cold_sky;
	int i, orbit;

	cold_sky = *type - 1;

	strcpy ( ura.ra.sfdu.prime_label, "NJPL1I000" );
        strncat ( ura.ra.sfdu.prime_label, b_head_.ptype, 3 );
        strcpy ( ura.ra.sfdu.prime_length, "00000108" );

	ura.ra.sfdu.second_label = 8;
	ura.ra.sfdu.second_length = 92;

	orbit = atoi( b_head_.orbit );
	ura.ra.sfdu.orbit_num = orbit;
	ura.ra.sfdu.data_ann_length = 88;

	ura.ra.sfdu.mid_rad_scet = var_local_.t_sample;

	ura.ra.sfdu.sc_x_vbf = var_local_.x_s[0];
	ura.ra.sfdu.sc_y_vbf = var_local_.x_s[1];
	ura.ra.sfdu.sc_z_vbf = var_local_.x_s[2];

	ura.ra.sfdu.rcvr_gain_factor = var_local_.gr;
	ura.ra.sfdu.rcvr_temp = var_local_.t_op;

	ura.ra.sfdu.coef_a = var_local_.coef_a;
	ura.ra.sfdu.coef_b = var_local_.coef_b;
	ura.ra.sfdu.coef_c = var_local_.coef_c;

	ura.ra.sfdu.sensor_in_noise_temp = var_local_.t_si;

	ura.ra.sfdu.cable1_temp = var_local_.t_cable1;
	ura.ra.sfdu.cable2_temp = var_local_.t_cable2;
	ura.ra.sfdu.cable3_temp = var_local_.t_cable3;
	ura.ra.sfdu.cable4_temp = var_local_.t_cable4;
	ura.ra.sfdu.cable5_temp = var_local_.t_cable5;

	ura.ra.data.raw_value = *data;
	ura.ra.data.raw_calib_value = *calib;
	ura.ra.data.t_antenna_obs = var_local_.t_antenna_obs;

	if ( cold_sky ) {
		ura.ra.sfdu.data_class = 40;
		ura.ra.sfdu.u.q.q1 = var_local_.qm[0];
		ura.ra.sfdu.u.q.q2 = var_local_.qm[1];
		ura.ra.sfdu.u.q.q3 = var_local_.qm[2];
		ura.ra.sfdu.u.q.q4 = var_local_.qm[3];
		ura.ra.sfdu.t_emission = 0.0;
		ura.ra.sfdu.kappa = 0.0;
		ura.ra.data.surface_bright_temp = 0.0;
	}
	else {
		ura.ra.sfdu.data_class = 8;
		ura.ra.sfdu.u.rad.rad_lat = var_local_.lat_ra;
		if ( var_local_.lon_ra < 0.0 ) {
		var_local_.lon_ra = var_local_.lon_ra + 360.0;
		};	
		ura.ra.sfdu.u.rad.rad_lon = var_local_.lon_ra;
		ura.ra.sfdu.u.rad.rad_inc_ang = var_local_.anglk_ra;
		ura.ra.sfdu.u.rad.rad_elev =    var_local_.height;
		ura.ra.sfdu.t_emission = var_local_.t_emission;
		ura.ra.sfdu.kappa = var_local_.kappa;
		ura.ra.data.surface_bright_temp = var_local_.t_surface;
	};

/*
     printf("ra.sfdu.prime_label = %.12s       \n", ura.ra.sfdu.prime_label);
     printf("ra.sfdu.prime_length = %.8s      \n", ura.ra.sfdu.prime_length);
     printf("ra.sfdu.second_label = %d      \n", ura.ra.sfdu.second_label);
     printf("ra.sfdu.second_length = %d     \n", ura.ra.sfdu.second_length);
     printf("ra.sfdu.orbit_num = %d         \n", ura.ra.sfdu.orbit_num);
     printf("ra.sfdu.data_class = %d        \n", ura.ra.sfdu.data_class);
     printf("ra.sfdu.data_ann_length = %d   \n", ura.ra.sfdu.data_ann_length);
     printf("ra.sfdu.mid_rad_scet = %g      \n", ura.ra.sfdu.mid_rad_scet);
     printf("ra.sfdu.rad_lat / q1 = %g      \n", ura.ra.sfdu.rad.rad_lat);
     printf("ra.sfdu.rad_lon / q2 = %g      \n", ura.ra.sfdu.rad.rad_lon);
     printf("ra.sfdu.rad_inc_ang / q3 = %g  \n", ura.ra.sfdu.rad.rad_inc_ang);
     printf("ra.sfdu.rad_elev / q4 = %g     \n", ura.ra.sfdu.rad.rad_elev);
     printf("ra.sfdu.sc_x_vbf = %g          \n", ura.ra.sfdu.sc_x_vbf);
     printf("ra.sfdu.sc_y_vbf = %g          \n", ura.ra.sfdu.sc_y_vbf);
     printf("ra.sfdu.sc_z_vbf = %g          \n", ura.ra.sfdu.sc_z_vbf);
     printf("ra.sfdu.rcvr_gain_factor = %g  \n", ura.ra.sfdu.rcvr_gain_factor);
     printf("ra.sfdu.rcvr_temp (Top) = %g   \n", ura.ra.sfdu.rcvr_temp);
     printf("ra.sfdu.coef_a = %g            \n", ura.ra.sfdu.coef_a);
     printf("ra.sfdu.coef_b = %g            \n", ura.ra.sfdu.coef_b);
     printf("ra.sfdu.coef_c = %g            \n", ura.ra.sfdu.coef_c);
     printf("ra.sfdu.sensor_in_noise_temp = %g  \n",
		ura.ra.sfdu.sensor_in_noise_temp);
     printf("ra.sfdu.cable1_temp = %g       \n", ura.ra.sfdu.cable1_temp);
     printf("ra.sfdu.cable2_temp = %g       \n", ura.ra.sfdu.cable2_temp);
     printf("ra.sfdu.cable3_temp = %g       \n", ura.ra.sfdu.cable3_temp);
     printf("ra.sfdu.cable4_temp = %g       \n", ura.ra.sfdu.cable4_temp);
     printf("ra.sfdu.cable5_temp = %g       \n", ura.ra.sfdu.cable5_temp);
     printf("ra.sfdu.T_emission = %g        \n", ura.ra.sfdu.t_emission);
     printf("ra.sfdu.kappa = %g             \n", ura.ra.sfdu.kappa);
     printf("ra.data.raw_value = %d         \n", ura.ra.data.raw_value);
     printf("ra.data.raw_calib_value = %d   \n", ura.ra.data.raw_calib_value);
     printf("ra.data.T_antenna_obs = %g     \n", ura.ra.data.t_antenna_obs);
     printf("ra.data.surface_bright_temp = %g  \n",
		ura.ra.data.surface_bright_temp);
*/
/* convert to VAX floating point */

/* L. Chen 12/22/93

		ura.ra.sfdu.mid_rad_scet = 
			ieee8_vaxd_( &ura.ra.sfdu.mid_rad_scet );
		ura.ra.sfdu.u.rad.rad_lat = 
			ieee4_vaxf_( &ura.ra.sfdu.rad.rad_lat );
		ura.ra.sfdu.u.rad.rad_lon = 
			ieee4_vaxf_( &ura.ra.sfdu.rad.rad_lon );
		ura.ra.sfdu.u.rad.rad_inc_ang = 
			ieee4_vaxf_( &ura.ra.sfdu.rad.rad_inc_ang );
		ura.ra.sfdu.u.rad.rad_elev = 
			ieee4_vaxf_( &ura.ra.sfdu.rad.rad_elev );
		ura.ra.sfdu.sc_x_vbf = 
			ieee4_vaxf_( &ura.ra.sfdu.sc_x_vbf );
		ura.ra.sfdu.sc_y_vbf = 
			ieee4_vaxf_( &ura.ra.sfdu.sc_y_vbf );
		ura.ra.sfdu.sc_z_vbf = 
			ieee4_vaxf_( &ura.ra.sfdu.sc_z_vbf );
		ura.ra.sfdu.rcvr_gain_factor = 
			ieee4_vaxf_( &ura.ra.sfdu.rcvr_gain_factor );
		ura.ra.sfdu.rcvr_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.rcvr_temp );
		ura.ra.sfdu.coef_a = 
			ieee4_vaxf_( &ura.ra.sfdu.coef_a );
		ura.ra.sfdu.coef_b = 
			ieee4_vaxf_( &ura.ra.sfdu.coef_b );
		ura.ra.sfdu.coef_c = 
			ieee4_vaxf_( &ura.ra.sfdu.coef_c );
		ura.ra.sfdu.sensor_in_noise_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.sensor_in_noise_temp );
		ura.ra.sfdu.cable1_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.cable1_temp );
		ura.ra.sfdu.cable2_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.cable2_temp );
		ura.ra.sfdu.cable3_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.cable3_temp );
		ura.ra.sfdu.cable4_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.cable4_temp );
		ura.ra.sfdu.cable5_temp = 
			ieee4_vaxf_( &ura.ra.sfdu.cable5_temp );
		ura.ra.sfdu.t_emission = 
			ieee4_vaxf_( &ura.ra.sfdu.t_emission );
		ura.ra.sfdu.kappa = 
			ieee4_vaxf_( &ura.ra.sfdu.kappa );
		ura.ra.data.t_antenna_obs = 
			ieee4_vaxf_( &ura.ra.data.t_antenna_obs );
		ura.ra.data.surface_bright_temp = 
			ieee4_vaxf_( &ura.ra.data.surface_bright_temp );
*/

/* convert from SUN to VAX floating point */

                ura.ra.sfdu.mid_rad_scet =
                        sun2vaxr8_( &ura.ra.sfdu.mid_rad_scet );
                ura.ra.sfdu.u.rad.rad_lat =
                        sun2vaxr4d( &ura.ra.sfdu.u.rad.rad_lat );
                ura.ra.sfdu.u.rad.rad_lon =
                        sun2vaxr4d( &ura.ra.sfdu.u.rad.rad_lon );
                ura.ra.sfdu.u.rad.rad_inc_ang =
                        sun2vaxr4d( &ura.ra.sfdu.u.rad.rad_inc_ang );
                ura.ra.sfdu.u.rad.rad_elev =
                        sun2vaxr4d( &ura.ra.sfdu.u.rad.rad_elev );
                ura.ra.sfdu.sc_x_vbf =
                        sun2vaxr4d( &ura.ra.sfdu.sc_x_vbf );
                ura.ra.sfdu.sc_y_vbf =
                        sun2vaxr4d( &ura.ra.sfdu.sc_y_vbf );
                ura.ra.sfdu.sc_z_vbf =
                        sun2vaxr4d( &ura.ra.sfdu.sc_z_vbf );
                ura.ra.sfdu.rcvr_gain_factor =
                        sun2vaxr4d( &ura.ra.sfdu.rcvr_gain_factor );
                ura.ra.sfdu.rcvr_temp =
                        sun2vaxr4d( &ura.ra.sfdu.rcvr_temp );
                ura.ra.sfdu.coef_a =
                        sun2vaxr4d( &ura.ra.sfdu.coef_a );
                ura.ra.sfdu.coef_b =
                        sun2vaxr4d( &ura.ra.sfdu.coef_b );
                ura.ra.sfdu.coef_c =
                        sun2vaxr4d( &ura.ra.sfdu.coef_c );
                ura.ra.sfdu.sensor_in_noise_temp =
                        sun2vaxr4d( &ura.ra.sfdu.sensor_in_noise_temp );
                ura.ra.sfdu.cable1_temp =
                        sun2vaxr4d( &ura.ra.sfdu.cable1_temp );
                ura.ra.sfdu.cable2_temp =
                        sun2vaxr4d( &ura.ra.sfdu.cable2_temp );
                ura.ra.sfdu.cable3_temp =
                        sun2vaxr4d( &ura.ra.sfdu.cable3_temp );
                ura.ra.sfdu.cable4_temp =
                        sun2vaxr4d( &ura.ra.sfdu.cable4_temp );
                ura.ra.sfdu.cable5_temp =
                        sun2vaxr4d( &ura.ra.sfdu.cable5_temp );
                ura.ra.sfdu.t_emission =
                        sun2vaxr4d( &ura.ra.sfdu.t_emission );
                ura.ra.sfdu.kappa =
                        sun2vaxr4d( &ura.ra.sfdu.kappa );
                ura.ra.data.t_antenna_obs =
                        sun2vaxr4d( &ura.ra.data.t_antenna_obs );
                ura.ra.data.surface_bright_temp =
                        sun2vaxr4d( &ura.ra.data.surface_bright_temp );
		
	for ( i = 0; i < 28; i++ ) ra_in[i] = ura.rastr.str1[i];
	for ( i = 0; i < 100; i++ ) ra_in[i+28] = ura.rastr.str2[i];
}
