C========================================================================
C c_to_doy.f
C------------------------------------------------------------------------
      integer*4 function c_to_doy ( date )
C
C Abstract:
C	converts calendar date to day of year
C
	implicit none

C Declarations:
C	Passing Parameters: 

      character*8 date                        

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C       date		I		date in format of MM/DD/YY
C	c_to_day	O		day of year
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

      integer*2 MM, DD, YY
      integer*4 month, day, year, leap

D     write (*,*) 'C_TO_DOY: date = ', date

      read ( date, '(i2,1x,i2,1x,i2)' ) MM, DD, YY

C>>  Convert month count to a year starting on March 1

      month = mod ( MM + 9, 12 )

C>>  Compute days to start of month, then add day of month

      day = DD + nint ( 153/5. * month )

C>>  Adjust year by subtracting 1 if month is JAN or FEB

      year = YY - INT ( month/10. )

C>>  If this is a leap year, leap = 1

      leap = int( ( mod(year-1,4) + 1 ) / 4. ) - 
     .       int( ( mod(year-1,400) + 1 ) / 400. )

C>>  Compute DOY by adding # of days in JAN and FEB and moving start of 
C>>     year back to JAN 1

      c_to_doy = mod ( day + 58 + leap, 365 + leap) + 1

      return
      end
