C========================================================================
C c_vaxpo.f
C------------------------------------------------------------------------
c Original code: Cynthia L. Wong
c Changes: Lawrence Chen 12/16/93
c ieee4_vaxf -> sun2vaxr4
c ieee4_vaxd -> sun2vaxr8

      subroutine c_vaxpo
C
C Abstract:
C	Converts per-orbit data from IEEE floating point to VAX floating point
C
	implicit none

C Declarations:
C	Passing Parameters: None.
C	Constant Parameters: None.
C	Include files: 

      include '../../../inc/po'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	po		I/O		convert po to VAX floating pointings.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

c	real*8 ieee8_vaxd
c	real ieee4_vaxf

	real*8 sun2vaxr8, vax2sunr8
	real*4 sun2vaxr4, vax2sunr4
	integer*4 sun2vaxi2
	integer*2 sun2vaxi4


c      po_data_gen_orb_start_scet = 
c	1	ieee8_vaxd( po_data_gen_orb_start_scet )
c      po_data_gen_orb_end_scet =   
c	1	ieee8_vaxd( po_data_gen_orb_end_scet )
c      po_data_orb_periapsis_J2000 = 
c	1	ieee8_vaxd( po_data_orb_periapsis_J2000 )
c      po_data_orb_semi_major = ieee8_vaxd( po_data_orb_semi_major )
c      po_data_orb_eccentricity = ieee8_vaxd( po_data_orb_eccentricity )
c      po_data_orb_inclination = ieee8_vaxd( po_data_orb_inclination )
c      po_data_orb_asc_node_lon = ieee8_vaxd( po_data_orb_asc_node_lon )
c      po_data_orb_arg_periapsis = 
c	1	ieee8_vaxd( po_data_orb_arg_periapsis )
c      po_data_orb_period = ieee4_vaxf( po_data_orb_period )
c      po_data_projp_sin_ref_lon = 
c	1	ieee4_vaxf( po_data_projp_sin_ref_lon )
c      po_data_projp_grid_fix_time = 
c	1	ieee8_vaxd( po_data_projp_grid_fix_time )
c      po_data_projp_xhat_x_vbf = ieee4_vaxf( po_data_projp_xhat_x_vbf )
c      po_data_projp_xhat_y_vbf = ieee4_vaxf( po_data_projp_xhat_y_vbf )
c      po_data_projp_xhat_z_vbf = ieee4_vaxf( po_data_projp_xhat_z_vbf )
c      po_data_projp_yhat_x_vbf = ieee4_vaxf( po_data_projp_yhat_x_vbf )
c      po_data_projp_yhat_y_vbf = ieee4_vaxf( po_data_projp_yhat_y_vbf )
c      po_data_projp_yhat_z_vbf = ieee4_vaxf( po_data_projp_yhat_z_vbf )
c      po_data_projp_zhat_x_vbf = ieee4_vaxf( po_data_projp_zhat_x_vbf )
c      po_data_projp_zhat_y_vbf = ieee4_vaxf( po_data_projp_zhat_y_vbf )
c      po_data_projp_zhat_z_vbf = ieee4_vaxf( po_data_projp_zhat_z_vbf )
c      po_data_projp_obl_ref_lon = 
c	1	ieee4_vaxf( po_data_projp_obl_ref_lon )
c      po_data_projp_neg_obl_ref_lat = 
c	1	ieee4_vaxf( po_data_projp_neg_obl_ref_lat)
c      po_data_projp_obl_st_time = 
c	1	ieee8_vaxd( po_data_projp_obl_st_time )
c      po_data_projp_obl_end_time = 
c	1	ieee8_vaxd( po_data_projp_obl_end_time )

c --------------------------------------------------
c change ieee8_vaxd -> sun2vaxr8
c        ieee4_vaxf -> sun2vaxr4
c L. Chen 12/16/93


	
      po_data_gen_orb_start_scet =
	1	sun2vaxr8( po_data_gen_orb_start_scet )
      po_data_gen_orb_end_scet =
	1       sun2vaxr8( po_data_gen_orb_end_scet )
      po_data_orb_periapsis_J2000 =
	1       sun2vaxr8( po_data_orb_periapsis_J2000 )
      po_data_orb_semi_major = sun2vaxr8( po_data_orb_semi_major )
      po_data_orb_eccentricity = sun2vaxr8( po_data_orb_eccentricity )
      po_data_orb_inclination = sun2vaxr8( po_data_orb_inclination )
      po_data_orb_asc_node_lon = sun2vaxr8( po_data_orb_asc_node_lon )
      po_data_orb_arg_periapsis =
	1       sun2vaxr8( po_data_orb_arg_periapsis )
      po_data_orb_period = sun2vaxr4( po_data_orb_period )
      po_data_projp_sin_ref_lon =
	1       sun2vaxr4( po_data_projp_sin_ref_lon )
      po_data_projp_grid_fix_time =
	1       sun2vaxr8( po_data_projp_grid_fix_time )
      po_data_projp_xhat_x_vbf = sun2vaxr4( po_data_projp_xhat_x_vbf )
      po_data_projp_xhat_y_vbf = sun2vaxr4( po_data_projp_xhat_y_vbf )
      po_data_projp_xhat_z_vbf = sun2vaxr4( po_data_projp_xhat_z_vbf )
      po_data_projp_yhat_x_vbf = sun2vaxr4( po_data_projp_yhat_x_vbf )
      po_data_projp_yhat_y_vbf = sun2vaxr4( po_data_projp_yhat_y_vbf )
      po_data_projp_yhat_z_vbf = sun2vaxr4( po_data_projp_yhat_z_vbf )
      po_data_projp_zhat_x_vbf = sun2vaxr4( po_data_projp_zhat_x_vbf )
      po_data_projp_zhat_y_vbf = sun2vaxr4( po_data_projp_zhat_y_vbf )
      po_data_projp_zhat_z_vbf = sun2vaxr4( po_data_projp_zhat_z_vbf )
      po_data_projp_obl_ref_lon =
	1       sun2vaxr4( po_data_projp_obl_ref_lon )
      po_data_projp_neg_obl_ref_lat =
	1       sun2vaxr4( po_data_projp_neg_obl_ref_lat)
      po_data_projp_obl_st_time =
	1       sun2vaxr8( po_data_projp_obl_st_time )
      po_data_projp_obl_end_time =
	1       sun2vaxr8( po_data_projp_obl_end_time )


c	Lawrence Chen 1/11/94
c	integer*4 and integer*2 need to be converted before
c	write on disk

      po_sfdu_second_label = sun2vaxi2( po_sfdu_second_label )
      po_sfdu_second_length = sun2vaxi2( po_sfdu_second_length )
      po_sfdu_orbit_num = sun2vaxi2( po_sfdu_orbit_num )

      po_data_gen_orbit = sun2vaxi4( po_data_gen_orbit )
      po_data_gen_n_edr_bursts = sun2vaxi4( po_data_gen_n_edr_bursts )

      po_data_gen_nlooks = sun2vaxi4( po_data_gen_nlooks )
      po_data_gen_left_looking = sun2vaxi4( po_data_gen_left_looking )

      po_data_projc_obl_st = sun2vaxi4( po_data_projc_obl_st )
      po_data_projc_obl_end = sun2vaxi4( po_data_projc_obl_end )
      po_data_projc_sin_st = sun2vaxi4( po_data_projc_sin_st )
      po_data_projc_sin_end = sun2vaxi4( po_data_projc_sin_end )

      po_data_projp_grid_fix_burst =
     .	 sun2vaxi4(po_data_projp_grid_fix_burst)

c      po_data_projp_grid_fix_burst =
c        1	sun2vaxi4(po_data_projp_grid_fix_burst)


      end
