C========================================================================
C check_1.f
C------------------------------------------------------------------------
	subroutine check_1(r,td,Dt_v_1way,cspeed,fs,nsample,alarm)
C
C Abstract:
C	Checks that whether the delta between the estimated
C	delay time for the BIP and the delay time of the MRP exceeding
C	certain bound.
C
	implicit none

C Declarations:
C	Passing Parameters:

	real r, td, dt_v_1way, cspeed, fs, alarm
	integer nsample

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	r		I		range
C	td		I		delay time
C	dt_v_1way	I		ratio of the delay time of the echo to
C					the one way travelling distance
C	cspeed		I		speed of light
C	fs		I		radar range sampling frequency
C	nsample		I		number of samples
C	alarm		O		set if check is true
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real t_d, delta_t, delta_sample

	alarm=0

	t_d=r*Dt_v_1way

	delta_t = abs(t_d - td)

	delta_sample = delta_t* fs

	if(delta_sample.gt.nsample/2.) alarm=1

	return
	end
