C=============================================================================
C corr_pp.f
C------------------------------------------------------------------------
	subroutine corr_pp ( nb, proj )
C
C Abstract:
C	Calls get_corr_pp_ to fill in pp_a common block.
C
	implicit none

C Declarations:
C	Constant Parameters: 
	
	integer os_maxburst, s_maxburst, pp_recsiz
	parameter ( os_maxburst = 400, s_maxburst = 8600 )
	parameter ( pp_recsiz = 1315 )

C	Passing Parameters: 

	integer nb, proj

	byte os_ppbuf( os_maxburst*pp_recsiz )
	byte s_ppbuf( s_maxburst*pp_recsiz )

	common / os_ppbuf / os_ppbuf
	common / s_ppbuf / s_ppbuf


C	Include files: 

	include '../../../inc/po'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	nb		I		burst number
C	proj		I		projection (0=oblique,1=sinusoidal)
C
C Constant Parameters:
C	os_maxburst - maximum bursts for oblique sinusoidal
C	s_maxburst - maximum bursts for sinusoidal proj.
C	pp_recsiz - length of pp record
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	os_ppbuf	I		pp data buffer
C	s_ppbuf		I		pp data buffer
C	po		I		per-orbit data buffer
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	None.
C
C Revised Information:
C	7-22-92 (CLW) - For integration between pp & correlator
C
C========================================================================
C Local Variables:

	integer offset

	if ( proj .eq. 0 ) then 
	
		offset = (nb - po_data_projc_obl_st)*pp_recsiz + 1
     		call get_corr_pp( os_ppbuf(offset) ) 

	else

		offset = (nb - po_data_projc_sin_st)*pp_recsiz + 1
		call get_corr_pp( s_ppbuf(offset) )

	endif

	end
