C========================================================================
C cross.f
C------------------------------------------------------------------------
	subroutine cross(x1,x2,x3,y1,y2,y3,z1,z2,z3)
C
C Abstract:
C	performs vector cross product to get Z = X x Y
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real x1, x2, x3, y1, y2, y3, z1, z2, z3

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x1, x2, x3	I		X vector
C	y1, y2, y3	I		Y vector
C	z1, z2, z3	O		Z vector = X x Y
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	z1=x2*y3-x3*y2
	z2=x3*y1-x1*y3
	z3=x1*y2-x2*y1

	call normal(z1,z2,z3)  !normalize vector Z

	return
	end
