C========================================================================
C dc12_of_frmcr.f
C------------------------------------------------------------------------
	subroutine dc12_of_frmcr(ipj,irl,r_hi,r_lo,fd_hi,fd_lo,mu_g,mu_a,
     1	r_ref,fd_ref,dc1_fc,dc2_fc,burst_num)
C
C Abstract:
C	Gets the delta projection coordinates for 
C	the framelet corner points. Delta means that it is with 
C	respect to the center of the geometric reference point
C
	implicit none

C Declarations:
C	Passing Parameters: 

	integer ipj, irl, burst_num
	real r_hi, r_lo, fd_hi, fd_lo, mu_g(3,3), mu_a(3,3)
	real r_ref, fd_ref, dc1_fc(2,2), dc2_fc(2,2)

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	ipj		I		projection option
C	irl		I		left- or right looking
C	r_hi, r_lo	I		range boundary
C	fd_hi, fd_lo	I		doppler freg. boundary
C	mu_g		I		range resampling coefficients
C	mu_a		I		azimuth resampling coefficients
C	r_ref, fd_ref	I		range & doppler of reference point
C	dc1_fc, dc2_fc	O		projection coordinates of framelet
C					corner point
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	call drf_to_dc12(r_lo-r_ref,fd_lo-fd_ref,ipj,irl,mu_g,mu_a,
     1	dc1_fc(1,1),dc2_fc(1,1),burst_num)
	call drf_to_dc12(r_lo-r_ref,fd_hi-fd_ref,ipj,irl,mu_g,mu_a,
     1	dc1_fc(1,2),dc2_fc(1,2),burst_num)
	call drf_to_dc12(r_hi-r_ref,fd_lo-fd_ref,ipj,irl,mu_g,mu_a,
     1	dc1_fc(2,1),dc2_fc(2,1),burst_num)
	call drf_to_dc12(r_hi-r_ref,fd_hi-fd_ref,ipj,irl,mu_g,mu_a,
     1	dc1_fc(2,2),dc2_fc(2,2),burst_num)

d	type *, 'dc1_fc(1,1)= ', dc1_fc(1,1)
d	type *, 'dc1_fc(2,1)= ', dc1_fc(2,1)
d	type *, 'dc1_fc(1,2)= ', dc1_fc(1,2)
d	type *, 'dc1_fc(2,2)= ', dc1_fc(2,2)
d	type *, 'dc2_fc(1,1)= ', dc2_fc(1,1)
d	type *, 'dc2_fc(2,1)= ', dc2_fc(2,1)
d	type *, 'dc2_fc(1,2)= ', dc2_fc(1,2)
d	type *, 'dc2_fc(2,2)= ', dc2_fc(2,2)
	return
	end
