C========================================================================
C get_drmp_coef.f
C------------------------------------------------------------------------
	subroutine get_drmp_coef(Np,prf,fd_m,fr_m,d1_rmp,d2_rmp)
C
C Abstract:
C	Computes the deramp coefficients
C
	implicit none

C Declarations:
C	Passing Parameters: 

	integer Np
	real prf, fd_m, fr_m, d1_rmp, d2_rmp

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	Np		I		# of pulses
C	prf		I		pulse repetition freq.
C	fd_m		I		doppler freq. of MRP
C	fr_m		I		doppler freq. rate of MRP
C	d1_rmp		O		1st order deramp reference coef.
C	d2_rmp		O		2nd order deramp reference coef.
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real pi, dt

	pi=4*atan(1.)
	dT=1/prf
	d1_rmp=2*pi*(prf/2-fd_m+fr_m*Np/2)*dT	!Eq. (39) fo PP Doc.
	d2_rmp=-1*pi*fr_m*dt**2			!Eq. (40) fo PP Doc.

	return
	end

