C========================================================================
C get_irg.f
C------------------------------------------------------------------------
	subroutine get_IRG(fd_m,qfd,Irg)
C
C Abstract:
C	Computes the range group index based on Eq. (34) of the PP Doc.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real fd_m, qfd
	integer Irg

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O	Description
C       --------	---	------------
C	fd_m		I	doppler freq. of MRP
C	qfd		I	bandwidth allocated to each group of references
C	Irg		O	range group index
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	if(fd_m.lt.-14.5*qfd) then
	Irg=1
	else

	if(fd_m.gt.15.5*qfd) then
	Irg=32
	else
	Irg=nint(fd_m/qfd)+16
	end if

	end if

	return
	end
