C========================================================================
C get_rm_fdm.f
C------------------------------------------------------------------------
	subroutine get_rm_fdm(td,fd_b,f_dr,Rapp_b,Dt_v_1way,cspeed,r_m,fd_m)
C
C Abstract:
C	Computes the apparent range and Doppler of the Mid-
C	range point based on Eq. (6) and (7) of the PP Doc.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real td, fd_b, f_dr, Rapp_b, Dt_v_1way, cspeed, r_m, fd_m

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	td		I		delay time of burst
C	fd_b		I		doppler freq. of BIP
C	f_dr		I		doppler drift rate of BIP
C	Rapp_b		I		apparent range of BIP
C	Dt_v_1way	I		ratio of the delay time of the echo to
C                                       the one way travelling distance
C	cspeed		I		speed of light
C	r_m, fd_m	O		range & doppler freq. of MRP
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	r_m = td/Dt_v_1way
	fd_m = fd_b+f_dr*(r_m-Rapp_b)

	return
	end
