C========================================================================
C look_ang.f
C------------------------------------------------------------------------
	subroutine look_ang(r,p,ang_lk)
C
C Abstract:
C	Computes the look angle based on the sensor position and 
C	pointing vector.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real r(3), p(3), ang_lk

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	r		I		sensor position
C	p		I		pointing vector
C	ang_lk		O		look angle
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	ang_lk=acosd(-1*(r(1)*p(1)+r(2)*p(2)+r(3)*p(3)))

	return
	end
