C========================================================================
C mtxsp.f
C------------------------------------------------------------------------
	subroutine mtxsp(u,x)
C
C Abstract:
C  	Solves the matrix equation ux=b for x, 
C	where b is stored in the 4-TH (and 5-th & 6-th) column 
C	of a 3X3 MATRIX aw as given below
C
C			   | 1   R1  R1**2|
C		       u = | 1   R2  R2**2|
C			   | 1   R3  R3**2|
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real u(3,4), x(3)

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	u		I		3x3 matrix
C	x		O		solve for ux=b
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real s, t, a, b, c, d, e, f, g, h

	s=u(2,2)-u(3,2)
	t=u(1,2)-u(2,2)
	a=s*(u(1,3)-u(2,3))-t*(u(2,3)-u(3,3))
	b=s
	c=u(2,3)-u(3,3)
	d=u(3,2)
	e=u(3,3)
	f=s*(u(1,4)-u(2,4))-t*(u(2,4)-u(3,4))
	g=u(2,4)-u(3,4)
	h=u(3,4)
	x(3)=f/a
	x(2)=(g-c*x(3))/b
	x(1)=h-(d*x(2)+e*x(3))

	return
	end
