C========================================================================
C navs.f
C------------------------------------------------------------------------
	subroutine NAVS(nav_source,t,t_p,x_s_j2000,v_s_j2000,
     C	a_s_j2000,HANDLE)
C
C Abstract:
C	Gets the spacecraft status at given time. There are
C	four ways to get the results by calling nav1, nav2, nav3, and 
C	nav4.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	integer nav_source, handle
	real x_s_j2000(3), v_s_j2000(3), a_s_j2000(3)
	real*8 t_p, t

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	nav_source	I		determines routine to call 
C					nav1, nav2, nav3, or nav4
C	handle		I		S/P kernel file handler (Nav s/w)
C					for nav1 only
C	x_s_j2000	O		location of sensor
C	y_s_j2000	O		velocity of sensor
C	a_s_j2000	O		acceleration of sensor
C	t_p		I		time at periapsis
C	t		I		burst reference time
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	go to (1,2,3,4) nav_source 

1	call nav1(t,t_p,x_s_j2000,v_s_j2000,a_s_j2000,HANDLE)
	return

2	call nav2(t,t_p,x_s_j2000,v_s_j2000,a_s_j2000)
	return

3	call nav3(t,t_p,x_s_j2000,v_s_j2000,a_s_j2000)
	return

4	call nav4(t,t_p,x_s_j2000,v_s_j2000,a_s_j2000)

	return
	end
