C	This gives the structure of an F-BIDR Per-Orbit
C	Parameter Record data block.
C
C	SFDU portion:


C		Primary label:

	CHARACTER*9 PO_SFDU_PRIME_LABEL
	CHARACTER*3 PO_SFDU_PRIME_TYPE
	CHARACTER*8 PO_SFDU_PRIME_LENGTH

C		Secondary label:

	INTEGER*2  PO_SFDU_SECOND_LABEL
	INTEGER*2  PO_SFDU_SECOND_LENGTH

	INTEGER*2  PO_SFDU_ORBIT_NUM

C		Data annotation block:

	BYTE   PO_SFDU_DATA_CLASS
	BYTE   PO_SFDU_DATA_ANN_LENGTH

C		Per-Orbit-specific fields:


C	Data portion:


C		General Parameters:

	INTEGER*4 PO_DATA_GEN_ORBIT

	REAL*8  PO_DATA_GEN_ORB_START_SCET
	REAL*8  PO_DATA_GEN_ORB_END_SCET
	INTEGER*4 PO_DATA_GEN_N_EDR_BURSTS

	CHARACTER*9 PO_DATA_GEN_PRODUCT_ID
	CHARACTER*6 PO_DATA_GEN_VOL_ID

	CHARACTER*19 PO_DATA_GEN_LOCAL_TIME

	INTEGER*4 PO_DATA_GEN_NLOOKS

	INTEGER*4 PO_DATA_GEN_LEFT_LOOKING

	CHARACTER*32 PO_DATA_GEN_EPHEMERIS_ID

C		Orbit Keplerians:

	CHARACTER*15 PO_DATA_ORB_PERIAPSIS_SCLK
	REAL*8  PO_DATA_ORB_PERIAPSIS_J2000

	REAL*8  PO_DATA_ORB_SEMI_MAJOR
	REAL*8  PO_DATA_ORB_ECCENTRICITY
	REAL*8  PO_DATA_ORB_INCLINATION
	REAL*8  PO_DATA_ORB_ASC_NODE_LON
	REAL*8  PO_DATA_ORB_ARG_PERIAPSIS
	REAL*4  PO_DATA_ORB_PERIOD

C		SCLK-to-SCET Conversion Coefficients:

	CHARACTER*13 PO_DATA_TIME_SCLK0
	CHARACTER*12 PO_DATA_TIME_A1
	CHARACTER*19 PO_DATA_TIME_A0
	CHARACTER*6 PO_DATA_TIME_DUT

C		Projection Burst Counters:

	INTEGER*4 PO_DATA_PROJC_OBL_ST
	INTEGER*4 PO_DATA_PROJC_OBL_END
	INTEGER*4 PO_DATA_PROJC_SIN_ST
	INTEGER*4 PO_DATA_PROJC_SIN_END

C		Projection Parameters:

	REAL*4 PO_DATA_PROJP_SIN_REF_LON

	INTEGER*4 PO_DATA_PROJP_GRID_FIX_BURST
	REAL*8 PO_DATA_PROJP_GRID_FIX_TIME

	REAL*4 PO_DATA_PROJP_XHAT_X_VBF
	REAL*4 PO_DATA_PROJP_XHAT_Y_VBF
	REAL*4 PO_DATA_PROJP_XHAT_Z_VBF
	REAL*4 PO_DATA_PROJP_YHAT_X_VBF
	REAL*4 PO_DATA_PROJP_YHAT_Y_VBF
	REAL*4 PO_DATA_PROJP_YHAT_Z_VBF
	REAL*4 PO_DATA_PROJP_ZHAT_X_VBF
	REAL*4 PO_DATA_PROJP_ZHAT_Y_VBF
	REAL*4 PO_DATA_PROJP_ZHAT_Z_VBF

	REAL*4 PO_DATA_PROJP_OBL_REF_LON
	REAL*4 PO_DATA_PROJP_NEG_OBL_REF_LAT

	REAL*8 PO_DATA_PROJP_OBL_ST_TIME
	REAL*8 PO_DATA_PROJP_OBL_END_TIME

C		Unused bytes:

	BYTE PO_DATA_FILL( 307:511 )

C		Fill rest of physical record with circumflexes,
C		since Per-Orbit is a single-record file (and count from
C		29 now, not 0, to allow for a 28-byte SFDU header):

	CHARACTER*1 PO_DATA_CIRCUM( 512+29:32500 ) 

	COMMON / PO / PO_SFDU_PRIME_LABEL, PO_SFDU_PRIME_TYPE,
     .	 PO_SFDU_PRIME_LENGTH, PO_SFDU_SECOND_LABEL,
     .	 PO_SFDU_SECOND_LENGTH, PO_SFDU_ORBIT_NUM, PO_SFDU_DATA_CLASS,
     .	 PO_SFDU_DATA_ANN_LENGTH, PO_DATA_GEN_ORBIT,
     .	 PO_DATA_GEN_ORB_START_SCET, PO_DATA_GEN_ORB_END_SCET,
     .	 PO_DATA_GEN_N_EDR_BURSTS, PO_DATA_GEN_PRODUCT_ID,
     .	 PO_DATA_GEN_VOL_ID, PO_DATA_GEN_LOCAL_TIME, PO_DATA_GEN_NLOOKS,
     .	 PO_DATA_GEN_LEFT_LOOKING, PO_DATA_GEN_EPHEMERIS_ID,
     .	 PO_DATA_ORB_PERIAPSIS_SCLK, PO_DATA_ORB_PERIAPSIS_J2000,
     .	 PO_DATA_ORB_SEMI_MAJOR, PO_DATA_ORB_ECCENTRICITY,
     .	 PO_DATA_ORB_INCLINATION, PO_DATA_ORB_ASC_NODE_LON,
     .	 PO_DATA_ORB_ARG_PERIAPSIS, PO_DATA_ORB_PERIOD,
     .	 PO_DATA_TIME_SCLK0, PO_DATA_TIME_A1, PO_DATA_TIME_A0,
     .	 PO_DATA_TIME_DUT, PO_DATA_PROJC_OBL_ST, PO_DATA_PROJC_OBL_END,
     .	 PO_DATA_PROJC_SIN_ST, PO_DATA_PROJC_SIN_END,
     .	 PO_DATA_PROJP_SIN_REF_LON, PO_DATA_PROJP_GRID_FIX_BURST,
     .	 PO_DATA_PROJP_GRID_FIX_TIME, PO_DATA_PROJP_XHAT_X_VBF,
     .	 PO_DATA_PROJP_XHAT_Y_VBF, PO_DATA_PROJP_XHAT_Z_VBF,
     .	 PO_DATA_PROJP_YHAT_X_VBF, PO_DATA_PROJP_YHAT_Y_VBF,
     .	 PO_DATA_PROJP_YHAT_Z_VBF, PO_DATA_PROJP_ZHAT_X_VBF,
     .	 PO_DATA_PROJP_ZHAT_Y_VBF, PO_DATA_PROJP_ZHAT_Z_VBF,
     .	 PO_DATA_PROJP_OBL_REF_LON, PO_DATA_PROJP_NEG_OBL_REF_LAT,
     .	 PO_DATA_PROJP_OBL_ST_TIME, PO_DATA_PROJP_OBL_END_TIME,
     .	 PO_DATA_FILL, PO_DATA_CIRCUM

	BYTE PO(32500)
	EQUIVALENCE ( PO, PO_SFDU_PRIME_LABEL )
