C========================================================================
C rfd_frmcr.f
C------------------------------------------------------------------------
	subroutine rfd_frmcr(pbw,i_m,Dlta_r,r_m,fd_m,r_hi,r_lo,fd_hi,fd_lo)
C
C Abstract:
C	Computes the range and Doppler bounds for the
C	single-look burst framelet
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real pbw, i_m, Dlta_r, r_m, fd_m, r_hi, r_lo, fd_hi, fd_lo

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	pbw		I		processing bandwidth
C	i_m		I		incidence angle of MRP
C	Dlta_r		I		apparent range relative to central 
C					radiometric grid point
C	r_m, fd_m	I		range & doppler of MRP
C	r_hi, r_lo,
C	fd_hi, fd_lo	O		range & doppler bounds of single-look
C					burst framelet
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:


	fd_lo=fd_m-pbw/2.
	fd_hi=fd_m+pbw/2.

	r_lo= r_m - Dlta_r/2.
	r_hi= r_m + Dlta_r/2.

	return
	end
