C========================================================================
C rng_walk.f
C------------------------------------------------------------------------
	subroutine rng_walk(fd_m,Wavl,Np,prf,Dr,Nw)
C
C Abstract:
C	Computes number of range walk samples
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real fd_m, wavl, prf, Dr, Nw
	integer Np

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	fd_m		I		doppler freq. of MRP
C	wavl		I		radar wavelength
C	Np		I		# of pulses per burst
C	prf		I		pulse repetition freq.
C	Dr		I		slant range sample spacing
C	Nw		O		# of range walk samples
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	Nw=abs(fd_m)*(Np-1)*wavl/(2*prf*Dr)	!Range walk value.

	return
	end
