C========================================================================
C get_rngwlk_coe.f
C------------------------------------------------------------------------
	subroutine get_rngwlk_coe(Dr,Np,prf,fd_m,wavl,d0_rw,d1_rw)
C
C Abstract:
C	Computes the 0-th order and the 1st order
C	coefficients for the range walk correction according to
C	Eq.(36) and Eq.(37) in the PP Doc.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real Dr, prf, fd_m, wavl, d0_rw, d1_rw
	integer Np

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	Dr		I		range sample spacing
C	prf		I		pulse repetition freq.
C	fd_m		I		doppler frequency of MRP
C	wavl		I		radar wavelength
C	d0_rw, d1_rw	O		range walk polynomial coefficients
C	Np		I		number of pulses of burst
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	d1_rw=-1*fd_m*wavl/(2*Dr*prf)
	
	if(fd_m.gt.0) then
	d0_rw=fd_m*(Np-1)*wavl/(2*Dr*prf)
	else
	d0_rw=0.
	end if

	return
	end
