C========================================================================
C rotate_y.f
C------------------------------------------------------------------------
	subroutine rotate_y(x,y,z,theta0,sign)
C
C Abstract:
C	Performs coordinate rotation about the Y axis by an angle of theta0.
C
	implicit none

C Declarations:
C	Passing Parameters: None.

	real x, y, z
	real theta0, sign

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x, y, z		I/O		vector to be rotated.
C	theta0		I		angle
C	sign		I		sign
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real theta
	real x1, z1

	theta=theta0*sign
	z1=z*cosd(theta)+x*sind(theta)
	x1=-1*z*sind(theta)+x*cosd(theta)
	y=y

	x=x1
	z=z1

	return
	end

