C========================================================================
C sc_state.f 
C------------------------------------------------------------------------
	subroutine sc_state ( handle )
C
C Abstract:
C	This is a high-level routine for the computation for spacecraft
C	state which are the position and velocity. It calls procedures 
C	Navs, sec_2_day, j2000_to_vme, and vme_to_vbf.

	implicit none

C Declarations:
C	Passing Parameters:

	integer handle 

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/var_local'
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	handle		I		Handle of S/P kernel file
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	var_local	I/O		see include file "var_local"
C
C Detailed I/O through common blocks:
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	integer i

d	type *, 'handle= ', handle
d	type *, 'nav_source= ', nav_source

	call Navs(Nav_source,t_b,t_p,x_s_j2000,v_s_j2000,
     c	a_s_j2000,handle)

c	get sensor states in j2000 coordinates

	call sec_2_day(t_b,day) !convert time from second to unit of day
	call j2000_to_VME(x_s_j2000,x_s_VME)  !sensor position in VME 
	call j2000_to_VME(v_s_j2000,v_s_VME)  !sensor velocity in VME 
	call VME_to_VBF(day,x_s_VME,x_s_VBF)  !sensor position in VBF
	call VME_to_VBF(day,v_s_VME,v_s_VBF)  !sensor velocity in VBF

	do i=1,3
	X_s(i)=X_s_VBF(i)
	V_s(i)=V_s_VBF(i)
	end do

d	type *, 'xs1,2,3', x_s(1), x_s(2), x_s(3)
d	type *, 'vs1,2,3', v_s(1), v_s(2), v_s(3)

	return
	end
