C========================================================================
C sph_of_geos.f
C------------------------------------------------------------------------
	subroutine sph_of_Geos(c1_g,c2_g,lon0,alpha1,alpha2,lat_g,lon_g,ipj)
C
C Abstract:
C	Computes the spherical coordinates of the geometric
C	reference points based on their projection coordinates.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real c1_g(3,3), c2_g(3,3), lon0, alpha1, alpha2
	real lat_g(3,3),lon_g(3,3)
	integer ipj

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	c1_g, c2_g	I		projection coord. of geometric ref. pts.
C	lon0		I		longitude of oblique sin. origin
C	alpha1, alpha2	I		angles for rotation
C	lat_g, lon_g	O		spherical coordinates
C	ipj		I		projection flag
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	integer i, j

	do i=1,3
	do j=1,3

	call c12_to_sph(c1_g(i,j),c2_g(i,j),lat_g(i,j),lon_g(i,j),
     1	lon0,alpha1,alpha2,ipj)

	end do
	end do	

	return
	end
