C========================================================================
C squint.f
C------------------------------------------------------------------------
	subroutine squint(v_s,p,th_squint,vs_mag)
C
C Abstract:
C	Computes squint and magnitude of velocity
C	
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real v_s(3), p(3), th_squint, vs_mag

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	v_s		I		sensor velocity
C	p		I		pointing vector
C	th_squint	O		squint
C	vs_mag		O		magnitude of velocity
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Cynthia L. Wong (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real vs_dot_p

	vs_dot_p = v_s(1)*p(1) +v_s(2)*p(2) +v_s(3)*p(3)
	vs_mag = sqrt(v_s(1)**2+v_s(2)**2+v_s(3)**2)
	th_squint = acosd(abs(vs_dot_p)/vs_mag)

	return
	end
