
#include <stdio.h>
#include "../../../inc/altedr.h"
#include "../../../inc/telem.h"

#define	ENG	"ENG.TEST"

static	char	*files[ ] = { "DECOM.TEST",
			         "DECAL.1",
		                 "DECAL.2",
		                 "DECAL.3",
		                 "DECAL.4" };

static	char	*channels[ ] = { "E-1028", "E-1029", "E-1030", 
				 "E-0041", "E-0042", "E-0043", 
				 "E-0045", "R-2105",
				 "R-2106", "R-2107", "R-2108",
				 "R-2109", "R-2110", "R-0670",
				 "R-1670", "R-0570", "R-1570",
				 "R-0472", "R-1472", 0 };

extern	struct	telemc	td_;

tlmc_( )
{
	edr_en_rec	eng;
	double		val;
	char		**c, *title;
	int		dn;		/* bit-string channel value */
	extern	 char	buf_[512];	/* Scratch input buffer */
 	extern	 long	rstat_;		/* return ststus of getegrec */

	short		RXU_A_last = -1, RXU_B_last = -1;
	short		ONU_A_last = -1, ONU_B_last = -1;
	short		XMTR_A_last = -1, XMTR_B_last = -1;
	int		i, nrec, nsa = 0;
  	int		nsb1 = 0, nsb2 = 0, nsb3 = 0, nsb4 = 0, nsb5 = 0;
  	int		nra = 0, nrb = 0, noa = 0, nob = 0, nxa = 0, nxb = 0;
  	int		nras = 0, nrbs = 0, noas = 0;
	int             nobs = 0, nxas = 0, nxbs = 0;

	union	buf_eng {
	    edr_en_rec	eng;
	    char	buf[ 274 ];
	} be;

	init_decom_decal( channels,files );

      	rstat_ = 1;
	for ( nrec = 0; rstat_ != 0; nrec++ ) {
	    getegrec_( );
	    for ( i = 0; i < 275; i++ ) be.buf[ i ] = buf_[ i ];
	    eng = be.eng;
	    eng.en_spare1 &= ~0x80;
	    for ( c = channels; *c; c++ ) {
		if ( c[ 0 ][ 1 ] == 'x' ) continue;

		if (get_decom_data(*c, &eng, &dn) &&
		    get_decal_from_decom(*c, (double)dn, &val, &title)) {
		    if ( ! strcmp( *c,"E-1028" )) {
			td_.sa_q[ nsa ].q1 = val;
  			strncpy( &td_.sa_time[nsa].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sa_time[nsa].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sa_time[nsa].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sa_time[nsa].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );

			if ( ! get_decom_data("E-1029", &eng, &dn) ||
		    	     ! get_decal_from_decom("E-1029", (double)dn, 
  			     &val, &title )) 
  			     printf( "  ERROR ! missing delta q2 \n" );  
			td_.sa_q[ nsa ].q2 = val;

			if ( ! get_decom_data("E-1030", &eng, &dn) ||
		    	     ! get_decal_from_decom("E-1030", (double)dn, 
  			     &val, &title )) 
  			     printf( "  ERROR ! missing delta q3 \n" );  
			td_.sa_q[ nsa ].q3 = val;
			nsa++;
		    }
		    if ( ! strcmp( *c,"E-0041" )) { 
			td_.cable1_temp[ nsb1 ] = val + 273.15;
  			strncpy( &td_.sb1[ nsb1 ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sb1[ nsb1 ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sb1[ nsb1 ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sb1[ nsb1 ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nsb1++;
		    }
		    if ( ! strcmp( *c,"E-0042" )) { 
			td_.cable2_temp[ nsb2 ] = val + 273.15;
  			strncpy( &td_.sb2[ nsb2 ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sb2[ nsb2 ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sb2[ nsb2 ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sb2[ nsb2 ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nsb2++;
		    }
		    if ( ! strcmp( *c,"E-0043" )) { 
			td_.cable3_temp[ nsb3 ] = val + 273.15;
  			strncpy( &td_.sb3[ nsb3 ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sb3[ nsb3 ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sb3[ nsb3 ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sb3[ nsb3 ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nsb3++;
		    }
		    if ( ! strcmp( *c,"E-0045" )) { 
			td_.cable5_temp[ nsb5 ] = val + 273.15;
  			strncpy( &td_.sb5[ nsb5 ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sb5[ nsb5 ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sb5[ nsb5 ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sb5[ nsb5 ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nsb5++;

			td_.cable4_temp[ nsb4 ] = val + 273.15;
  			strncpy( &td_.sb4[ nsb4 ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.sb4[ nsb4 ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.sb4[ nsb4 ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.sb4[ nsb4 ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nsb4++;
		    }
		    if ( ! strcmp( *c,"R-2105" ) ) { 
			if ( val == 1 ) nrbs++;
			if ( RXU_B_last == -1 && val == 1 ) {
                            td_.ra.RXU_B_state = val;
      		            RXU_B_last = val; 
      		        }
			if ( td_.ra.RXU_B_state != RXU_B_last && 
  			    RXU_B_last != -1 ) {
			    RXU_B_last = td_.ra.RXU_B_state; 
			    printf( "  WARNING ! Change in RXU_B_state \n" );  
			}
		    }
		    if ( ! strcmp( *c,"R-2106" ) ) { 
			if ( val == 1 ) nras++;
			if ( RXU_A_last == -1 && val == 1 ) {
			    td_.ra.RXU_A_state = val;
      	                    RXU_A_last = val; 
      			}
			if ( td_.ra.RXU_A_state != RXU_A_last && 
  			    RXU_A_last != -1 ) {
			    RXU_A_last = td_.ra.RXU_A_state; 
			    printf( "  WARNING ! Change in RXU_A_state \n" );  
			}
		    }
		    if ( ! strcmp( *c,"R-2107" ) ) { 
			if ( val == 1 ) nobs++;
			if ( ONU_B_last == -1 && val == 1 ) {
			    td_.ra.ONU_B_state = val;
      		            ONU_B_last = val; 
      			}
			if ( td_.ra.ONU_B_state != ONU_B_last && 
  			    ONU_B_last != -1 ) {
			    ONU_B_last = td_.ra.ONU_B_state; 
			    printf( "  WARNING ! Change in ONU_B_state \n" );  
			}
		    }
		    if ( ! strcmp( *c,"R-2108" ) ) { 
			if ( val == 1 ) noas++;
			if ( ONU_A_last == -1 && val == 1 ) {
			    td_.ra.ONU_A_state = val;
      		            ONU_A_last = val;
      			} 
			if ( td_.ra.ONU_A_state != ONU_A_last && 
  			    ONU_A_last != -1 ) {
			    ONU_A_last = td_.ra.ONU_A_state; 
			    printf( "  WARNING ! Change in ONU_A_state \n" );  
			}
		    }
		    if ( ! strcmp( *c,"R-2109" ) ) { 
			if ( val == 1 ) nxbs++;
			if ( XMTR_B_last == -1 && val == 1 ) {
      			    XMTR_B_last = val; 
			    td_.ra.XMTR_B_state = val;
      			}
			if ( td_.ra.XMTR_B_state != XMTR_B_last && 
  			    XMTR_B_last != -1 ) {
			    XMTR_B_last = td_.ra.XMTR_B_state; 
			    printf( "  WARNING ! Change in XMTR_B_state \n" );  
			}
		    }
		    if ( ! strcmp( *c,"R-2110" ) ) { 
			if ( val == 1 ) nxas++;
			if ( XMTR_A_last == -1 && val == 1 ) {
			    td_.ra.XMTR_A_state = val;
      			    XMTR_A_last = val; 
      			}
			if ( td_.ra.XMTR_A_state != XMTR_A_last && 
  			    XMTR_A_last != -1 ) {
			    XMTR_A_last = td_.ra.XMTR_A_state; 
			    printf( "  WARNING ! Change in XMTR_A_state \n" );  
			}
		    }    
		    if ( ! strcmp( *c,"R-0670" )) { 
			td_.RXU_A_temp[ nra ] = val + 273.15;
  			strncpy( &td_.rbra[ nra ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rbra[ nra ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rbra[ nra ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rbra[ nra ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nra++;
		    }
		    if ( ! strcmp( *c,"R-1670" )) { 
			td_.RXU_B_temp[ nrb ] = val + 273.15;
  			strncpy( &td_.rbrb[ nrb ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rbrb[ nrb ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rbrb[ nrb ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rbrb[ nrb ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nrb++;
		    }
		    if ( ! strcmp( *c,"R-0570" )) { 
			td_.ONU_A_temp[ noa ] = val + 273.15;
  			strncpy( &td_.rboa[ noa ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rboa[ noa ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rboa[ noa ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rboa[ noa ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			noa++;
		    }
		    if ( ! strcmp( *c,"R-1570" )) { 
			td_.ONU_B_temp[ nob ] = val + 273.15;
  			strncpy( &td_.rbob[ nob ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rbob[ nob ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rbob[ nob ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rbob[ nob ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nob++;
		    }
		    if ( ! strcmp( *c,"R-0472" )) { 
			td_.XMTR_A_temp[ nxa ] = val + 273.15;
  			strncpy( &td_.rbxa[ nxa ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rbxa[ nxa ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rbxa[ nxa ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rbxa[ nxa ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nxa++;
		    }
		    if ( ! strcmp( *c,"R-1472" )) { 
			td_.XMTR_B_temp[ nxb ] = val + 273.15;
  			strncpy( &td_.rbxb[ nxb ].rim,  
				 &eng.en_mgn3.m3_sclk.sc_rim,3 );
  			strncpy( &td_.rbxb[ nxb ].mod91,
				 &eng.en_mgn3.m3_sclk.sc_mod91,1 );
  			strncpy( &td_.rbxb[ nxb ].mod10,
				 &eng.en_mgn3.m3_sclk.sc_mod10,1 );
  			strncpy( &td_.rbxb[ nxb ].mod8, 
				 &eng.en_mgn3.m3_sclk.sc_mod8,1 );
			nxb++;
		    }
		}
	    }
	}
	td_.nsa   = nsa;
	td_.nsb1  = nsb1;
	td_.nsb2  = nsb2;
	td_.nsb3  = nsb3;
	td_.nsb4  = nsb4;
	td_.nsb5  = nsb5;
	td_.nrbra = nra;
	td_.nrbrb = nrb;
	td_.nrboa = noa;
	td_.nrbob = nob;
	td_.nrbxa = nxa;
	td_.nrbxb = nxb;

	if ( nras >= nrbs ) {
            td_.ra.RXU_A_state = 1;
            td_.ra.RXU_B_state = 0;
      	}
  	else {
            td_.ra.RXU_A_state = 0;
            td_.ra.RXU_B_state = 1;
      	}

	if ( noas >= nobs ) {
	    td_.ra.ONU_A_state = 1;
	    td_.ra.ONU_B_state = 0;
      	}
  	else {
	    td_.ra.ONU_A_state = 0;
	    td_.ra.ONU_B_state = 1;
      	}

	if ( nxas >= nxbs ) {
	    td_.ra.XMTR_A_state = 1;
	    td_.ra.XMTR_B_state = 0;
      	}
  	else {
	    td_.ra.XMTR_A_state = 0;
	    td_.ra.XMTR_B_state = 1;
      	}

}

