C========================================================================
C tp_search.f
C------------------------------------------------------------------------
	subroutine TP_Search(handle)
C
C Abstract:
C	Verifies the time periapsis with the one obtained from ephemeris data.
C	Displays the result on console.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	integer handle

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/var_local'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	handle		I		S/P kernel file handler (NAV s/w)
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	var_local	I		see include file "var_local"
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	t_p		I		time of periapsis
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real*8 t
	real lat, lon, rs
	real alt_temp, alt, dt_10deg

	pi=4.*atan(1.)

	rv=6051000.
	alt_temp = 2000000.

	day = t_p / (24*3600.)
	dt_10deg = 130.6658
	t = t_p - 100.
1	continue
d	type *, 't= ', t
	call navs(nav_source,t,t_p,x_s_j2000,v_s_j2000,
     c	a_s_j2000, handle)
	call j2000_to_VME(x_s_j2000,x_s_vme)
	alt = sqrt(x_s_vme(1)**2+x_s_vme(2)**2+x_s_vme(3)**2) - rv
	if(alt.gt.alt_temp) go to 2
	alt_temp = alt
	t = t + .1

	if (t. gt. t_p + 200.1) then
	type *, 'Cannot get t_p from ephemeris within the 200 sec interval!'
	return
	else
	end if

	go to 1

2	type *, 'time of periapsis= ', t

	return
	end

