C========================================================================
C vbf_to_qsph.f
C------------------------------------------------------------------------
	subroutine VBF_to_qsph(x0,y0,z0,alpha1,alpha2,r,lat,lon)
C
C Abstract:
C	Converts the body fixed coordinates into the 
C	spherical coordinates of the oblique sinusoidal projection.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real x0, y0, z0, alpha1, alpha2, r, lat, lon

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	x0, y0, z0	I		body fixed coordinates
C	alpha1		I		angle for rotation about z-axis
C	alpha2		I		angle for rotation about y-axis
C	r, lat, lon	I		sperical coorinates
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real x, y, z

d	type *, 'alpha12= ', alpha1, alpha2

	x=x0
	y=y0
	z=z0

	call rotate_z(x,y,z,alpha1,1.)
	call rotate_y(x,y,z,alpha2,1.)

	r=sqrt(x**2+y**2+z**2)
	lat=asind(z/r)
	lon=atan2d(y,x)

	return
	end
