C========================================================================
C vbf_to_vme.f
C------------------------------------------------------------------------
	subroutine VBF_to_VME(day,xin,xout)
C
C Abstract:
C	Converts the body fixed coordinates into the
C	Venus mean equitorial coordiantes according to the Planetary
C	Constant and Model Document.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real*8 day
	real xin(3), xout(3)

C	Constant Parameters: None.
C	Include files: None.
C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	day		I		number of days since 2000 ET
C	xin		I		input vector in VBF coordinates
C	xout		O		output vector in VME coordinates
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real*8 omega8
	real omega, omega_2000, epsilon

	omega_2000=160.39
	epsilon=1.4813291

	omega8=omega_2000-epsilon*day
	if(omega8.gt.0) omega = omega8 - int(omega/360)*360.
	if(omega8.lt.0) omega = omega8 + int(omega/360)*360.


	xout(1)=cosd(omega)*xin(1)-sind(omega)*xin(2)
	xout(2)=sind(omega)*xin(1)+cosd(omega)*xin(2)
	xout(3)=xin(3)

	return
	end
