C========================================================================
C vme_to_vbf.f
C------------------------------------------------------------------------
	subroutine VME_to_VBF(day,xin,xout)
C
C Abstract:
C	Converts from the Venus_mean_equitorial coordinates
C	into the Venus-Body-Fixed coordinates according to the "Planetary 
C	Constant and Model" document.
C
	implicit none

C Declarations:
C	Passing Parameters: 

	real*8 day 
	real xin(3), xout(3)

C	Constant Parameters: None.
C	Include files: 

	include '../../../inc/po'

C
C Brief I/O:
C	Variable	I/O		Description
C       --------	---		------------
C	day		I		# of days since j2000 ET
C	xin		I		vector in VME coordinates
C	xout		O		vector in VBF coordinates
C
C Constant Parameters:
C	None.
C
C Common Blocks:
C	Name		I/O		Description
C       ----		---		------------
C	None.
C
C Detailed I/O through common blocks:
C
C	Variable	I/O		Description
C       --------	---		------------
C	TBD
C
C Files:
C	None.
C
C Author and Institution:
C	Michael Jin (JPL).
C
C References:
C	Source is obtainted from MGN/SDPS/PSP preprocessing software on VAX.
C
C Revised Information:
C	PPLIB 05-01-1992 (CLW) - To be compatible to Alliant FX/2800.
C
C========================================================================
C Local Variables:

	real*8 omega8
	real epsilon, omega_2000, omega

c	integer i, num_cycles
c	parameter (num_cycles=10)
c	integer begin_cycle(num_cycles), end_cycle(num_cycles)
c	data (begin_cycle(i),i=1,2) / 376, 2901 /
c	data (end_cycle(i),i=1,2) /2900, 3957/

c	if (po_sfdu_orbit_num .ge. begin_cycle(1) .and. 
c     +      po_sfdu_orbit_num .le. end_cycle(1)) then
c		omega_2000=160.39
c	else if (po_sfdu_orbit_num .ge. begin_cycle(2)) then
cc     +	    po_sfdu_orbit_num .le. end_cycle(2)) then
c		omega_2000=160.39994225
c	endif

c 2/5/93 change

	omega_2000=160.39
	if ( po_sfdu_orbit_num .gt. 2900 ) omega_2000=160.39994225
	
c end of change
	epsilon=1.4813291

	omega8=omega_2000-epsilon*day
	if (omega8.gt.0) omega = omega8 - int(omega8/360.)*360.
	if (omega8.lt.0) omega = omega8 + int(omega8/360.)*360.

	xout(1)=cosd(omega)*xin(1)+sind(omega)*xin(2)
	xout(2)=-1*sind(omega)*xin(1)+cosd(omega)*xin(2)
	xout(3)=xin(3)

	return
	end
