c*****************************************************************
c	Jet Propulsion Laboratory
c	Section:	334,Radar Science and Engineering
c	Project:	Magellan
c	Task:		SAR Data Processing, Alliant Fortran Version.
c--------------------------------------------------------------------
c
c	7/31/92 Anhua Chu Re-code
c*********************************************************************
c	
c	This gives the structure of the BIDR Trailer file.
c
c	The following fields need to be set at run time:
c
c		- year
c		- day
c		- hour
c		- min
c		- sec
c		- msec
c		- BIDR_name
c
c	jg  05/27/89
c	STRUCTURE / b_trail /
c------------------------------------------------------------
c	Primary SFDU label:

	character*12	b_trail_prim_lab /'CCSD1Z000001'/
	character*8	b_trail_prim_len /'00000116'/

c	Annotation field secondary SFDU label:

	character*12	b_trail_ann_2_lab /'NJPL1K00HD00'/
	character*8     b_trail_ann_2_len /'00000035'/

c	Volume closed time:

	character*14	b_trail_tape_doy /'TAPE_CLSD_DOY='/

	character*2	b_trail_year

	character*1	b_trail_slash /'/'/

	character*3	b_trail_day

	character*1	b_trail_dash /'-'/

	character*2	b_trail_hour

	character*1	b_trail_colon1 /':'/

	character*2	b_trail_min

	character*1	b_trail_colon2 /':'/

	character*2	b_trail_sec

	character*1	b_trail_period /'.'/

	character*3	b_trail_msec

	byte		b_trail_cr1 /13/
	byte		b_trail_lf1 /10/

c	End marker secondary SFDU label:

	character*12	b_trail_em_2_lab /'CCSD1R000003'/
	character*8	b_trail_em_2_len /'00000041'/

c	Delimiter type:

	character*17	b_trail_delim /'DELIMITER=EMARKER'/
	byte		b_trail_cr2 /13/
	byte		b_trail_lf2 /10/

c	Product name:

	character*13	b_trail_pname /'PRODUCT_NAME='/

	character*7	b_trail_bidr_name

	byte		b_trail_cr3 /13/
	byte		b_trail_lf3 /10/

c	Fill rest of physical record with circumflexes,
c	since BIDR Trailer is a single-record file:

	character*1	b_trail_circum( 137:32500 ) /32364*'^'/

c	END STRUCTURE

	common /b_trail/ 
	2 b_trail_prim_lab,b_trail_prim_len,b_trail_ann_2_lab,
	2 b_trail_ann_2_len,b_trail_tape_doy,b_trail_year,
	2 b_trail_slash,b_trail_day,b_trail_dash,b_trail_hour,b_trail_colon1,
	2 b_trail_min,b_trail_colon2,b_trail_sec,b_trail_period,
	2 b_trail_msec,b_trail_cr1,b_trail_lf1,b_trail_em_2_lab,
	2 b_trail_em_2_len,b_trail_delim,b_trail_cr2,b_trail_lf2,
	2 b_trail_pname,b_trail_bidr_name,b_trail_cr3,b_trail_lf3,
	2 b_trail_circum

	byte b_trail(32500)

	equivalence(b_trail,b_trail_prim_lab)

c ------------------------ end of b_trail.inc -----------------------

