c***************************************************************
c	constant.inc
c
c	Constant data base for correlator.
c-------------------------------------------------------------
c	5/20/92 A.Chu Added SAR data extract length
c	3/23/92 A.Chu Collected from Jin & ESP
c***************************************************************
c	-------------
c	SAR data extract length
c	------------

	integer		sar_sfdu_length
	parameter	(sar_sfdu_length=298)

	integer		sab_hdr_length
	parameter	(sab_hdr_length=370)

	integer		sine
	parameter	(sine=1)
c	-------------
C	CORRELATOR FUNCTION CONSTANTS
c	------------
	real		pi
	parameter       (pi = 3.1415926535897938238d0)

	real 		fs			!Radar range sampling frequency
	parameter 	(fs=2.2585227*10**6)

	real 		dt			!Range sampling time
	parameter 	(dt=0.442477876e-6)

	real 		fc			! Radar carrier freq.
	parameter 	(fc=23.85e8)		!A.Chu	
c	parameter 	(fc=23.75e8)		

	real 		wavl			!Radar wave length
	parameter 	(wavl=0.12605042) 	

	real 		cspeed			!light speed
	parameter 	(cspeed=2.997925*10**8)	

	integer		fd_largest
	parameter 	(fd_largest = 37357)

	integer		fd_smallest
	parameter 	(fd_smallest = -36985)

	integer		fd_div
	parameter 	(fd_div = (fd_largest - fd_smallest)/32)

	real		dr   
	parameter 	(Dr=cspeed/(2*fs))      !Range sample spacing 
						!(1-way slant range)
	real		del_g
	parameter 	(del_g=75.)		!Image pixel spacing

	real		rv
	parameter 	(Rv=6051000.)		!Radius of Venus in m.

	real		nrc
	parameter 	(Nrc = 60)	!Number of range chips in range pulse

	real		nrs
	parameter 	(Nrs = 64)	!Number of range chips in range weights

	real		nintp
	parameter 	(Nintp = 4)	!Number of points lost after interpol.

	real		theta_d
	parameter 	(theta_d=0.05)		!delta look angle for far BIP

c	----------
c	FILE LENGTH
c	----------
	integer		tape_rec_size
	parameter 	(tape_rec_size=32500) ! 124
	integer		pp_size
	parameter 	(pp_size=1315)

C	integer*4 	LNG_MAX
C	parameter 	(LNG_MAX=400)

C	integer*4 	MAX_FFT
C	parameter 	(MAX_FFT=2048)

C	integer*4 	NWGT
C	parameter	( NWGT = 64 )

C	integer*4 	NFFT
C	parameter	( NFFT = 512 )

c	real		r_off_bound
c	parameter 	(r_off_bound = 100)!Range gate deviation bound report

c	real		irl
c	parameter 	(irl = 0)	!radar right/left look flag 
					!(left =0, right =1)
c	real		ir_pass
c	parameter 	(ir_pass = 0)	!radiometric comp. mode 
					!(0 is active, 1 is bypass mode)
c	real		g_scale
c	parameter 	(g_scale = 1.)	!for test use to change gain factors

c	real		gmass		! venus G mass
c	parameter       (gmass=3.2485876561687*10**14)

c	real		qfd
c	parameter 	(qfd=2550.)		!Doppler quantization freq.

c	real		t_85deg
c	parameter 	(t_85deg = -1152.154)	!time passing 85 deg latitude

c	real		ang_order
c	parameter 	(ang_order=6)	!Order of angle for App range poly

c	real		elev_order
c	parameter 	(elev_order=5)	!Order of elevation for App range poly

c	real		rsc_order
c	parameter 	(rsc_order=4)	!Order of Sensor  for App range poly

c	real		alfa_order
c	parameter 	(alfa_order=3)	!Order of alpha for delta App poly

c	real		hgt_order
c	parameter 	(hgt_order=3)	!Order of height for delta App poly

c	real		ksp
c	parameter 	(Ksp=.145* 10. ** 23)!Sensor-Processor gain factor

c	F-BIDR GENERATION CONSTANT

c	integer		decode_table_size
c	parameter 	(decode_table_size=1690*512/4) ! # of bytes

c	integer		obl_image_size
c	parameter 	(obl_image_size=17000*512) ! # of bytes

c	integer		obl_pp_size
c	parameter 	(obl_pp_size=699*512) ! # of bytes

c	integer		sin_image_size
c	parameter 	(sin_image_size=210000*512) ! # of bytes

c	integer		sin_pp_size
c	parameter 	(sin_pp_size=15425*512) ! # of bytes

c	integer		pm_size
c	parameter 	(pm_size=20472)

c	integer		max_o_size
c	parameter 	(max_o_size=800*400*2) ! 4* s_image size in NX

c	integer		max_2bit_buff
c	parameter 	(max_2bit_buff=50000*4)

c	integer		max_2bit_file
c	parameter 	(max_2bit_file=409107) ! # of block

c	integer		max_r_size
c	parameter 	(max_r_size=(900*285+7)/8) ! # of words

c	integer		max_block
c	parameter 	(max_block=124) ! 124

c	integer		pr_rec_size
c	parameter 	(pr_rec_size=250*4) ! 124

c	integer		npara
c	parameter 	(npara=63)

c	integer		sig_size
c	parameter 	(sig_size=44)

!	MAX_LK = 16			!Max. # of look in Multi-look MEM
!	MIN_lk = 0			!Min. # of look in Multi-look MEM -1
C********* DCS constants **************
