c***************************************************************
c	overlay.inc			
c	Comprise: 1).Overlay process variables,
c		  2).Image SFDU header,
c	          3).F-BIDR I/O variables,
c		  4).Load F-BIDR tape variables, 
c		  5).Corr-Per-Orbit file
c		  6).Corr-PP file
c		  7).Flags. 	
c---------------------------------------------------------------
c
c	9/16/92  A. Chu  Added c1_stack_last,c2_stack_1st
c	8/20/92  A. Chu  Added c2 history for cleaning buffer
c	5/5/92   Anhua Chu Initial code.
c***************************************************************

c	-------------
c	OVERLAY PROCESS VARIABLES 
c	-------------
c	Constant

	integer nominal,go_backward,cross_no_overlay,along_no_overlay
	parameter (nominal=1,go_backward=2,
	2	   cross_no_overlay=3,along_no_overlay=4)

c	common block
	integer	c1_offset,c2_offset
	integer c1_len,c2_len
	integer	c1_max_0,c1_min_0	
	integer	c1_offset_1,c1_len_1   
	integer	c1_min_2,c1_max_2,c2_min_2,c2_max_2
	integer	c1_min_1,c1_max_1,c2_min_1,c2_max_1
	integer	c2_max_0,c2_min_0
	integer	c2_offset_1,c2_len_1   
	integer c1_start_out,c2_start_out,c1_size_out,c2_size_out
	integer c1_down_left(8600)	!c1_min SIN;c1_max OBL
	integer c2_min_left(8600)	!c2_min
	integer c2_max_right(8600)	!c2_max
	integer c1_down_right(8600)	!c1_min sin, c1_max obl
	integer c1_edge_left,c2_edge_left,c2_edge_right,c1_edge_right 
	integer left_in_ptr,left_out_ptr,right_in_ptr,right_out_ptr

	common /overlay_c12/ 
	2	c1_max_0,c1_min_0,	
	2	c1_offset_1,c1_len_1,   
	2	c1_offset,c2_offset,c2_offset_1,
	2       c1_len,c2_len,c2_len_1,c2_max_0,c2_min_0,
	2	c1_min_2,c1_max_2,c2_min_2,c2_max_2,
	2	c1_min_1,c1_max_1,c2_min_1,c2_max_1,
	2       c1_down_left,c2_min_left,c2_max_right,c1_down_right,
	2       c1_edge_left,c2_edge_left,c2_edge_right,c1_edge_right,
	2       left_in_ptr,left_out_ptr,right_in_ptr,right_out_ptr,
	2	c1_start_out,c2_start_out,c1_size_out,c2_size_out

c	-------------
c	BIDR I/O VARIABLES
c	-------------

	integer disk_address	!starting at 0
	integer byte_count
	integer first_burst
	integer image_total_size
	integer num_image

	common /io_size/ disk_address,
	2  byte_count,image_total_size,num_image,first_burst

	integer bidr_13,bidr_14
	integer bidr_15,bidr_16
	parameter (bidr_13=13,bidr_14=14,bidr_15=15,bidr_16=16)

	character*(50)	sar_name,bidr_13_name,bidr_14_name,
	2  bidr_15_name,bidr_16_name,bidr_12_name,pp_file_name
	integer sin_im_ch,os_im_ch
	integer sin_pp_ch,os_pp_ch
	integer sar_ch

	common/corr_file/sar_name,bidr_13_name,bidr_14_name,
	2  bidr_15_name,bidr_16_name,bidr_12_name,pp_file_name

	common/io_ch/sin_im_ch,os_im_ch,sin_pp_ch,os_pp_ch,sar_ch

c	-------------
c	LOAD BIDR TAPE VARIABLES
c	-------------
	
	integer rec_count_file_13
	integer rec_count_file_13_blocks

	integer rec_count_file_15
	integer rec_count_file_15_blocks

	common/rec_count/ rec_count_file_15,rec_count_file_15_blocks,
	2	          rec_count_file_13,rec_count_file_13_blocks

c	-------------
c	FLAGS
c	-------------

	logical hop_request
	logical last_filler_flag
		
	common/flag/hop_request,last_filler_flag
c	--------------
c	Per-Orbit data base Include file for the Alliant FX/2800
c	-------------

	integer	 po_orbit_num

	integer	 po_oblique_start_burst
	integer	 po_oblique_end_burst
	integer	 po_sin_start_burst
	integer	 po_sin_end_burst

	integer	 current_burst
	integer  start_burst_num
	integer	 end_burst_num
	integer	 burst_bias
	integer	 projection	!1=sin; 2=oblique-sin

	common /po_a/
	2	current_burst,
	2  	start_burst_num,
	2	end_burst_num,
	2	burst_bias,
	2	projection,
	2	po_oblique_start_burst,
	2	po_oblique_end_burst,
	2	po_sin_start_burst,
	2	po_sin_end_burst
 	
c	-------------
c	TESTING TEMPORARY
c	-------------
 
	character*50 nam1, nam2, nam3,nam4,nam5,nam6
	integer ichan1,ichan2,ichan3,ichan4,ichan5,ichan6
	common/test_name/nam1,nam2,nam3,nam4,nam5,nam6
	common/test_chan/ichan1,ichan2,ichan3,ichan4,ichan5,ichan6
c******************************end of overlay.inc****************

