c************************************************************************
c	Per-Orbit data base Include file for the Alliant FX/2800
c       
c	r000	5/12/92  A.Chu Initial code
c************************************************************************
c	 po.inc
c--------------------------------------------------------------------------
c	SFDU portion:
c		Primary label:

	character*9	po_sfdu_prime_label
	character*3	po_sfdu_prime_type
	character*8	po_sfdu_prime_length

c		Secondary label:

	integer*2	po_sfdu_second_label
	integer*2	po_sfdu_second_length

	integer*2	po_sfdu_orbit_num

c		Data annotation block:

	byte		po_sfdu_data_class
	byte		po_sfdu_data_ann_length

c		Per-Orbit-specific fields:

c	Data portion:

c	General Parameters:

	integer*4	po_data_gen_orbit
	real*8		po_data_gen_orb_start_scet
	real*8		po_data_gen_orb_end_scet
	integer*4	po_data_gen_n_EDR_bursts
	character*9	po_data_gen_product_id
	character*6	po_data_gen_vol_id
	character*19	po_data_gen_local_time
	integer*4	po_data_gen_nlooks
	integer*4	po_data_gen_left_looking
	character*32	po_data_gen_ephemeris_id

c		Orbit Keplerians:

	character*15	po_data_orb_periapsis_sclk
	real*8		po_data_orb_periapsis_j2000
	real*8		po_data_orb_semi_major
	real*8		po_data_orb_eccentricity
	real*8		po_data_orb_inclination
	real*8		po_data_orb_asc_node_lon
	real*8		po_data_orb_arg_periapsis
	real*4		po_data_orb_period
	
c	SCLK-to-SCET Conversion Coefficients:

	character*13	po_data_time_sclk0
	character*12	po_data_time_A1
	character*19	po_data_time_A0
	character*6	po_data_time_dut

c	Projection Burst Counters:

	integer*4	po_data_projc_obl_st
	integer*4	po_data_projc_obl_end
	integer*4	po_data_projc_sin_st
	integer*4	po_data_projc_sin_end

c	Projection Parameters:

	real*4		po_data_projp_sin_ref_lon
	integer*4	po_data_projp_grid_fix_burst
	real*8		po_data_projp_grid_fix_time
	real*4		po_data_projp_xhat_x_vbf
	real*4		po_data_projp_xhat_y_vbf
	real*4		po_data_projp_xhat_z_vbf
	real*4		po_data_projp_yhat_x_vbf
	real*4		po_data_projp_yhat_y_vbf
	real*4		po_data_projp_yhat_z_vbf
	real*4		po_data_projp_zhat_x_vbf
	real*4		po_data_projp_zhat_y_vbf
	real*4		po_data_projp_zhat_z_vbf
	real*4		po_data_projp_obl_ref_lon
	real*4		po_data_projp_neg_obl_ref_lat
	real*8		po_data_projp_obl_st_time
	real*8		po_data_projp_obl_end_time

	common/po_hdr/po_sfdu_prime_label,
	2	po_sfdu_prime_type,
	2	po_data_gen_ephemeris_id,
	2	po_sfdu_orbit_num

c	2	po_sfdu_prime_length,
c	2	po_sfdu_second_label,
c	2	po_sfdu_second_length,

	common/po_data/
c	2	po_sfdu_data_class,
c	2	po_sfdu_data_ann_length,
c	2	po_data_gen_orbit,
c	2	po_data_gen_orb_start_scet,
c	2	po_data_gen_orb_end_scet,
c	2	po_data_gen_n_EDR_bursts,
c	2	po_data_gen_product_id,
c	2	po_data_gen_vol_id,
c	2	po_data_gen_local_time,
c	2	po_data_gen_nlooks,
	2	po_data_gen_left_looking,
c	2	po_data_orb_periapsis_sclk,
c	2	po_data_orb_periapsis_j2000,
c	2	po_data_orb_semi_major,
c	2	po_data_orb_eccentricity,
c	2	po_data_orb_inclination,
c	2	po_data_orb_asc_node_lon,
c	2	po_data_orb_arg_periapsis,
c	2	po_data_orb_period,
c	2	po_data_time_sclk0,
c	2	po_data_time_A1,
c	2	po_data_time_A0,
c	2	po_data_time_dut,
	2	po_data_projc_obl_st,
	2	po_data_projc_obl_end,
	2	po_data_projc_sin_st,
	2	po_data_projc_sin_end,
	2	po_data_projp_sin_ref_lon,
c	2	po_data_projp_grid_fix_burst,
c	2	po_data_projp_grid_fix_time,
	2	po_data_projp_xhat_x_vbf,
	2	po_data_projp_xhat_y_vbf,
	2	po_data_projp_xhat_z_vbf,
	2	po_data_projp_yhat_x_vbf,
	2	po_data_projp_yhat_y_vbf,
	2	po_data_projp_yhat_z_vbf,
	2	po_data_projp_zhat_x_vbf,
	2	po_data_projp_zhat_y_vbf,
	2	po_data_projp_zhat_z_vbf,
	2	po_data_projp_obl_ref_lon,
	2	po_data_projp_neg_obl_ref_lat
c	2	po_data_projp_obl_st_time,
c	2	po_data_projp_obl_end_time
c********************** end of po_a.inc ********************
