#define PP_RECORD_LEN 1315
#define MAXBURST 8600
#define PP_BUFSIZ PP_RECORD_LEN*MAXBURST
/*----------------------------------------------------------------------------*/

	struct pp {

/*	sfdu portion: */

		struct sfdu {

/*		primary label: */

			char	prime_label[12];
			char	prime_length[8];

/*		secondary label: */

			short	second_label;
			short	second_length;

			short	orbit_num;

/*		data annotation block: */

			char	data_class;
			char	data_ann_length; 

/*		processing parameter-specific fields: */

			struct time_tag{
				short 	mod210;
				char 	rim[3];
				char	mod91;
				char	mod10; 
				char    nul1[5];   /* for alignment purpose */
		  	} time_tag;

		} sfdu;

/*	data portion: */

		struct data {

/*		general processing parameters: */

			struct gen {

				long	burst_num;

				char    nul2[4];   /* for alignment purpose */

				double	burst_start;
				double	burst_ref;
				double	burst_center;
				float	echo_delay;

				long	test;
				long	anomaly;
				long	error;
				long	projection;

				char    nul3[4];   /* for alignment purpose */

			} gen;


/*		spacecraft state parameters: */

			struct ssp {
				float	sc_x_j2000;
				float	sc_y_j2000;
				float	sc_z_j2000;

				float	sc_x_vbf;
				float	sc_y_vbf;
				float	sc_z_vbf;

				float	sc_vx_j2000;
				float	sc_vy_j2000;
				float	sc_vz_j2000;

				float	sc_vx_vbf;
				float	sc_vy_vbf;
				float	sc_vz_vbf;

				float	sc_ax_j2000;
				float	sc_ay_j2000;
				float	sc_az_j2000;

				float	sc_ax_vbf;
				float	sc_ay_vbf;
				float	sc_az_vbf;

				float	q1;
				float	q2;
				float	q3;
				float	q4;

				float	delta_q1;
				float	delta_q2;
				float	delta_q3;
				float	delta_q4;

				float	ubor_x_vme;
				float	ubor_y_vme;
				float	ubor_z_vme;

				float	ubor_x_vbf;
				float	ubor_y_vbf;
				float	ubor_z_vbf;

				float	look_ang;
			} ssp;

/*		boresight intercept point [bip] parameters: */

			struct bip {
				float	bip_x_vbf;
				float	bip_y_vbf;
				float	bip_z_vbf;

				float	bip_lon;
				float	bip_lat;
				float	bip_elev;

				float	bip_inc_ang;
				float	bip_app_rg;

				float	bip_fd;
				float	bip_fd_drift;
			} bip;

/*		mid-range point [mrp] parameters: */

			struct mrp {
				float	mrp_incang;
				float	mrp_bs_coef;
				float	mrp_lat;
				float	mrp_lon;

				float	mrp_elev;

    				float	sample1_app_rg;
				float	mrp_app_rg;

				float	mrp_fd;
    				float	mrp_fr;

				float	mrp_x_vme;
				float	mrp_y_vme;
				float	mrp_z_vme;
			} mrp;

/*		radiometric compensation parameters: */

			struct brcomp {
				float	sensor_proc_gain;
				long	rg_f;

				long	az_f;
				long	n_pulses;

				float	t_grg_cf;
				float	fd_at_cf;
				float	baq_sf;

				float	trans_pow_cf;
				float	rec_gain_cf;
				float	ns_redund_gain_cf;
			} brcomp;

/*		dcs control parameters: */

			struct dcs {
				long	rg_ref_ndx;
				float	abs_rgwalk;
				float	rgwalk_0;
				float	rgwalk_1;
			} dcs;

/*		sensor states & temperatures: */

			struct sensor {
				long	trans_state;
				long	receive_state;
				long	onu_state;
				float	trans_a_temp;
				float	receive_a_temp;
				float	onu_a_temp;
				float	trans_b_temp;
				float	receive_b_temp;
				float	onu_b_temp;
				float	cable_1_temp;
				float	cable_2_temp;
				float	cable_3_temp;
				float	cable_4_temp;
				float	cable_5_temp;
			} sensor;

/*		radiometric compensation parameters: */

			struct rcomp {
				float	rel_rg[ 3 ][ 3 ];
				float	rel_fd[ 3 ][ 3 ];
				float	c1[ 3 ] [ 3 ];
				float	c2[ 3 ] [ 3 ];
				float	sc_d[ 3 ] [ 3 ];
				float	bor_elang[ 3 ] [ 3 ];
				float	bor_hang[ 3 ] [ 3 ];
				float	ant_gain[ 3 ] [ 3 ];
				float	sigma22;
				float	rcomp[ 3 ] [ 3 ];
				float	c_in_fd[ 3 ] [ 3 ];
			} rcomp;

/*		geometric correction parameters: */

			struct geo {
				long c1[ 3 ] [ 3 ];
				long c2[ 3 ] [ 3 ];
				float	elev[ 3 ] [ 3 ];
				float	rel_rg[ 3 ] [ 3 ];
				float	rel_fd[ 3 ] [ 3 ];
				float	c_in_c2[ 3 ] [ 3 ];
				float	c_in_c1[ 3 ] [ 3 ];
			} geo;

/*		framelet parameters: */

			struct framelet {
				float	rg[ 2 ][ 2 ];
				float	fd[ 2 ][ 2 ];
				long	c1[ 2 ][ 2 ];
				long	c2[ 2 ][ 2 ];
			} framelet;

/*		burst size parameters: */

			struct bs {
				float	prf;
				long	npulses;
				long	nsamples;

				float	pbw;
				float	prs;
			} bs;

/*		process monitor parameters: */

			struct pm {
				long	min_looks;

				char	thresh[ 24 ];
			} pm;

/*		frame size parameters: */

			struct frame {
				long	c1_fdmax;
				long	c2_min;
				long	c2_start;
				long	c1_fdmin;
				long	c2_max;
				long	c2_end;

				long	c1_offset;
				long	c2_offset;
				long	set_no;
				long	r_offset;
			} frame;

/*		unused chars: */

			char 	fill [132];

		} data;

	};
/*----------------------------------------------------------------------------*/
	union upp {
		struct pp pp;
		struct {
		   char str1[35];
		   char nul1[5];
		   char str2[4];
		   char nul2[4];
		   char str3[44];
		   char nul3[4];
		   char str4[1232];
		} ppstr;
	};
