/*	this gives the struct of an f-bidr processed
	radiometer data record data block.

	/clw/04-09-92/ modified from vax rad.inc

	Lawrence Chen 2/1/94 Modified

*/
#define MAXBURST 8600
#define RAD_RECORD_LEN 128
#define RAD_BUFSIZ MAXBURST*RAD_RECORD_LEN

/*	struct rad {   L. Chen 2/1/94  
	Don't use same names in one structure
*/

	struct rad_tag {

		struct sfdu {
			char	prime_label[12];
			char	prime_length[8];
			short 	second_label;
			short 	second_length;
			short	orbit_num;
			char	data_class;
			char	data_ann_length;
			double	mid_rad_scet;

			union u_tag{  
				struct rad {
					float	rad_lat;
					float	rad_lon;
					float	rad_inc_ang;
					float	rad_elev;
				} rad;
				struct q {
					float	q1;
					float	q2;
					float	q3;
					float	q4;
				} q;
			} u;

			float	sc_x_vbf;
			float	sc_y_vbf;
			float	sc_z_vbf;

			float	rcvr_gain_factor;
			float	rcvr_temp;

			float	coef_a;
			float	coef_b;
			float	coef_c;

/*	tsi = coef_a * s*s + coef_b * s + coef_c */ 

			float	sensor_in_noise_temp;


/*	antenna cable segment temperatures and losses 1 through 5: */

			float	cable1_temp;
			float	cable2_temp;
			float	cable3_temp;
			float	cable4_temp;
			float	cable5_temp;

/*	table-derived factors for adjusting observed antenna temp: */

			float	t_emission;
			float	kappa;
		} sfdu;

		struct data {

			short	raw_value;
			short	raw_calib_value;
			float	t_antenna_obs;
			float	surface_bright_temp;
		} data;
};
union ura {
	struct rad_tag ra;
	struct rastr{
		char str1[28];
		char nul1[4];
		char str2[100];
		char nul2[4];
		char str[136];
	} rastr; 
};
